#!/bin/csh -f

while (1)
        echo -n "Where is DocumentRoot of WIZ? -> "
        set docroot = $<
	if ("$docroot" == "") then
		echo "no input."
	else
		if (-d $docroot) then
			echo "OK."
			break
		else
			echo "Directory not found."
		endif
	endif
end
while (1)
        echo -n "Name httpd username.(default:nobody) -> "
        set username = $<
        if ("$username" == "") then
                set username = "nobody"
                break
        else
                echo "OK."
                break
        endif
end

set osname = `uname`
#tar zxPf wiz.tar.gz -C $docroot
mv task $docroot
switch ($osname)
	case Linux:
		chown -R $username.$username $docroot/
                chmod -R 550 $docroot/task
		breaksw
	default:
		echo "$osname is not supported."
		echo "Please change owner and group manually."
		exit 1
endsw
echo "**************************************************************"
echo "*** TaskManagement on WIZ has been successfully installed. ***"
echo "***                                                        ***"
echo "***1999-2000 (C)Top Management Service,inc.                ***"
echo "***                            All Rights Reserved.        ***"
echo "***                            info@tms-px.co.jp           ***"
echo "***2002-2003 (C)System Consultants Co.,Ltd.                ***"
echo "***                            All Rights Reserved.        ***"
echo "**************************************************************"
exit 0
