#!/bin/csh -f

while (1)
        echo -n "Where is DocumentRoot of Apache? -> "
        set docroot = $<
	if ("$docroot" == "") then
		echo "no input."
	else
		if (-d $docroot) then
			echo "OK."
			break
		else
			echo "Directory not found."
		endif
	endif
end
while (1)
        echo -n "What is your server name?(default:localhost) -> "
        set url = $<
        if ("$url" == "") then
                set url = "localhost"
                break
        else
                echo "OK."
                break
        endif
end
while (1)
        echo -n "Name httpd username.(default:daemon) -> "
        set username = $<
        if ("$username" == "") then
                set username = "daemon"
                break
        else
                echo "OK."
                break
        endif
end
while (1)
        echo -n "Name database username.(default:daemon) -> "
        set dbusername = $<
        if ("$dbusername" == "") then
                set dbusername = "daemon"
                break
        else
                echo "OK."
                break
        endif
end


set osname = `uname`
cp -Rp ./wiz/ $docroot
switch ($osname)
	case Linux:
		chown -R $username.$username $docroot/wiz/
                chmod -R 550 $docroot/wiz/
                chmod -R 770 $docroot/wiz/files/
		sed "s{daemon{$dbusername{;s{/usr/local/apache2/htdocs{$docroot{;s{http://localhost{http://$url{" $docroot/wiz/gw.php.dist > $docroot/wiz/gw.php
		chown -R $username.$username $docroot/wiz/gw.php
		chmod 660 $docroot/wiz/gw.php
                chmod -R 770 $docroot/wiz/bbs/admin/settings/
		breaksw
	default:
		echo "$osname is not supported."
		echo "Please change owner and group manually."
		exit 1
endsw
echo "******************************************************"
echo "***   WIZ has been successfully installed.         ***"
echo "***                                                ***"
echo "***1999-2000 (C)Top Management Service,inc.        ***"
echo "***                            All Rights Reserved.***"
echo "***                            info@tms-px.co.jp   ***"
echo "***2002-2003 (C)System Consultants Co.,Ltd.        ***"
echo "***                            All Rights Reserved.***"
echo "******************************************************"
exit 0
