#!/bin/csh -f

if (! $?PGDATA) then
	echo "Envirnment Variable PGDATA is not set."
	exit 1
endif
if (! -o $PGDATA) then
	echo "You are not PostgreSQL administrator."
	exit 1
endif
if (! -e /tmp/.s.PGSQL.5432) then
	echo "postmaster is not up."
	exit 1
endif
while (1)
        echo -n "Name your database.(default:masters) -> "
        set dbname = $<
        if ("$dbname" == "") then
                set dbname = "masters"
                break
        else
		if (-d $PGDATA/base/$dbname) then
			echo "Database already exist"
		else
               		echo "OK."
                	break
		endif
        endif
end
while (1)
        echo -n "Name database username.(default:daemon) -> "
        set username = $<
        if ("$username" == "") then
                set username = "daemon"
                break
        else
       		echo "OK."
               	break
        endif
end
set pgadm = `whoami`
set osname = `uname`
set curdir = `pwd`
switch ($osname)
	case Linux:
                createuser -D -A $username
		echo OK!
	break

