<?php
//
// Copyright (C) 2001-2002 System Consultants Co.,Ltd. All Rights Reserved.
//
// $Id: table_definitionowner.php 920 2002-06-07 10:35:21Z hiboki $
//

/**
 * ơ֥ڤ륯饹
 *
 * @author hiroki KAWAMURA <hiroki@syscon.co.jp>
 * @author yuji TAKAHASHI <yu-ji@syscon.co.jp>
 */



include_once($_ROOT_DIR_ . "admin/csvimport/class/table_definition.php");
include_once($_ROOT_DIR_ . "admin/csvimport/class/myfile.php");

include_once($_ROOT_DIR_ . "include/resultToStringFunction.php");


class TableDefinitionOwner
{
	var $tableName;					// ơ֥̾
	var $tableDefinition;			// ơ֥
	var $tableDefinitionFileName;	// ơ֥եΥѥ
	var $tableDefinitionFileObj;	// ơ֥եΥե륪֥
	var $errorInfoOwner;			// 顼󥯥饹
	var $delimiter;					// ǥߥ

	var $conn;						// DBͥ
	var $dbSqlObj;					// SQL֥
	var $dbExecObj;					// Exec֥


	// 󥹥ȥ饯
	function TableDefinitionOwner()
	{
		$this->errorInfoOwner = new ErrorInfoOwner();
		$this->tableDefinitionFileObj = new MyFile();
	}


	// tableNameμ
	function getTableName()
	{
		return $this->tableName;
	}

	// tableName
	function setTableName($tableName)
	{
		$this->tableName = $tableName;
	}

	// tableDefinitionμ
	function getTableDefinition()
	{
		return $this->tableDefinition;
	}

	// tableDefinition
	function setTableDefinition($tableDefinition)
	{
		$this->tableDefinition = $tableDefinition;
	}

	// tableDefinitionFileNameμ
	function getTableDefinitionFileName()
	{
		return $this->tableDefinitionFileName;
	}

	// tableDefinitionFileName
	function setTableDefinitionFileName($tableDefinitionFileName)
	{
		$this->tableDefinitionFileName = $tableDefinitionFileName;
	}

	// tableDefinitionFileObjμ
	function getTableDefinitionFileObj()
	{
		return $this->tableDefinitionFileObj;
	}

	// tableDefinitionFileObj
	function setTableDefinitionFileObj($tableDefinitionFileObj)
	{
		$this->tableDefinitionFileObj = $tableDefinitionFileObj;
	}

	// errorInfoOwnerμ
	function getErrorInfoOwner()
	{
		return $this->errorInfo;
	}

	// errorInfoOwner
	function setErrorInfoOwner($errorInfoOwner)
	{
		$this->errorInfoOwner = $errorInfoOwner;
	}

	// delimiterμ
	function getDelimiter()
	{
		// ֶڤǥեȤˤ
		if ($this->delimiter == "")
		{
			$this->delimiter = "\t";
		}

		return $this->delimiter;
	}

	// delimiter
	function setDelimiter($delimiter)
	{
		$this->delimiter = $delimiter;
	}

	// connμ
	function getConn()
	{
		return $this->conn;
	}

	// conn
	function setConn($conn)
	{
		$this->conn = $conn;
	}

	// dbSqlObjμ
	function getDbSqlObj()
	{
		return $this->dbSqlObj;
	}

	// dbSqlObj
	function setDbSqlObj($dbSqlObj)
	{
		$this->dbSqlObj = $dbSqlObj;
	}

	// dbExecObjμ
	function getDbExecObj()
	{
		return $this->dbExecObj;
	}

	// dbExecObj
	function setDbExecObj($dbExecObj)
	{
		$this->dbExecObj = $dbExecObj;
	}


	// ơ֥ե򳫤
	function openTableDefinitionFile()
	{
		if (!$this->tableDefinitionFileObj->open($this->getTableDefinitionFileName()))
		{
			echo $this->tableDefinitionFileObj->errorInfoOwner->outputAllErrorInfo();

			return False;
		}

		return True;
	}


	// ơ֥եĤ
	function closeTableDefinitionFile()
	{
		if (!$this->tableDefinitionFileObj->close())
		{
			echo $this->tableDefinitionFileObj->errorInfoOwner->outputAllErrorInfo();

			return False;
		}

		return True;
	}


	// ơ֥եβ
	function analyze()
	{
		if (!$this->openTableDefinitionFile())
		{
			exit;
		}

		$lineCount = 1;
		$isError = False;

		$delimiter = $this->getDelimiter();

		while ($csvArray = fgetcsv($this->tableDefinitionFileObj->getFilePointer(), 99999, $delimiter))
		{
			// Ƭ // ԤϥȤȤ̵뤹
			// Ԥ̵뤹
			if (!ereg("^\/\/", $csvArray[0]) && !ereg("^$", $csvArray[0]))
			{
				$csvDataTemp = array();
				for ($i = 0; $i < count($csvArray); $i++)
				{
					$csvDataTemp[] = $csvArray[$i];
				}

				if (!$this->checkCorrect($csvDataTemp, $lineCount))
				{
					$isError = True;
				}

				if (!$isError)
				{
					$this->add($csvDataTemp);
				}
			}

			$lineCount++;
		}

		if (!$this->closeTableDefinitionFile())
		{
			exit;
		}

		if ($isError)
		{
			$this->clear();

			return False;
		}

		return True;
	}


	// ɲ
	function add($csvDataArray)
	{
		$tableDefinition = new TableDefinition();
		$tableDefinition->setColumnName($csvDataArray[0]);
		$tableDefinition->setType($csvDataArray[1]);
		$tableDefinition->setLength($csvDataArray[2]);
		$tableDefinition->setNotNull($csvDataArray[3]);
		$tableDefinition->setDefaultValue($csvDataArray[4]);
		$tableDefinition->setRelationTableName($csvDataArray[5]);
		$tableDefinition->setRelationColumnCode($csvDataArray[6]);
		$tableDefinition->setRelationColumnName($csvDataArray[7]);

		$tableDefinitionTemp = $this->getTableDefinition();
		$tableDefinitionTemp[] = $tableDefinition;

		$this->setTableDefinition($tableDefinitionTemp);
	}


	// Υꥢ
	function clear()
	{
		$this->setTableDefinition("");
	}


	// ǡå
	function checkCorrect(&$csvDataArray, $lineCount)
	{
		// ¸ߤʤä""
		for ($i = 0; $i < 8; $i++)
		{
			if (!isset($csvDataArray[$i]))
			{
				$csvDataArray[$i] = "";
			}
		}

		$isError = False;

		// Ƥ񤭴礬١Ȥ
		$columnName = &$csvDataArray[0];
		$type = &$csvDataArray[1];
		$length = &$csvDataArray[2];
		$notNull = &$csvDataArray[3];
		$defaultValue = &$csvDataArray[4];
		$relationTableName = &$csvDataArray[5];
		$relationColumnCode = &$csvDataArray[6];
		$relationColumnName = &$csvDataArray[7];

		$this->convert2Eucjp($columnName);
		$this->convert2Eucjp($type);
		$this->convert2Eucjp($length);
		$this->convert2Eucjp($notNull);
		$this->convert2Eucjp($defaultValue);
		$this->convert2Eucjp($relationTableName);
		$this->convert2Eucjp($relationColumnCode);
		$this->convert2Eucjp($relationColumnName);

		$this->convertKana($columnName);
		$this->convertKana($type);
		$this->convertKana($length);
		$this->convertKana($notNull);
		$this->convertKana($defaultValue);
		$this->convertKana($relationTableName);
		$this->convertKana($relationColumnCode);
		$this->convertKana($relationColumnName);

		if ($columnName == "")
		{
			$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤΥ̾Ǥ");
			$isError = True;
		}
		else if (!ereg("^[a-zA-Z\-_].[0-9a-zA-Z\-_]*$", $columnName))
		{
			$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤΥ̾Ǥ");
			$isError = True;
		}

		if ($type == "")
		{
			$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤη̾Ǥ");
			$isError = True;
		}
		else if (!ereg("^[a-zA-Z].[0-9a-zA-Z \-_]*$", $type))
		{
			$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤη̾Ǥ");
			$isError = True;
		}

		if (ereg("[^0-9]", $length))
		{
			$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤĹǤ");
			$isError = True;
		}

		if (eregi("^t$", $notNull) || eregi("^not null$", $notNull))
		{
			$notNull = "t";
		}
		else if (eregi("^f$", $notNull) || $notNull == "")
		{
			$notNull = "f";
		}
		else
		{
			$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤNotNullǤ");
			$isError = True;
		}

		if ($defaultValue != "")
		{
			if (eregi("^integer$", $type) || eregi("^smallint$", $type))
			{
				if (ereg("[^0-9]", $defaultValue))
				{
					$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤΥǥեͤϿͤΤߤǤ");
					$isError = True;
				}
			}

			if (ereg("^[0-9]+$", $length))
			{
				if ($length < strlen($defaultValue))
				{
					$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤΥǥեͤĹǤ");
					$isError = True;
				}
			}

			if (eregi("bool", $type))
			{
				if (!eregi("^[t|f]$", $defaultValue))
				{
					$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤΥǥեͤbooleanǤ");
					$isError = True;
				}
			}
		}

		if ($relationTableName != "")
		{
			if (!$this->isTableExist($relationTableName, $lineCount))
			{
				$isError = True;
			}

			if ($relationColumnCode == "")
			{
				$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤλ襫ॳ̾Ǥ");
				$isError = True;
			}

			if ($relationColumnName == "")
			{
				$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤλ襫̾Ǥ");
				$isError = True;
			}
		}

		if ($isError)
		{
			return False;
		}

		return True;
	}


	// ơ֥¸ߥå
	function isTableExist($relationTableName, $lineCount)
	{
		$sql = $this->dbSqlObj->selectTableList($relationTableName);
		$result = $this->dbExecObj->exeSql($this->conn, $sql);

		if (!$result)
		{
			$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤλơ֥" . $relationTableName . "¸ߥåκݡǡ١顼ȯޤ¹ԤSQL:" . $sql);
			return False;
		}

		$subStrings = resultToString($result, $this->dbSqlObj->getTableListColumnName(), $this->dbExecObj);

		if (!ereg("'" . $relationTableName . "'", $subStrings))
		{
			$this->errorInfoOwner->add($this->getTableName() . "ơ֥ե" . $lineCount . "ܤλơ֥" . $relationTableName . "¸ߤޤ");
			return False;

		}
		return True;
	}


	// EUC-JP˥С
	function convert2Eucjp(&$str)
	{
		if (mb_detect_encoding($str, "auto") != "EUC-JP")
		{
			$str = mb_convert_encoding($str, "EUC-JP", "auto");
		}
	}


	// Ⱦѥʢѥ
	function convertKana(&$str)
	{
		$str = mb_convert_kana($str);
	}

}
?>