<?php
/**
 * SQL饹 PostgreSQL
 **/

include_once($_ROOT_DIR_ . "class/DBSqlMysql.php");

class DBSqlMysqlForTask extends DBSqlMysql
{
  function DBSqlMysqlForTask()
  {
  }

  function selectMonthScheduleTaskList($emp_cd, $startYear, $startMonth, $startDay, $endYear, $endMonth, $endDay)
  {
    $strsql = <<<EOF
      SELECT task.category_cd,
        task.sub_category_cd,
        task.group_cd,
        task.task_cd,
        task.title,
        task.description,
        year(task.plan_end_date) AS peyear, 
        month(task.plan_end_date) AS pemonth, 
        dayofmonth(task.plan_end_date) AS peday, 
        lpad(EXTRACT(HOUR FROM concat(task.plan_end_date,task.plan_end_time)), 2, '0') AS pehour, 
        lpad(EXTRACT(MINUTE FROM concat(task.plan_end_date,task.plan_end_time)), 2, '0') AS peminutes, 
        task.owner_emp_cd,
        task.regist_emp_cd,
        task.status,
        task.schedule_flg
      FROM task
      WHERE
            task.owner_emp_cd = '$emp_cd'
        AND task.plan_end_date >= '$startYear-$startMonth-$startDay'
        AND task.plan_end_date <= '$endYear-$endMonth-$endDay'
        AND task.schedule_flg = 't'
      ORDER BY
        plan_end_date, plan_end_time;
EOF;
//    echo $strsql;
    return $strsql; 
  }
  function countCategoryWithGroupCd($group_cd)
  {
    $strsql = <<<EOF
      SELECT 
        COUNT(1) AS num_cat
      FROM 
        task_category
      WHERE
        group_cd = '$group_cd';
EOF;
//    echo $strsql;    
    return $strsql;

  }
}

?>
