<?php
//
// Copyright (C) 2001-2003 System Consultants Co.,Ltd. All Rights Reserved.
//
// $Id: DBSqlPgsql.php 1330 2005-09-29 05:07:05Z root $
//

/**
 * SQL饹Pgsqlѥ饹
 *
 * @author hiroki KAWAMURA <hiroki@syscon.co.jp>
 * @author yuji TAKAHASHI <yu-ji@syscon.co.jp>
 * @author hideo OHSAWA <ohsawa@syscon.co.jp>
 * @author hideki HARANAKA <hideki-h@syscon.co.jp>
 */



// 
include ($_ROOT_DIR_ . "/include/constant.conf");

include_once($_ROOT_DIR_ . "/class/DBSql.php");

//PostgreSQLѥ饹->DBSql
class DBSqlPgsql extends DBSql {
	// 󥹥ȥ饯
	function DBSqlPgsql(){
	}

    //ۡڡɽǼĥꥹȤ
    function selectForumList($BBS_FORUM_NAME_){
      if((isset($BBS_FORUM_NAME_) && $BBS_FORUM_NAME_ != ""))
      {
        $strBBS_Sql = " and name = '" . $BBS_FORUM_NAME_ . "';";
      }
      else
      {
        $strBBS_Sql = ";";
      }

      $sqlstr =<<< EOF
        select 
          'select id, datestamp, subject, thread as tid, ''' || name || '''  as forum_name, ''' || id || '''  as forum_id from ' || table_name as strSelectTable, ' UNION ' as strUNION 
        from 
          forums 
        where 
          folder = '0'
          $strBBS_Sql;

EOF;
      return $sqlstr;
    }
  
	function setDateStyleToIso(){
	//record.php 144
		return "SET datestyle TO 'ISO';";
	}

	function selectRecordAllEmployeeNameWithEmpCdCatCdSubCatCd($division, $emp_cd, $cat_cd, $subcat_cd, $nowPage, $show_no, $A_term,$A_PHP_AUTH_USER,$isAdmin,$myGroup,$orderColumn,$sortForRev)
	{
	//record.php 1504
		$sqlstr = "SELECT DISTINCT record.up_time, record.filename, record.cat_cd, record.subcat_cd, record.remark, record.emp_cd, record.filesize ,employee.last_name_j || first_name_j AS name,";
		$sqlstr .= "category.cat_name,subcategory.subcat_name,employee.division ";
		if(!$isAdmin) {
			$sqlstr .= ", record_access.readable_status FROM record, employee, ";
//2004.08 ԻȽɲ
			$sqlstr .= " (SELECT * FROM category WHERE enable = 't') as category, ";
			$sqlstr .= " (SELECT * FROM subcategory WHERE enable = 't') as subcategory, record_access ";
		} else {
			$sqlstr .= "FROM record, employee, ";
//2004.08  ԻȽɲ
			$sqlstr .= "  (SELECT * FROM category WHERE enable = 't') AS category,";
			$sqlstr .= "  (SELECT * FROM subcategory WHERE enable = 't') AS subcategory ";
		}
		$sqlstr .= "WHERE record.cat_cd = category.cat_cd ";
		$sqlstr .= "AND record.subcat_cd = subcategory.subcat_cd ";
		$sqlstr .= "AND employee.emp_cd = record.emp_cd ";

		if ($emp_cd != "all" && $emp_cd != "")
		{
			$sqlstr .= "AND record.emp_cd = '$emp_cd' ";
		}
		else if ($division != "all" && $division != "")
		{
			$sqlstr .= "AND employee.division = '$division' ";
		}

		if ($cat_cd != "all" && $cat_cd != "")
		{
			$sqlstr .= "AND record.cat_cd = '$cat_cd' ";
		}

		if ($subcat_cd != "all" && $subcat_cd != "")
		{
			$sqlstr .= "AND record.subcat_cd = '$subcat_cd' ";
		}

//ɵ ä
		if (!$isAdmin){
			$sqlstr.= "AND record.up_time = record_access.up_time ";
			$sqlstr.= "AND ( ";
			$sqlstr.= "record_access.group_cd = 9999 ";
			$sqlstr.= "OR record_access.readable_status <> 'F' ";
			$sqlstr.= "OR record.emp_cd = '$A_PHP_AUTH_USER' ";
			if($myGroup != "('')"){
			  $sqlstr.= "OR record_access.group_cd IN $myGroup ";
			}
			$sqlstr.= ") ";
		}
			
		$sqlstr .= "AND record.up_time + '$A_term months' >= now() ";

		switch($sortForRev) {
			case "KOUJUN":
				$sortForRev = " DESC";
				break;
			case "SHOUJUN":
				$sortForRev = "";
			default:
				break;
		}
		if ($orderColumn == "name") {
			$orderColumn = "employee.last_name_j || employee.first_name_j";
		}

		$sqlstr .= "ORDER BY $orderColumn $sortForRev ";

		$offSET = ($nowPage - 1) * $show_no;

		$sqlstr .= "LIMIT $show_no OFFSET " . $offSET . ";";
		return $sqlstr;
	}


	function selectRecordAllEmployeeNameWithEmpCdCatCdSubCatCdDivcd($division, $emp_cd, $cat_cd, $subcat_cd, $nowPage, $show_no, $A_term,$A_PHP_AUTH_USER,$isAdmin,$myGroup,$orderColumn,$sortForRev,$Div_cd)
	{
	//record.php 1504
		$sqlstr = "SELECT DISTINCT record.up_time, record.filename, record.cat_cd, record.subcat_cd, record.remark, record.emp_cd, record.filesize ,employee.last_name_j || first_name_j AS name,";
		$sqlstr .= "category.cat_name,subcategory.subcat_name,employee.division ";
		if(!$isAdmin) {
			$sqlstr .= ", record_access.readable_status FROM record, employee, ";
//2004.08 ˤɽɲ  ԻȽɲ
			$sqlstr .= " (SELECT * FROM category WHERE enable = 't') as category, ";
			$sqlstr .= " (SELECT * FROM subcategory WHERE enable = 't') as subcategory, record_access, ";
			$sqlstr .= "(SELECT subcategory.subcat_cd ";
			$sqlstr .= " FROM subcategory,group_access ";
			$sqlstr .= " WHERE subcategory.subcat_cd = group_access.subcat_cd ";
			$sqlstr .= "   AND group_access.group_cd = '$Div_cd' ";
			$sqlstr .= "   AND enable = 't' ";
			$sqlstr .= "UNION ";
			$sqlstr .= "SELECT * FROM ";
			$sqlstr .= " (SELECT subcategory.subcat_cd ";
			$sqlstr .= "   FROM subcategory ";
			$sqlstr .= "   WHERE enable = 't' ";
			$sqlstr .= "  EXCEPT ";
			$sqlstr .= "  SELECT subcategory.subcat_cd ";
			$sqlstr .= "   FROM  subcategory,group_access ";
			$sqlstr .= "   WHERE subcategory.subcat_cd = group_access.subcat_cd ";
			$sqlstr .= "   AND enable = 't') AS free) AS subcd_acc ";
		} else {
			$sqlstr .= "FROM record, employee, ";
//2004.08  ԻȽɲ
			$sqlstr .= "  (SELECT * FROM category WHERE enable = 't') AS category,";
			$sqlstr .= "  (SELECT * FROM subcategory WHERE enable = 't') AS subcategory ";
		}
		$sqlstr .= "WHERE record.cat_cd = category.cat_cd ";
		$sqlstr .= "AND record.subcat_cd = subcategory.subcat_cd ";
		$sqlstr .= "AND employee.emp_cd = record.emp_cd ";

		if ($emp_cd != "all" && $emp_cd != "")
		{
			$sqlstr .= "AND record.emp_cd = '$emp_cd' ";
		}
		else if ($division != "all" && $division != "")
		{
			$sqlstr .= "AND employee.division = '$division' ";
		}

		if ($cat_cd != "all" && $cat_cd != "")
		{
			$sqlstr .= "AND record.cat_cd = '$cat_cd' ";
		}

		if ($subcat_cd != "all" && $subcat_cd != "")
		{
			$sqlstr .= "AND record.subcat_cd = '$subcat_cd' ";
		}

//ɵ ä
		if (!$isAdmin){
			$sqlstr.= "AND record.up_time = record_access.up_time ";
			$sqlstr.= "AND ( ";
			$sqlstr.= "record_access.group_cd = 9999 ";
			$sqlstr.= "OR record_access.readable_status <> 'F' ";
			$sqlstr.= "OR record.emp_cd = '$A_PHP_AUTH_USER' ";
			if($myGroup != "('')"){
			  $sqlstr.= "OR record_access.group_cd IN $myGroup ";
			}
			$sqlstr.= ") ";
//2004.08ˤɽɲ
			$sqlstr.= "AND subcategory.subcat_cd = subcd_acc.subcat_cd ";
		}
			
		$sqlstr .= "AND record.up_time + '$A_term months' >= now() ";

		switch($sortForRev) {
			case "KOUJUN":
				$sortForRev = " DESC";
				break;
			case "SHOUJUN":
				$sortForRev = "";
			default:
				break;
		}
		if ($orderColumn == "name") {
			$orderColumn = "employee.last_name_j || employee.first_name_j";
		}

		$sqlstr .= "ORDER BY $orderColumn $sortForRev ";

		$offSET = ($nowPage - 1) * $show_no;

		$sqlstr .= "LIMIT $show_no OFFSET " . $offSET . ";";
		return $sqlstr;
	}

    //20040506 haranakaɲ
	function insertRecord($userfile_name2,$cat_cd,$subcat_cd,$comment,$A_PHP_AUTH_USER,$A_userfile_size,$up_time){
	//record.php 819
		$this->argumentCheck("userfile_name2", $userfile_name2);
		$this->argumentCheck("cat_cd", $cat_cd);
		$this->argumentCheck("subcat_cd", $subcat_cd);
		$this->argumentCheck("PHP_AUTH_USER", $_SERVER["PHP_AUTH_USER"]);
		$this->argumentCheck("userfile_size", $A_userfile_size);
		$this->argumentCheck("up_time", $up_time);
		return "INSERT INTO record VALUES('$userfile_name2','$cat_cd','$subcat_cd','$comment','$A_PHP_AUTH_USER',to_timestamp('$up_time','YYYY-MM-DD HH24:MI:SS.US'),'$A_userfile_size');";
	}    

	function insertRecord_Access($up_time,$group_cd,$publicFlag) {
    //pg/myʬ
		$this->argumentCheck("up_time",$up_time);
		$this->argumentCheck("group_cd",$group_cd);
		//$strSql = "INSERT INTO record_access values(to_timestamp('$up_time','YYYY-MM-DD HH24:MI:SS.US'),$group_cd,'$publicFlag');";
		$strSql = "INSERT INTO record_access values('$up_time',$group_cd,'$publicFlag');";
		return $strSql;
	}

	function selectEmployeeNameBirthdayWithToday(){
	//index.php 283
		$sqlstr = "SELECT last_name_j,birthday ";
		$sqlstr .=  "FROM employee ";
		$sqlstr .= "WHERE date_part('month',birthday)::text = date_part('month',current_date)::text ";
		$sqlstr .= "AND retire_date is NULL ";
		$sqlstr .= "AND date_part('day',birthday)::text = date_part('day',current_date)::text;";
		return $sqlstr;
	}
	function selectCompanyCDateWithToday(){
	//index.php 294
		$sqlstr = "SELECT c_date FROM company ";
		$sqlstr .= "WHERE date_part('month',c_date)::text = date_part('month',current_date)::text ";
		$sqlstr .= "AND date_part('day',c_date)::text = date_part('day',current_date)::text;";
		return $sqlstr;
	}

	// Employeeơ֥뤫ܸ̾emp_cdˤäƼ
	function selectEmployeeNameWithEmpCd($emp_cd){
		$this->argumentCheck("emp_cd", $emp_cd);
		return "SELECT last_name_j || first_name_j AS name FROM employee WHERE emp_cd = '$emp_cd';";
	}

	// Employeeơ֥뤫emp_name(last_name_j||first_name_j)򥭡ˤemp_cd
	// PgѤMyѤʬޤ
	function selectEmpCdWithEmpName($emp_name, $division){
		$strSql = "SELECT emp_cd ";
		$strSql .= "FROM employee ";
		$strSql .= "WHERE last_name_j || first_name_j = '$emp_name';";
		return $strSql;
	}

	// Employeeơ֥뤫EmpCdܸ̾
	function selectEmployeeEmpCdNameWithRetireDateNullUnifyFalse(){
		return "SELECT emp_cd,last_name_j || first_name_j AS name FROM employee WHERE retire_date is NULL AND unify = 'f' ORDER BY sort_no;";
	}

	function selectEmployeeAdministratorsEmpCdNameWithNotAdmin($adminStr) {
	//admin.php 94
		$this->argumentCheck("adminStr",$adminStr);
		$strSql = "SELECT emp_cd ,last_name_j || first_name_j as name ";
		$strSql.= "FROM employee ";
		$strSql.= "WHERE emp_cd not in $adminStr and retire_date is null ";
		$strSql.= "order by sort_no;";
		return $strSql;
	}

	function selectEmployeeAdministratorsEmpCdNameWithAdmin() {
	//admin.php 124
		$strSql = "SELECT administrators.emp_cd ,employee.last_name_j||employee.first_name_j AS name ";
		$strSql.= "FROM administrators, employee ";
		$strSql.= "WHERE administrators.emp_cd=employee.emp_cd ";
		$strSql.= "ORDER BY employee.sort_no;";
		return $strSql;
	}

    /**
     * ʬβİ
     * ɽե饰ͭʲĤΤ
     * @author hideki-h
     * @since 1.4 - 2005/09/29
     */
	function selectAllNotice($A_PHP_AUTH_USER,$vlimit,$print_flg){
	//notice1.php 177
		$this->argumentCheck("PHP_AUTH_USER", $_SERVER["PHP_AUTH_USER"]);
		$this->argumentCheck("vlimit", $vlimit);
		$sqlstr = "SELECT notice.*,employee.last_name_j||employee.first_name_j AS name,pnotice.emp_cd, pnotice.print_flg ";
		$sqlstr .= "FROM notice,employee,pnotice ";
		$sqlstr .= "WHERE notice.emp_cd = employee.emp_cd ";
		$sqlstr .= "AND pnotice.sendtime = notice.sendtime ";
		$sqlstr .= "AND pnotice.emp_cd = '$A_PHP_AUTH_USER' ";
		if($print_flg == '0'){
			$sqlstr .= "AND pnotice.print_flg = '1' ";
		}
		$sqlstr .= "ORDER BY sendtime DESC ";
		$sqlstr .= "limit $vlimit;";
		return $sqlstr;
	}

	function selectNoticeEmployeeAllNoticeEmpNameWithSendTime($sendtime){
	//notice2.php 159
		$this->argumentCheck("sendtime", $sendtime);
		$sqlstr = "SELECT notice.*, ";
		$sqlstr .= "employee.last_name_j||employee.first_name_j as name ";
		$sqlstr .= "FROM notice,employee ";
		$sqlstr .= "WHERE notice.emp_cd = employee.emp_cd ";
		$sqlstr .= "AND notice.sendtime = '$sendtime';";
		return $sqlstr;
	}

	function selectNoticePNoticeEmployeeAllNoticePNoticeRemarkReplyEmployeeNameWithSendTimeAdmPhpAuthUser($sendtime,$adm,$A_PHP_AUTH_USER){
	//notice2.php 208
		$this->argumentCheck("sendtime", $sendtime);
		$this->argumentCheck("adm", $adm);
		$this->argumentCheck("PHP_AUTH_USER", $_SERVER["PHP_AUTH_USER"]);
		$sqlstr = "SELECT notice.*, pnotice.remark,pnotice.reply, ";
		$sqlstr .= "employee.last_name_j||employee.first_name_j AS name ";
		$sqlstr .= "FROM notice,pnotice,employee ";
		$sqlstr .= "WHERE notice.emp_cd = employee.emp_cd ";
		$sqlstr .= "AND notice.sendtime = '$sendtime' ";
		$sqlstr .= "AND notice.sendtime = pnotice.sendtime ";

		if (substr($adm,2,1) == "1") {
			$sqlstr .= "AND pnotice.emp_cd = '$A_PHP_AUTH_USER';";
		}
		return $sqlstr;
	}

	function selectPnoticeEmployeeAllPNoticeEmployeeNameWithSendTime($sendtime){
	//notice2.php 309
		$this->argumentCheck("sendtime", $sendtime);
		$sqlstr = "SELECT pnotice.*,";
		$sqlstr .= "employee.last_name_j||employee.first_name_j AS name ";
		$sqlstr .= "FROM pnotice,employee ";
		$sqlstr .= "WHERE pnotice.emp_cd = employee.emp_cd ";
		$sqlstr .= "AND pnotice.sendtime = '$sendtime' ";
		$sqlstr .= "ORDER BY reply,seentime DESC;";
		return $sqlstr;
	}

	function selectEmployeeEmpCdNameSortNoWithDivisionSortedSortNo($ar_div){
	//notice3.php 166
		$this->argumentCheck("ar_div", $ar_div);
		return "SELECT emp_cd,last_name_j || first_name_j AS name,sort_no FROM employee WHERE division = '$ar_div' AND retire_date IS NULL AND unify = 'f' ORDER BY sort_no;";
	}

	function selectDivisionEmp_cdNameOrderBySort_noEmp_cd()
	{
		$sqlstr = "SELECT division,emp_cd,last_name_j || first_name_j AS name FROM employee WHERE retire_date IS NULL AND unify = 'f' ORDER BY sort_no,emp_cd;";
		return $sqlstr;
	}

    //20040810ɲ Start
    function selectDivisionEmp_cdNameOrderBySort_noEmp_cd_without_group($group_cd){
		$this->argumentCheck("group_cd", $group_cd);

        $sqlstr  = "SELECT ";
        $sqlstr .= "	employee.division, ";
        $sqlstr .= "	employee.emp_cd, ";
        $sqlstr .= "	employee.last_name_j || employee.first_name_j AS name ";
        $sqlstr .= "FROM ";
        $sqlstr .= "    employee ";
        $sqlstr .= "WHERE ";
        $sqlstr .= "    employee.retire_date IS NULL ";
        $sqlstr .= "    AND employee.unify = 'f' ";
        $sqlstr .= "    AND employee.emp_cd NOT IN (SELECT emp_cd FROM group_relation WHERE group_cd = '$group_cd') ";
	$sqlstr .= "ORDER BY ";
	$sqlstr .= "    sort_no, emp_cd;";

        return $sqlstr;
    }

    function selectDivisionEmp_cdNameOrderBySort_noEmp_cd_with_group($group_cd){
		$this->argumentCheck("group_cd", $group_cd);

        $sqlstr  = "SELECT ";
        $sqlstr .= "	employee.division, ";
        $sqlstr .= "	employee.emp_cd, ";
        $sqlstr .= "	employee.last_name_j || employee.first_name_j AS name ";
        $sqlstr .= "FROM ";
        $sqlstr .= "    employee ";
        $sqlstr .= "WHERE ";
        $sqlstr .= "    employee.retire_date IS NULL ";
        $sqlstr .= "    AND employee.unify = 'f' ";
        $sqlstr .= "    AND employee.emp_cd IN (SELECT emp_cd FROM group_relation WHERE group_cd = '$group_cd') ";
    	$sqlstr .= "ORDER BY ";
    	$sqlstr .= "    sort_no, emp_cd;";


        return $sqlstr;
    }
	function selectDivisionDiv_nameOrderByDiv_nameDivisionWithoutGroup($group_cd)
	{
	    $strSql =  "SELECT distinct ";
	    $strSql .= "    division.division, ";
	    $strSql .= "    division.div_name ";
	    $strSql .= "FROM ";
	    $strSql .= "    employee, division ";
	    $strSql .= "WHERE ";
	    $strSql .= "    division.division = employee.division ";
	    $strSql .= "    AND employee.retire_date IS NULL ";
	    $strSql .= "    AND employee.unify = 'f' ";
	    $strSql .= "    AND employee.emp_cd NOT IN (SELECT emp_cd FROM group_relation WHERE group_cd = ". $group_cd . ") ";
	    $strSql .= "ORDER BY div_name,division;";
	    return $strSql;
	}

	function selectDivisionDiv_nameOrderByDiv_nameDivisionWithGroup($group_cd)
	{
	    $strSql =  "SELECT distinct ";
	    $strSql .= "    division.division, ";
	    $strSql .= "    division.div_name ";
	    $strSql .= "FROM ";
	    $strSql .= "    employee, division ";
	    $strSql .= "WHERE ";
	    $strSql .= "    division.division = employee.division ";
	    $strSql .= "    AND employee.retire_date IS NULL ";
	    $strSql .= "    AND employee.unify = 'f' ";
	    $strSql .= "    AND employee.emp_cd IN (SELECT emp_cd FROM group_relation WHERE group_cd = ". $group_cd . ") ";
	    $strSql .= "ORDER BY div_name,division;";
	    return $strSql;
	}  
    //20040810End

	function selectEmployeeEmailNameWithEmpCd($emp_cd){
	//notice3.php 571
		$this->argumentCheck("emp_cd", $emp_cd);
		return "SELECT email,last_name_j || first_name_j AS name FROM employee WHERE emp_cd = '$emp_cd';";
	}

	function selectNoticeEmployeeAllNoticeEmpNameWithEmpCd($adminCheck,$A_PHP_AUTH_USER){
	//notice4.php 313
//		$this->argumentCheck("adminCheck", $adminCheck);

		$strSQL = "SELECT notice.*,employee.last_name_j||employee.first_name_j AS name ";
		$strSQL .= "FROM notice,employee ";
		$strSQL .= "WHERE notice.emp_cd = employee.emp_cd ";
		//Ԥʤ硢ʬΤߤʤ롣
			if ($adminCheck == false) {
				$strSQL .= "AND notice.emp_cd = '$A_PHP_AUTH_USER' ";
			}
		$strSQL .= "ORDER BY sendtime DESC ";
		return $strSQL;
	}

	function selectPNoticeEmployeeAllPNoticeEmpNameWithSendTime($sendtime){
	//notice4.php 495
		$this->argumentCheck("sendtime", $sendtime);
		$strSQL = "SELECT pnotice.*,";
		$strSQL .= "employee.last_name_j||employee.first_name_j AS name ";
		$strSQL .= "FROM pnotice,employee ";
		$strSQL .= "WHERE pnotice.emp_cd = employee.emp_cd ";
		$strSQL .= "AND pnotice.sendtime = '$sendtime' ";
		$strSQL .= "ORDER BY reply,seentime desc;";
		return $strSQL;
	}

	function selectEmployeeForPhoneBookWithDivision($division){
	//phonebook.php 102
		$sqlstr = "SELECT emp_cd,email,last_name_j || first_name_j AS name,extension_no,home_phone,handy_phone,";
		$sqlstr.= "home_addr1||home_addr2||home_addr3 AS addr, retire_date FROM employee WHERE retire_date IS NULL AND unify='f' ";
		if ($division != "") {
			$sqlstr.="AND division = '$division' ";
		}
		$sqlstr.="ORDER BY sort_no;";
		return $sqlstr;
	}

	function selectEmployeerAllName(){
	//record.php 317
		return "SELECT emp_cd,last_name_j || first_name_j AS name FROM employee WHERE retire_date IS NULL ORDER BY sort_no;";
	}

	function selectEmployeeEmpCdNameWithEmpCd($A_PHP_AUTH_USER){
	//reserve.php 117
		$this->argumentCheck("PHP_AUTH_USER", $_SERVER["PHP_AUTH_USER"]);
		return "SELECT emp_cd,last_name_j || first_name_j AS name FROM employee WHERE emp_cd = '$A_PHP_AUTH_USER';";
	}

	function selectReserveStatusOfTheDate($rsv_date,$rsv_time_b,$rsv_time_e,$fac_cd){
	//reserve.php 215
		$this->argumentCheck("rsv_date", $rsv_date);
		$this->argumentCheck("rsv_time_b", $rsv_time_b);
		$this->argumentCheck("rsv_time_e", $rsv_time_e);
		$this->argumentCheck("fac_cd", $fac_cd);
		$sqlstr = "SELECT reservation.*,facilities.fac_name,";
		$sqlstr .= "employee.last_name_j||employee.first_name_j AS name ";
		$sqlstr .= "FROM reservation,facilities,employee ";
		$sqlstr .= "WHERE reservation.rsv_date = '$rsv_date' ";
		$sqlstr .= "AND reservation.rsv_time_b = '$rsv_time_b' ";
		$sqlstr .= "AND reservation.rsv_time_e = '$rsv_time_e' ";
		$sqlstr .= "AND reservation.fac_cd = '$fac_cd' ";
		$sqlstr .= "AND reservation.fac_cd = facilities.fac_cd ";
		$sqlstr .= "AND reservation.emp_cd = employee.emp_cd;";
		return $sqlstr;
	}

	function selectCompanyGetBoss($arg2){
	//bosschk.funk 12ԤǻѤƤޤ
		$this->argumentCheck("arg2", $arg2);
		$sqlstr = "SELECT company.boss, employee.emp_cd, ";
		$sqlstr .= "employee.last_name_j||employee.first_name_j ";
		$sqlstr .= "FROM company, employee ";
		$sqlstr .= "WHERE emp_cd = '$arg2' ";
		$sqlstr .= "AND employee.last_name_j||employee.first_name_j = company.boss;";
		return $sqlstr;
	}

	function selectEmployeeGetAllRecord($arg2){
	//getallemp.func 15ԤǻѤƤޤ
		$this->argumentCheck("arg2", $arg2);
		$sqlstr = "SELECT emp_cd,last_name_j || first_name_j AS name ";
		$sqlstr .= "FROM employee ";
		$sqlstr .= "WHERE retire_date IS NULL AND unify = 'f' ";
		$sqlstr .= "ORDER BY $arg2;";
		return $sqlstr;
	}

	function selectEmployeeChiefInformation($now_emp_cd)
	{
	//makeoddmans.func 116
		$this->argumentCheck("now_emp_cd", $now_emp_cd);
		return "SELECT emp_cd,last_name_j || first_name_j AS name FROM employee WHERE emp_cd = (SELECT DISTINCT chief FROM chiefemp WHERE emp_cd = '$now_emp_cd');";
	}

	function selectEmployeeNameWithUnify(){
	//makeoddmans.func 236
		return "SELECT last_name_j || first_name_j AS name FROM employee WHERE unify = 't'";
	}

//	function selectEmployeeWithPetitionCdAndTime($petition_cd,$petition_time_temp)
	function selectEmployeeWithPetitionCdAndTime($subStrings)
	{
	//originalroot 70
//		$this->argumentCheck("petition_cd", $petition_cd);
//		$this->argumentCheck("petition_time_temp", $petition_time_temp);

		$sqlstr = "SELECT division,emp_cd,last_name_j || first_name_j AS name ";
		$sqlstr.= "FROM employee ";
		$sqlstr.= "WHERE retire_date IS NULL ";
		$sqlstr.= "AND emp_cd NOT IN ";

//		$sqlstr.= "(SELECT emp_cd FROM oddmans ";
//		$sqlstr.= "WHERE petition_cd = '$petition_cd' ";
//		$sqlstr.= "AND petition_time = '$petition_time_temp')";
		$sqlstr.= $subStrings;

		$sqlstr.= " ORDER BY sort_no;";

		return $sqlstr;
	}

	// selectEmployeeWithPetitionCdAndTime()Υ֥꡼ʬ
	function selectOddmansEmp_cdWithPetition_cdPetition_time($petition_cd, $petition_time_temp)
	{
		$this->argumentCheck("petition_cd", $petition_cd);
		$this->argumentCheck("petition_time_temp", $petition_time_temp);

		$sqlstr.= "SELECT emp_cd FROM oddmans ";
		$sqlstr.= "WHERE petition_cd = '$petition_cd' ";
		$sqlstr.= "AND petition_time = '$petition_time_temp'";

		return $sqlstr;
	}



	function selectOddmansEmployeeWithPetitionCdAndTimeAndEmpCd($petition_cd,$petition_time_temp){
	//originalroot 90
		$this->argumentCheck("petition_cd", $petition_cd);
		$this->argumentCheck("petition_time_temp", $petition_time_temp);
		$sqlstr = "SELECT oddmans.emp_cd AS emp_cd,employee.emp_cd,employee.last_name_j||employee.first_name_j AS name ";
		$sqlstr.= "FROM oddmans,employee ";
		$sqlstr.= "WHERE petition_cd = '$petition_cd' ";
		$sqlstr.= "AND petition_time = '$petition_time_temp' ";
		$sqlstr.= "AND oddmans.emp_cd = employee.emp_cd ";
		$sqlstr.= "ORDER BY seq;";
		return $sqlstr;
	}

	function selectTorihikisakiAllAddressWithToriCode($Sel){
	//client_list.php 206
		$this->argumentCheck("Sel", $Sel);
		return "SELECT * , address_1 || address_2 || address_3  AS ADDRESS FROM torihikisaki WHERE toricode = '$Sel';";
	}

	function selectEmployeeEmpCdNameWithRetireDateIsNullSortedSortNo($withoutEmpCd){
	//chief.php 210
		$strSql = "SELECT emp_cd,last_name_j || first_name_j AS name,retire_date FROM employee ";
		$strSql.= "WHERE retire_date IS NULL AND emp_cd <> '" . $withoutEmpCd . "' ORDER BY sort_no;";
		return $strSql;
	}

	function selectEmployeeEmpCdNameRetireDateWithEmpCdNotInChiefEmpString($chiefempString){
	//chief.php 279
		$strSql = "SELECT emp_cd,last_name_j || first_name_j AS name,retire_date FROM employee ";
		$strSql.= "WHERE emp_cd NOT IN $chiefempString AND employee.retire_date IS NULL ORDER BY sort_no;";
		return $strSql;
	}
	function selectWorkflowEmployeeMst_wflowClose($myEmpCd, $A_term, $petition_cd, $division, $emp_cd, $divisionOddman, $nowPage, $show_no, $oddman,$orderColumn,$sortForRev)
	{
		$this->argumentCheck("term", $A_term);
		$this->argumentCheck("nowPage", $nowPage);
		$this->argumentCheck("show_no", $show_no);

		$sqlstr = "SELECT (date_part('year',workflow.petition_time)::text || '-' || ";
		$sqlstr .= "lpad(date_part('month',workflow.petition_time)::text, 2, '0') || '-' || ";
		$sqlstr .= "lpad(date_part('day',workflow.petition_time)::text, 2, '0') || ' ' || ";
		$sqlstr .= "lpad(date_part('hour',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('minute',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('second',workflow.petition_time)::text, 2, '0')) AS petition_time,";

		$sqlstr .= "workflow.emp_cd,workflow.purpose,";
		$sqlstr .= "employee.last_name_j || employee.first_name_j AS name,";
		$sqlstr .= "mst_wflow.petition_name ";
		$sqlstr .= "FROM workflow,employee,mst_wflow ";
		$sqlstr .=",oddmans ";
		$sqlstr .= "WHERE workflow.oddall = 't' AND workflow.delflg = 'f' ";
		$sqlstr .= "AND employee.emp_cd = workflow.emp_cd ";

		//-- եΥ롼Ȥˤͤޤ
		$sqlstr .= "AND oddmans.petition_time = workflow.petition_time ";
		$sqlstr .= "AND ((oddmans.emp_cd = '$myEmpCd') or ";
		$sqlstr .= "(workflow.emp_cd = '$myEmpCd' and oddmans.seq = 1)) ";

		// ߤ $term ޤǤ򸡺
		$sqlstr .= "AND workflow.petition_time + '$A_term months' >= now() ";

		if ($petition_cd != "" && $petition_cd != "all")
		{
			$sqlstr .= "AND workflow.petition_cd = '$petition_cd' ";
		}

		// Ԥ򤵤ƤơƤǤϤʤ
		if ($emp_cd != "" && $emp_cd != "all") 
		{
			$sqlstr .= "AND workflow.emp_cd = '$emp_cd' ";
		}
		else
		{
			// Τwhereɲ
			if ($division != "" && $division != "all")
			{
				$sqlstr .= "AND employee.division = '" . $division . "' ";
				$sqlstr .= "AND workflow.emp_cd = employee.emp_cd ";
			}
		}

		// ۼԤơפǤʤ
		if ($oddman != "" && $oddman != "all")
		{
			$sqlstr .= "AND oddmans.emp_cd = '$oddman' ";
			$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
		}
		else
		{
			// Τwhereɲ
			if ($divisionOddman != "" && $divisionOddman != "all")
			{
				$sqlstr .= "AND employee.division = '" . $divisionOddman . "' ";
				$sqlstr .= "AND oddmans.emp_cd = employee.emp_cd ";
				$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
			}
		}

		$sqlstr .= "AND workflow.petition_cd = mst_wflow.petition_cd ";

		switch($sortForRev) {
			case "KOUJUN":
				$sortForRev = " DESC";
				break;
			case "SHOUJUN":
				$sortForRev = "";
			default:
				break;
		}
		if($orderColumn == "name"){
			$orderColumn = "employee.last_name_j || employee.first_name_j";
		}

		$sqlstr .= "ORDER BY $orderColumn $sortForRev ";

		// ɽ
		// ǽΥڡξ硢OFFSET0ˤ
		$offSET = ($nowPage - 1) * $show_no;
		$sqlstr .= "LIMIT $show_no OFFSET " . $offSET . ";";

		return $sqlstr;
	}

	function selectWorkflowEmployeeMst_wflow($A_term, $petition_cd, $division, $emp_cd, $divisionOddman, $nowPage, $show_no, $oddman,$orderColumn,$sortForRev)
	{
		$this->argumentCheck("term", $A_term);
		$this->argumentCheck("nowPage", $nowPage);
		$this->argumentCheck("show_no", $show_no);

		$sqlstr = "SELECT (date_part('year',workflow.petition_time)::text || '-' || ";
		$sqlstr .= "lpad(date_part('month',workflow.petition_time)::text, 2, '0') || '-' || ";
		$sqlstr .= "lpad(date_part('day',workflow.petition_time)::text, 2, '0') || ' ' || ";
		$sqlstr .= "lpad(date_part('hour',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('minute',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('second',workflow.petition_time)::text, 2, '0')) AS petition_time,";

		$sqlstr .= "workflow.emp_cd,workflow.purpose,";
		$sqlstr .= "employee.last_name_j || employee.first_name_j AS name,";
		$sqlstr .= "mst_wflow.petition_name ";
		$sqlstr .= "FROM workflow,employee,mst_wflow ";

		if ($oddman!= "" && $oddman != "all") {
			$sqlstr .=",oddmans ";
		} elseif ($divisionOddman != "" && $divisionOddman != "all") {
			$sqlstr .=",oddmans ";
		}

		$sqlstr .= "WHERE workflow.oddall = 't' AND workflow.delflg = 'f' ";
		$sqlstr .= "AND employee.emp_cd = workflow.emp_cd ";

		// ߤ $term ޤǤ򸡺
		$sqlstr .= "AND workflow.petition_time + '$A_term months' >= now() ";

		if ($petition_cd != "" && $petition_cd != "all")
		{
			$sqlstr .= "AND workflow.petition_cd = '$petition_cd' ";
		}

		// Ԥ򤵤ƤơƤǤϤʤ
		if ($emp_cd != "" && $emp_cd != "all") 
		{
			$sqlstr .= "AND workflow.emp_cd = '$emp_cd' ";
		}
		else
		{
			// Τwhereɲ
			if ($division != "" && $division != "all")
			{
				$sqlstr .= "AND employee.division = '" . $division . "' ";
				$sqlstr .= "AND workflow.emp_cd = employee.emp_cd ";
			}
		}

		// ۼԤơפǤʤ
		if ($oddman != "" && $oddman != "all")
		{
			$sqlstr .= "AND oddmans.emp_cd = '$oddman' ";
			$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
		}
		else
		{
			// Τwhereɲ
			if ($divisionOddman != "" && $divisionOddman != "all")
			{
				$sqlstr .= "AND employee.division = '" . $divisionOddman . "' ";
				$sqlstr .= "AND oddmans.emp_cd = employee.emp_cd ";
				$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
			}
		}

		$sqlstr .= "AND workflow.petition_cd = mst_wflow.petition_cd ";

		switch($sortForRev) {
			case "KOUJUN":
				$sortForRev = " DESC";
				break;
			case "SHOUJUN":
				$sortForRev = "";
			default:
				break;
		}
		if($orderColumn == "name"){
			$orderColumn = "employee.last_name_j || employee.first_name_j";
		}

		$sqlstr .= "ORDER BY $orderColumn $sortForRev ";

		// ɽ
		// ǽΥڡξ硢OFFSET0ˤ
		$offSET = ($nowPage - 1) * $show_no;
		$sqlstr .= "LIMIT $show_no OFFSET " . $offSET . ";";

		return $sqlstr;
	}

	function selectWorkflowEmployeeMst_wflowWithEmp_cdPetition_cdEndflgClose($myEmpCd, $petition_cd, $division, $emp_cd, $divisionOddman, $oddman)
	{
		$sqlstr = "SELECT (date_part('year',workflow.petition_time)::text || '-' || ";
		$sqlstr .= "lpad(date_part('month',workflow.petition_time)::text, 2, '0') || '-' || ";
		$sqlstr .= "lpad(date_part('day',workflow.petition_time)::text, 2, '0') || ' ' || ";
		$sqlstr .= "lpad(date_part('hour',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('minute',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('second',workflow.petition_time)::text, 2, '0')) AS petition_time,";

		$sqlstr .= "workflow.emp_cd,workflow.petition_cd,workflow.oddtime,";
		$sqlstr .= "workflow.oddall,workflow.time_begin,workflow.time_end,workflow.purpose,workflow.detail,";
		$sqlstr .= "workflow.etc,workflow.ammount,workflow.ngflg,workflow.endflg,workflow.remark,";
		$sqlstr .= "workflow.filename,workflow.delflg,";
		$sqlstr .= "employee.last_name_j||employee.first_name_j AS name,employee.emp_cd,";

		$sqlstr .= "employee.last_name_j || first_name_j AS name,employee.emp_cd,";
		$sqlstr .= "mst_wflow.petition_name,mst_wflow.petition_type AS petition_type ";
		$sqlstr .= "FROM workflow,employee,mst_wflow ";

		$sqlstr .=",oddmans ";

		$sqlstr .= "WHERE workflow.oddall = 'f' AND workflow.delflg = 'f' ";
		$sqlstr .= "AND employee.emp_cd = workflow.emp_cd ";

		//-- եΥ롼Ȥˤͤޤ
		$sqlstr .= "AND oddmans.petition_time = workflow.petition_time ";
		$sqlstr .= "AND ((oddmans.emp_cd = '$myEmpCd') or ";
		$sqlstr .= "(workflow.emp_cd = '$myEmpCd' and oddmans.seq = 1)) ";

		if ($petition_cd != "" && $petition_cd != "all")
		{
			$sqlstr .= "AND workflow.petition_cd = '$petition_cd' ";
		}

		// Ԥ򤵤ƤơƤǤϤʤ
		if ($emp_cd != "" && $emp_cd != "all") 
		{
			$sqlstr .= "AND workflow.emp_cd = '$emp_cd' ";
		}
		else
		{
			// Τwhereɲ
			if ($division != "" && $division != "all")
			{
				$sqlstr .= "AND employee.division = '" . $division . "' ";
				$sqlstr .= "AND workflow.emp_cd = employee.emp_cd ";
			}
		}

		// ۼԤơפǤʤ
		if ($oddman != "" && $oddman != "all")
		{
			$sqlstr .= "AND oddmans.emp_cd = '$oddman' ";
			$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
		}
		else
		{
			// Τwhereɲ
			if ($divisionOddman != "" && $divisionOddman != "all")
			{
				$sqlstr .= "AND employee.division = '" . $divisionOddman . "' ";
				$sqlstr .= "AND oddmans.emp_cd = employee.emp_cd ";
				$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
			}
		}

		$sqlstr .= "AND workflow.petition_cd = mst_wflow.petition_cd ";
		$sqlstr .= "ORDER BY workflow.petition_time;";

		return $sqlstr;
	}

	function selectWorkflowEmployeeMst_wflowWithEmp_cdPetition_cdEndflg($petition_cd, $division, $emp_cd, $divisionOddman, $oddman)
	{
		$sqlstr = "SELECT (date_part('year',workflow.petition_time)::text || '-' || ";
		$sqlstr .= "lpad(date_part('month',workflow.petition_time)::text, 2, '0') || '-' || ";
		$sqlstr .= "lpad(date_part('day',workflow.petition_time)::text, 2, '0') || ' ' || ";
		$sqlstr .= "lpad(date_part('hour',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('minute',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('second',workflow.petition_time)::text, 2, '0')) AS petition_time,";

		$sqlstr .= "workflow.emp_cd,workflow.petition_cd,workflow.oddtime,";
		$sqlstr .= "workflow.oddall,workflow.time_begin,workflow.time_end,workflow.purpose,workflow.detail,";
		$sqlstr .= "workflow.etc,workflow.ammount,workflow.ngflg,workflow.endflg,workflow.remark,";
		$sqlstr .= "workflow.filename,workflow.delflg,";
		$sqlstr .= "employee.last_name_j||employee.first_name_j AS name,employee.emp_cd,";

		$sqlstr .= "employee.last_name_j || first_name_j AS name,employee.emp_cd,";
		$sqlstr .= "mst_wflow.petition_name,mst_wflow.petition_type AS petition_type ";
		$sqlstr .= "FROM workflow,employee,mst_wflow ";

		if ($oddman != "" && $oddman != "all") {
			$sqlstr .=",oddmans ";
		} elseif ($divisionOddman != "" && $divisionOddman != "all") {
			$sqlstr .=",oddmans ";
		}

		$sqlstr .= "WHERE workflow.oddall = 'f' AND workflow.delflg = 'f' ";
		$sqlstr .= "AND employee.emp_cd = workflow.emp_cd ";

		if ($petition_cd != "" && $petition_cd != "all")
		{
			$sqlstr .= "AND workflow.petition_cd = '$petition_cd' ";
		}

		// Ԥ򤵤ƤơƤǤϤʤ
		if ($emp_cd != "" && $emp_cd != "all") 
		{
			$sqlstr .= "AND workflow.emp_cd = '$emp_cd' ";
		}
		else
		{
			// Τwhereɲ
			if ($division != "" && $division != "all")
			{
				$sqlstr .= "AND employee.division = '" . $division . "' ";
				$sqlstr .= "AND workflow.emp_cd = employee.emp_cd ";
			}
		}

		// ۼԤơפǤʤ
		if ($oddman != "" && $oddman != "all")
		{
			$sqlstr .= "AND oddmans.emp_cd = '$oddman' ";
			$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
		}
		else
		{
			// Τwhereɲ
			if ($divisionOddman != "" && $divisionOddman != "all")
			{
				$sqlstr .= "AND employee.division = '" . $divisionOddman . "' ";
				$sqlstr .= "AND oddmans.emp_cd = employee.emp_cd ";
				$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
			}
		}

		$sqlstr .= "AND workflow.petition_cd = mst_wflow.petition_cd ";
		$sqlstr .= "ORDER BY workflow.petition_time;";

		return $sqlstr;
	}

	function selectWorkflowCasusMst_wflowEmployeeWherePetition_timePetition_cdEmp_cd($petition_time)
	{
		$this->argumentCheck("petition_time", $petition_time);

		$sqlstr = "SELECT (date_part('year',workflow.petition_time)::text || '-' || ";
		$sqlstr .= "lpad(date_part('month',workflow.petition_time)::text, 2, '0') || '-' || ";
		$sqlstr .= "lpad(date_part('day',workflow.petition_time)::text, 2, '0') || ' ' || ";
		$sqlstr .= "lpad(date_part('hour',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('minute',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('second',workflow.petition_time)::text, 2, '0')) AS petition_time,";

		$sqlstr .= "workflow.emp_cd,workflow.petition_cd,workflow.oddtime,";
		$sqlstr .= "workflow.oddall,workflow.time_begin,workflow.time_end,workflow.purpose,workflow.detail,";
		$sqlstr .= "workflow.etc,workflow.ammount,workflow.ngflg,workflow.endflg,workflow.remark,";
		$sqlstr .= "workflow.filename,workflow.delflg,";

		$sqlstr .= "date_part('year',time_begin)::text AS byear,";
		$sqlstr .= "date_part('month',time_begin)::text AS bmonth,";
		$sqlstr .= "date_part('day',time_begin)::text AS bday,";
		$sqlstr .= "date_part('hour',time_begin)::text AS bhour,";
		$sqlstr .= "date_part('minute',time_begin)::text AS bmin,";
		$sqlstr .= "date_part('year',time_end)::text AS eyear,";
		$sqlstr .= "date_part('month',time_end)::text AS emonth,";
		$sqlstr .= "date_part('day',time_end)::text AS eday,";
		$sqlstr .= "date_part('hour',time_end)::text AS ehour,";
		$sqlstr .= "date_part('minute',time_end)::text AS emin,";
		$sqlstr .= "casus.*,mst_wflow.petition_name,";
		$sqlstr .= "mst_wflow.petition_type AS petition_type,";
		$sqlstr .= "employee.last_name_j || employee.first_name_j AS name ";
		$sqlstr .= "FROM workflow,casus,mst_wflow,employee ";
		$sqlstr .= "WHERE workflow.petition_time = '$petition_time' ";
		$sqlstr .= "AND workflow.petition_cd = mst_wflow.petition_cd ";
		$sqlstr .= "AND workflow.petition_time = casus.petition_time ";
		$sqlstr .= "AND casus.emp_cd = employee.emp_cd;";

		return $sqlstr;
	}

	function selectWorkflowEmployeeMst_wflowWherePetition_timeEmp_cdPetition_cd($petition_time, $emp_cd)
	{
		$this->argumentCheck("petition_time", $petition_time);
		$this->argumentCheck("emp_cd", $emp_cd);

		$sqlstr = "SELECT (date_part('year',workflow.petition_time)::text || '-' || ";
		$sqlstr .= "lpad(date_part('month',workflow.petition_time)::text, 2, '0') || '-' || ";
		$sqlstr .= "lpad(date_part('day',workflow.petition_time)::text, 2, '0') || ' ' || ";
		$sqlstr .= "lpad(date_part('hour',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('minute',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('second',workflow.petition_time)::text, 2, '0')) AS petition_time,";

		$sqlstr .= "workflow.emp_cd,workflow.petition_cd,workflow.oddtime,";
		$sqlstr .= "workflow.oddall,workflow.time_begin,workflow.time_end,workflow.purpose,workflow.detail,";
		$sqlstr .= "workflow.etc,workflow.ammount,workflow.ngflg,workflow.endflg,workflow.remark,";
		$sqlstr .= "workflow.filename,workflow.delflg,";
		$sqlstr .= "employee.last_name_j||employee.first_name_j AS name,employee.emp_cd,";

		$sqlstr .= "date_part('year',time_begin)::text AS byear,";
		$sqlstr .= "date_part('month',time_begin)::text AS bmonth,";
		$sqlstr .= "date_part('day',time_begin)::text AS bday,";
		$sqlstr .= "date_part('hour',time_begin)::text AS bhour,";
		$sqlstr .= "date_part('minute',time_begin)::text AS bmin,";
		$sqlstr .= "date_part('year',time_end)::text AS eyear,";
		$sqlstr .= "date_part('month',time_end)::text AS emonth,";
		$sqlstr .= "date_part('day',time_end)::text AS eday,";
		$sqlstr .= "date_part('hour',time_end)::text AS ehour,";
		$sqlstr .= "date_part('minute',time_end)::text AS emin,";
		$sqlstr .= "employee.last_name_j || first_name_j AS name,";
		$sqlstr .= "mst_wflow.petition_name,mst_wflow.petition_type AS petition_type ";
		$sqlstr .= "FROM workflow,employee,mst_wflow ";
		$sqlstr .= "WHERE workflow.petition_time = '$petition_time' ";
		$sqlstr .= "AND workflow.emp_cd = '$emp_cd' ";
		$sqlstr .= "AND employee.emp_cd = '$emp_cd' ";
		$sqlstr .= "AND workflow.petition_cd = mst_wflow.petition_cd;";

		return $sqlstr;
	}

	function selectEmployeeEmpCdNameWithRetireDateNullSortedKindEmpCd(){
	//gwlog.php 108
		return "SELECT emp_cd, last_name_j || first_name_j AS name FROM employee WHERE retire_date IS NULL ORDER BY sort_no ;";
	}

	function selectBbsEmployeeBbsAllEmployeeNameWithBbsnoEmpCd($orgin,$bbsno,$compareString){
		$this->argumentCheck("orgin", $orgin);
		$this->argumentCheck("bbsno", $bbsno);

	//not unionС
		$sqlstr .= "SELECT bbs.*,employee.last_name_j||employee.first_name_j AS name ";
		$sqlstr .= "FROM bbs,employee ";
		$sqlstr .= "WHERE (bbs.bbsno = $bbsno AND bbs.emp_cd = employee.emp_cd AND bbs.voicetime >= '$orgin') OR ";
		$sqlstr .= "(bbs.bbsno = $bbsno AND bbs.emp_cd = employee.emp_cd AND msgid IN $compareString ) ";
		$sqlstr .= "ORDER BY bbs.msgid;";
		return $sqlstr;
	}

	function selectBbsEmployeeBbsAllEmpNameWithMsgIdEmpCd($bbsno,$msgid){
	//skybbs2.php 71
		$this->argumentCheck("bbsno", $bbsno);
		$this->argumentCheck("msgid", $msgid);
		$sqlstr = "SELECT bbs.*,employee.last_name_j || first_name_j AS name ";
		$sqlstr .= "FROM bbs,employee ";
		$sqlstr .= "WHERE bbsno = '$bbsno' ";
		$sqlstr .= "AND bbs.msgid='$msgid' ";
		$sqlstr .= "AND bbs.emp_cd = employee.emp_cd;";
		return $sqlstr;
	}

	function selectEmployeeEmpCdNameWithRetireDateNullSortedSortNo(){
	//bbsconf.php 180
	//bbsconf.php 211
		return "SELECT emp_cd,last_name_j || first_name_j AS name FROM employee WHERE retire_date IS NULL ORDER BY sort_no;";
	}

	function selectBbsMaxOfMsgIdWithMsgIdBbsNo($msgidhead,$bbsno){
	//skybbs1.php 417
		$this->argumentCheck("msgidhead", $msgidhead);
		$this->argumentCheck("bbsno", $bbsno);
		$strSql = "select max(msgid) as max_of_field from bbs where msgid ~ '^$msgidhead' and bbsno = '$bbsno';";
		return $strSql;
	}

	function selectTorihikisakiSortedToriCode(){
	//client_main.php 107
		return "SELECT * FROM torihikisaki ORDER BY int4(toricode);";
	}

	function selectTorihikisakiToriCodeSyameiSortedToriCode(){
	//client_list.php 421
		return "SELECT toricode,syamei FROM torihikisaki ORDER BY int4(toricode);";
	}

//	function selectTantouMaxOfSeq(){
//	//client_list.php 108
//		return "SELECT max(int4(rtrim(seq))) as max_of_field FROM tantou;";
//	}

//	function selectTorihikisakiMaxOfToriCode(){
//	//client_list.php 172
//		return "SELECT max(int4(toricode)) as max_of_field FROM torihikisaki;";
//	}

	// 2004.08 ͭνɲ
	function selectRecordCountOfFileNametWithCatCdSubCatCdEmpCd($cat_cd,$subcat_cd,$division,$emp_cd,$A_term,$A_PHP_AUTH_USER,$isAdmin,$myGroup,$Divcd) {
	//record.php 1430
	// 2004.08 ƥ/֥ƥλԻȽɲ
		$sqlstr = "SELECT COUNT(DISTINCT(record.up_time)) AS count_of_records FROM record,employee,";
		$sqlstr .= "category, subcategory ";
		if(!$isAdmin) {
			$sqlstr.= ",record_access ";
			if ($Divcd != "") {
			//2004.08ˤɽɲ
				$sqlstr .= ",(SELECT subcategory.subcat_cd ";
				$sqlstr .= " FROM subcategory,group_access ";
				$sqlstr .= " WHERE subcategory.subcat_cd = group_access.subcat_cd ";
				$sqlstr .= "   AND group_access.group_cd = '$Divcd' ";
				$sqlstr .= "   AND enable = 't' ";
				$sqlstr .= "UNION ";
				$sqlstr .= "SELECT * FROM ";
				$sqlstr .= " (SELECT subcategory.subcat_cd ";
				$sqlstr .= "   FROM subcategory ";
				$sqlstr .= "   WHERE enable = 't' ";
				$sqlstr .= "  EXCEPT ";
				$sqlstr .= "  SELECT subcategory.subcat_cd ";
				$sqlstr .= "   FROM  subcategory,group_access ";
				$sqlstr .= "   WHERE subcategory.subcat_cd = group_access.subcat_cd ";
				$sqlstr .= "   AND enable = 't') AS free) AS subcd_acc ";
			}
		}
		$sqlstr .= "WHERE employee.emp_cd = record.emp_cd ";
		$sqlstr .= " AND category.cat_cd = record.cat_cd ";
		$sqlstr .= " AND subcategory.cat_cd = record.cat_cd ";
		$sqlstr .= " AND subcategory.subcat_cd = record.subcat_cd ";
		$sqlstr .= " AND category.enable = 't' ";
		$sqlstr .= " AND subcategory.enable = 't' ";

		if ($emp_cd != "all" && $emp_cd != "")
		{
			$sqlstr .= "AND record.emp_cd = '$emp_cd' ";
		}
		else if ($division != "all" && $division != "")
		{
			$sqlstr .= "AND employee.division = '$division' ";
		}

		if ($cat_cd != "all" && $cat_cd != "")
		{
			$sqlstr .= "AND record.cat_cd = '$cat_cd' ";
		}

		if ($subcat_cd != "all" && $subcat_cd != "")
		{
			$sqlstr .= "AND record.subcat_cd = '$subcat_cd' ";
		}
//ɵ ä
		if (!$isAdmin){
			$sqlstr.= "AND record.up_time = record_access.up_time ";
			$sqlstr.= "AND ( ";
			$sqlstr.= "record_access.group_cd = 9999 ";
			$sqlstr.= "OR record_access.readable_status <> 'F' ";
			$sqlstr.= "OR record.emp_cd = '$A_PHP_AUTH_USER' ";
			if($myGroup != "('')"){
			  $sqlstr.= "OR record_access.group_cd IN $myGroup ";
			}
			$sqlstr.= " ) ";
			if ($Divcd != "") {
				//2004.08ˤɽɲ
				$sqlstr.= "AND subcategory.subcat_cd = subcd_acc.subcat_cd ";
			}
		}

		$sqlstr .= "AND record.up_time + '$A_term months' >= now();";

		return $sqlstr;
	}

	function selectWorkflowPetition_timeCountClose($A_term, $petition_cd, $division, $emp_cd, $divisionOddman, $oddman, $myEmpCd)
	{
		$this->argumentCheck("term", $A_term);

		// μ
		$sqlstr = "SELECT COUNT(workflow.petition_time) as count_of_records FROM workflow, oddmans ";
		$sqlstr .= "WHERE workflow.oddall = 't' ";

		//-- եΥ롼Ȥˤͤޤ
		$sqlstr .= "AND oddmans.petition_time = workflow.petition_time ";
		$sqlstr .= "AND ((oddmans.emp_cd = '$myEmpCd') or ";
		$sqlstr .= "(workflow.emp_cd = '$myEmpCd' and oddmans.seq = 1)) ";

		// ߤ $term ޤǤ򸡺
		$sqlstr .= "AND workflow.petition_time + '$A_term months' >= now() ";

		if ($petition_cd != "" && $petition_cd != "all")
		{
			$sqlstr .= "AND workflow.petition_cd = '$petition_cd' ";
		}

		// Ԥ򤵤ƤơƤǤϤʤ
		if ($emp_cd != "" && $emp_cd != "all") 
		{
			$sqlstr .= "AND workflow.emp_cd = '$emp_cd' ";
		}
		else
		{
			// Τwhereɲ
			if ($division != "" && $division != "all")
			{
				$sqlstr .= "AND employee.division = '" . $division . "' ";
				$sqlstr .= "AND workflow.emp_cd = employee.emp_cd ";
			}
		}

		// ۼԤơפǤʤ
		if ($oddman != "" && $oddman != "all")
		{
			$sqlstr .= "AND oddmans.emp_cd = '$oddman' ";
			$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
		}
		else
		{
			// Τwhereɲ
			if ($divisionOddman != "" && $divisionOddman != "all")
			{
				$sqlstr .= "AND employee.division = '" . $divisionOddman . "' ";
				$sqlstr .= "AND oddmans.emp_cd = employee.emp_cd ";
				$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
			}
		}

		$sqlstr .= "AND workflow.delflg = 'f'";

		return $sqlstr;
	}

	function selectWorkflowPetition_timeCount($A_term, $petition_cd, $division, $emp_cd, $divisionOddman, $oddman)
	{
		$this->argumentCheck("term", $A_term);

		// μ
		$sqlstr = "SELECT COUNT(workflow.petition_time) as count_of_records FROM workflow ";
			if ($oddman != "" && $oddman != "all") {
				$sqlstr.= ",oddmans ";
			}

		$sqlstr .= "WHERE workflow.oddall = 't' ";

		// ߤ $term ޤǤ򸡺
		$sqlstr .= "AND workflow.petition_time + '$A_term months' >= now() ";

		if ($petition_cd != "" && $petition_cd != "all")
		{
			$sqlstr .= "AND workflow.petition_cd = '$petition_cd' ";
		}

		// Ԥ򤵤ƤơƤǤϤʤ
		if ($emp_cd != "" && $emp_cd != "all") 
		{
			$sqlstr .= "AND workflow.emp_cd = '$emp_cd' ";
		}
		else
		{
			// Τwhereɲ
			if ($division != "" && $division != "all")
			{
				$sqlstr .= "AND employee.division = '" . $division . "' ";
				$sqlstr .= "AND workflow.emp_cd = employee.emp_cd ";
			}
		}

		// ۼԤơפǤʤ
		if ($oddman != "" && $oddman != "all")
		{
			$sqlstr .= "AND oddmans.emp_cd = '$oddman' ";
			$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
		}
		else
		{
			// Τwhereɲ
			if ($divisionOddman != "" && $divisionOddman != "all")
			{
				$sqlstr .= "AND employee.division = '" . $divisionOddman . "' ";
				$sqlstr .= "AND oddmans.emp_cd = employee.emp_cd ";
				$sqlstr .= "AND workflow.petition_time = oddmans.petition_time ";
			}
		}

		$sqlstr .= "AND workflow.delflg = 'f'";

		return $sqlstr;
	}


	function selectEmployeeInfo($division, $emp_cd)
	{
		$sqlStr = "SELECT employee.emp_cd,employee.division,employee.last_name_j || employee.first_name_j AS name,administrators.emp_cd AS admin FROM employee LEFT OUTER JOIN administrators USING(emp_cd)";

		// оݼҰ
		if ($division == "all")
		{
			$sqlPrerequisiteStr = " WHERE employee.retire_date IS NULL ";
		}
		else if ($emp_cd != "" && $division != "")
		{
			$sqlPrerequisiteStr = " WHERE employee.emp_cd = '" . $emp_cd . "' OR employee.division = '" . $division . "'";
			$sqlPrerequisiteStr .= " AND employee.retire_date IS NULL ";
		}
		else if ($emp_cd != "")
		{
			$sqlPrerequisiteStr = " WHERE employee.emp_cd = '" . $emp_cd . "'";
			$sqlPrerequisiteStr .= " AND employee.retire_date IS NULL ";
		}
		else if ($division != "")
		{
			$sqlPrerequisiteStr = " WHERE employee.division = '" . $division . "'";
			$sqlPrerequisiteStr .= " AND employee.retire_date IS NULL ";
		}

		// Ⱦ
		$sqlOrderStr = " ORDER BY employee.sort_no;";

		return $sqlStr . $sqlPrerequisiteStr . $sqlOrderStr;
	}


	function selectEmployeeInfoExcludeUnify($division, $emp_cd)
	{
		$sqlStr = "SELECT employee.emp_cd,employee.division,employee.last_name_j || employee.first_name_j AS name,administrators.emp_cd AS admin FROM employee LEFT OUTER JOIN administrators USING(emp_cd)";

		if ($division == "all")
		{
			$sqlPrerequisiteStr = " WHERE employee.retire_date IS NULL AND employee.unify = 'f' ";
		}
		else if ($emp_cd != "" && $division != "")
		{
			$sqlPrerequisiteStr = " WHERE employee.emp_cd = '" . $emp_cd . "' OR employee.division = '" . $division . "'";
			$sqlPrerequisiteStr .= " AND employee.retire_date IS NULL AND employee.unify = 'f' ";
		}
		else if ($emp_cd != "")
		{
			$sqlPrerequisiteStr = " WHERE employee.emp_cd = '" . $emp_cd . "'";
			$sqlPrerequisiteStr .= " AND employee.retire_date IS NULL AND employee.unify = 'f' ";
		}
		else if ($division != "")
		{
			$sqlPrerequisiteStr = " WHERE employee.division = '" . $division . "'";
			$sqlPrerequisiteStr .= " AND employee.retire_date IS NULL AND employee.unify = 'f' ";
		}

		// Ⱦ
		$sqlOrderStr = " ORDER BY employee.sort_no;";

		return $sqlStr . $sqlPrerequisiteStr . $sqlOrderStr;
	}


	function selectEmployeeWhiteboardEmpInfoWhiteboardAllWithDivisionEmpCdUnifyFSortedSortNo($division)
	{
		$sqlstr = "SELECT employee.last_name_j || employee.first_name_j AS name,";
		$sqlstr .= "employee.contact,employee.extension_no,employee.email,employee.sort_no,";
		$sqlstr .= "whiteboard.* ";
		$sqlstr .= "FROM employee,whiteboard ";

		if ($division != "all") {
			$sqlstr .= "WHERE employee.division = '$division' ";
			$sqlstr .= "AND employee.retire_date IS NULL ";
		} else {
			$sqlstr .= "WHERE employee.retire_date IS NULL ";
		}

		$sqlstr .= "AND employee.emp_cd = whiteboard.emp_cd ";
		$sqlstr .= "AND employee.unify = 'f' ";
		$sqlstr .= "ORDER BY employee.sort_no;";
		return $sqlstr;
	}

	function selectScheduleDateTimeWithEmpCdFlgdelFlgpubSortedScdl_s_time($emp_cd)
	{
	//whiteboard1.php 334

		$this->argumentCheck("emp_cd", $emp_cd);

		$sqlstr = "SELECT lpad(date_part('hour'::text, schedule_date.scdl_s_time)::text, 2, '0') AS shour,";
		$sqlstr .= "lpad(date_part('minutes'::text, schedule_date.scdl_s_time)::text, 2, '0') AS smin,";
		$sqlstr .= "lpad(date_part('hour'::text, schedule_date.scdl_e_time)::text, 2, '0') AS ehour,";
		$sqlstr .= "lpad(date_part('minutes'::text, schedule_date.scdl_e_time)::text, 2, '0') AS emin,";
		$sqlstr .= "date_part('month'::text, schedule_date.scdl_date)::text || '/' || date_part('day'::text, schedule_date.scdl_date)::text AS scdl_s_date,";
		$sqlstr .= "date_part('month'::text, schedule_date.scdl_date)::text || '/' || date_part('day'::text, schedule_date.scdl_date)::text AS scdl_e_date,";
		$sqlstr .= "schedule2.scdl_plan,";
		$sqlstr .= "schedule2.scdl_place,";
		$sqlstr .= "schedule2.flg_pub, ";
		$sqlstr .= "schedule2.flg_out ";
		$sqlstr .= "FROM schedule2, wiz_event_member, schedule_date ";

		$sqlstr .= "WHERE schedule2.schedule_cd = wiz_event_member.schedule_cd";
		$sqlstr .= " AND schedule2.schedule_cd = schedule_date.schedule_cd";
		$sqlstr .= " AND schedule_date.schedule_date_cd = wiz_event_member.schedule_date_cd";
		$sqlstr .= " AND (('now'::date <= schedule_date.scdl_date AND schedule_date.scdl_date <= 'now'::date)";
		$sqlstr .= " OR ('now'::date <= schedule_date.scdl_date AND schedule_date.scdl_date <= 'now'::date)";
		$sqlstr .= " OR ('now'::date > schedule_date.scdl_date AND schedule_date.scdl_date > 'now'::date))";
		$sqlstr .= " AND wiz_event_member.emp_cd = '" . $emp_cd . "' ";
		$sqlstr .= " AND wiz_event_member.enable = '1'";
		$sqlstr .= " AND schedule2.flg_del = 'f' ";
		$sqlstr .= "ORDER BY schedule_date.scdl_date,schedule_date.scdl_s_time;";

		return $sqlstr;
	}

	function selectTelmemo2AllWithEmpCdDelF($emp_cd){
	//whiteboard1.php 387
		$this->argumentCheck("emp_cd", $emp_cd);
		return "SELECT * FROM telmemo2 WHERE emp_cd ='" . $emp_cd . "' AND del = 'f';";
	}

	function selectScheduleDateTimeWithEmpCdFlgdelFlgpubSortedScdl_s_time_DateStr($emp_cd, $dateStr)
	{
		$this->argumentCheck("emp_cd", $emp_cd);

		$sqlstr = "SELECT lpad(date_part('hour'::text, schedule_date.scdl_s_time)::text, 2, '0') AS shour,";
		$sqlstr .= "lpad(date_part('minutes'::text, schedule_date.scdl_s_time)::text, 2, '0') AS smin,";
		$sqlstr .= "lpad(date_part('hour'::text, schedule_date.scdl_e_time)::text, 2, '0') AS ehour,";
		$sqlstr .= "lpad(date_part('minutes'::text, schedule_date.scdl_e_time)::text, 2, '0') AS emin,";
		$sqlstr .= "date_part('month'::text, schedule_date.scdl_date)::text || '/' || date_part('day'::text, schedule_date.scdl_date)::text AS scdl_s_date,";
		$sqlstr .= "date_part('month'::text, schedule_date.scdl_date)::text || '/' || date_part('day'::text, schedule_date.scdl_date)::text AS scdl_e_date,";
		$sqlstr .= "schedule2.scdl_plan,";
		$sqlstr .= "schedule2.scdl_place,";
		$sqlstr .= "schedule2.flg_pub, ";
		$sqlstr .= "schedule2.flg_out ";
		$sqlstr .= "FROM schedule2, wiz_event_member, schedule_date ";

		$sqlstr .= "WHERE schedule2.schedule_cd = wiz_event_member.schedule_cd";
		$sqlstr .= " AND schedule2.schedule_cd = schedule_date.schedule_cd";
		$sqlstr .= " AND schedule_date.schedule_date_cd = wiz_event_member.schedule_date_cd";
		$sqlstr .= " AND (('$dateStr' <= schedule_date.scdl_date AND schedule_date.scdl_date <= '$dateStr')";
		$sqlstr .= " OR ('$dateStr' <= schedule_date.scdl_date AND schedule_date.scdl_date <= '$dateStr')";
		$sqlstr .= " OR ('$dateStr' > schedule_date.scdl_date AND schedule_date.scdl_date > '$dateStr'))";
		$sqlstr .= " AND wiz_event_member.emp_cd = '" . $emp_cd . "' ";
		$sqlstr .= " AND wiz_event_member.enable = '1'";
		$sqlstr .= " AND schedule2.flg_del = 'f' ";
		$sqlstr .= "ORDER BY schedule_date.scdl_date,schedule_date.scdl_s_time;";

		return $sqlstr;
	}

	function selectWorkflowNextoddMst_WflowEmployeeInformation($targetCategory, $division, $targetEmployee, $admin, $A_PHP_AUTH_USER,$orderColumn,$sortForRev)
	{
		$sqlstr = "SELECT nextodd.petition_time AS petition_time,nextodd.emp_cd AS petition_emp_cd,";
		$sqlstr .= "workflow.petition_cd AS petition_cd, ";
		$sqlstr .= "mst_wflow.petition_name AS petition_name,";
		$sqlstr .= "employee.last_name_j||employee.first_name_j AS name ";
		$sqlstr .= "FROM workflow,nextodd,mst_wflow,employee ";
		$sqlstr .= "WHERE workflow.emp_cd = employee.emp_cd ";
		$sqlstr .= "AND workflow.petition_time = nextodd.petition_time ";
		$sqlstr .= "AND workflow.petition_cd = mst_wflow.petition_cd ";
		$sqlstr .= "AND workflow.ngflg = 'f' ";

		// ƥΤwhereɲ
		if ($targetCategory != "")
		{
			if ($targetCategory != "all")
			{
				$sqlstr .= "AND workflow.petition_cd = '" . $targetCategory . "' ";
			}
		}

		// ϿԤΤwhereɲ
		if ($targetEmployee != "" && $targetEmployee != "all")
		{
			$sqlstr .= "AND employee.emp_cd = '" . $targetEmployee . "' ";
		}
		else
		{
			// Τwhereɲ
			if ($division != "" && $division != "all")
			{
				$sqlstr .= "AND employee.division = '" . $division . "' ";
			}
		}

		// ԤƤηۤǽʰ
		if ($admin <= 0)
		{
			$sqlstr .= "AND nextodd.emp_cd = '$A_PHP_AUTH_USER' ";
		}

		switch($sortForRev) {
			case "KOUJUN":
				$sortForRev = " DESC";
				break;
			case "SHOUJUN":
				$sortForRev = "";
			default:
				break;
		}
		if($orderColumn == "name"){
			$orderColumn = "employee.last_name_j || employee.first_name_j";
		}

		$sqlstr .= "ORDER BY $orderColumn $sortForRev;";

		return $sqlstr;
	}

	function selectWorkflowEmployeeMst_WflowInformationWithPetitionTime($petition_time){
	//flowpetit.php 649
	//pg/myʬɬפ
		$sqlstr = "SELECT (date_part('year',workflow.petition_time)::text || '-' || ";
		$sqlstr .= "lpad(date_part('month',workflow.petition_time)::text, 2, '0') || '-' || ";
		$sqlstr .= "lpad(date_part('day',workflow.petition_time)::text, 2, '0') || ' ' || ";
		$sqlstr .= "lpad(date_part('hour',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('minute',workflow.petition_time)::text, 2, '0') || ':' || ";
		$sqlstr .= "lpad(date_part('second',workflow.petition_time)::text, 2, '0')) AS petition_time,";
		$sqlstr .= "workflow.emp_cd,workflow.petition_cd,workflow.oddtime,";
		$sqlstr .= "workflow.oddall,workflow.time_begin,workflow.time_end,workflow.purpose,workflow.detail,";
		$sqlstr .= "workflow.etc,workflow.ammount,workflow.ngflg,workflow.endflg,workflow.remark,";
		$sqlstr .= "workflow.filename,workflow.delflg,";
		$sqlstr .= "date_part('year',time_begin)::text AS byear,";
		$sqlstr .= "date_part('month',time_begin)::text AS bmonth,";
		$sqlstr .= "date_part('day',time_begin)::text AS bday,";
		$sqlstr .= "date_part('hour',time_begin)::text AS bhour,";
		$sqlstr .= "date_part('minute',time_begin)::text AS bmin,";
		$sqlstr .= "date_part('year',time_end)::text AS eyear,";
		$sqlstr .= "date_part('month',time_end)::text AS emonth,";
		$sqlstr .= "date_part('day',time_end)::text AS eday,";
		$sqlstr .= "date_part('hour',time_end)::text AS ehour,";
		$sqlstr .= "date_part('minute',time_end)::text AS emin,";
		$sqlstr .= "employee.last_name_j || first_name_j AS name,";
		$sqlstr .= "mst_wflow.petition_name,mst_wflow.petition_type AS petition_type ";
		$sqlstr .= "FROM workflow,employee,mst_wflow ";
		$sqlstr .= "WHERE workflow.petition_time = '$petition_time' ";
		$sqlstr .= "AND workflow.emp_cd = employee.emp_cd ";
		$sqlstr .= "AND workflow.petition_cd = mst_wflow.petition_cd;";
		return $sqlstr;
	}

	function selectNextOddCountWithEmp_cdPetition_cd($A_PHP_AUTH_USER, $subStrings)
	{
		$this->argumentCheck("PHP_AUTH_USER", $_SERVER["PHP_AUTH_USER"]);

		$sqlstr = "select count(*) as count_of_records from nextodd ";
		$sqlstr .= "where emp_cd ='$A_PHP_AUTH_USER' ";
		$sqlstr .= "and petition_time not in ";
		$sqlstr .= "(select petition_time from workflow ";
		$sqlstr .= "where ngflg = 't');";

		return $sqlstr;
	}

	function selectTantouMaxOfSeq(){
	//client_list.php 108
		return "SELECT max(int4(rtrim(seq))) as max_of_field FROM tantou;";
	}

	function selectTori_PlaceMaxOfBashoCodeWithToriCode($Sel){
		return "SELECT max(int4(bashocode)) as max_of_field FROM tori_place WHERE toricode = '$Sel';";
	}

	function selectTorihikisakiMaxOfToriCode(){
	//client_list.php 172
		return "SELECT max(int4(toricode)) as max_of_field FROM torihikisaki;";
	}


	function selectDivisionEmployeeEmpCdNameSortedSortNo()
	{
		return "SELECT division,emp_cd,last_name_j||first_name_j AS name FROM employee ORDER BY sort_no;";
	}


	function selectDivisionEmployeeEmpCdNameMobileUserSortedSortNo()
	{
	    $strSql  = " SELECT";
	    $strSql .= " 	division,";
	    $strSql .= " 	emp_cd,";
	    $strSql .= " 	last_name_j||first_name_j AS name";
	    $strSql .= " FROM";
	    $strSql .= " 	employee";
	    $strSql .= " WHERE";
	    $strSql .= " 	mobileMailAddress <> ''";
	    $strSql .= " ORDER BY";
	    $strSql .= " 	sort_no;";
	    $strSql .= " ";
		return $strSql;
	}

	function selectTableList($relationTableName)
	{
		return "SELECT relname FROM pg_class WHERE relname = '$relationTableName'";
	}

	function getTableListColumnName()
	{
		return "relname";
	}


// Divisin۲νȰ̾
//2004.08
//PgSqlMySqlΩƤȤ
	function selectEmployeeNameWithDivision($div_cd){
	//divisionEmpWindow.php 63
		$this->argumentCheck("div_cd", $div_cd);
		$sqlstr = "SELECT last_name_j || first_name_j as emp_Name ";
		$sqlstr .= " FROM employee ";
		$sqlstr .= " WHERE division = '$div_cd' ";
		$sqlstr .= "   AND retire_date IS NULL ";
//	    $strstr .= "   AND unify = 'f' ";
		$sqlstr .= " ORDER BY sort_no; ";
		return $sqlstr;
	}

	/**
	 * 塼TEMPơ֥뤫ꤵ줿֤Υǡ
	 * @author maiko mikami
	 * @since 1.4 2005/05/17
	 */
	function selectTmpEventMember_ListData($owner_emp_cd, $enable){
		//2005/06/23 tani CONCATؿpostgreSQLǻѤǤʤΤǽ񤭴
//		$sqlstr = "SELECT DISTINCT employee.division, tmp_event_member.emp_cd, concat(employee.last_name_j, employee.first_name_j) AS emp_name ";
		$sqlstr = "SELECT DISTINCT employee.division, tmp_event_member.emp_cd, employee.last_name_j || employee.first_name_j AS emp_name, employee.sort_no ";
		$sqlstr .= " FROM tmp_event_member, employee";
		$sqlstr .= " WHERE tmp_event_member.emp_cd = employee.emp_cd";
		$sqlstr .= " AND tmp_event_member.owner_emp_cd = '$owner_emp_cd'";
		$sqlstr .= " AND tmp_event_member.enable = '$enable'";
                $sqlstr .= " ORDER BY employee.sort_no asc, emp_name asc;";
		return $sqlstr;
	}

	/**
	 * 塼TEMPơ֥뤫ꤵ줿ְʳΥǡ
	 * @author maiko mikami
	 * @since 1.4 2005/05/17
	 */
	function selectTmpEventMember_ListDataNotEqual($owner_emp_cd, $enable){
		//2005/06/23 tani CONCATؿpostgreSQLǻѤǤʤΤǽ񤭴
//		$sqlstr = "SELECT DISTINCT employee.division, tmp_event_member.emp_cd, CONCAT(employee.last_name_j, employee.first_name_j) AS emp_name ";
		$sqlstr = "SELECT DISTINCT employee.division, tmp_event_member.emp_cd, employee.last_name_j || employee.first_name_j AS emp_name ";
		$sqlstr .= " FROM tmp_event_member, employee";
		$sqlstr .= " WHERE tmp_event_member.emp_cd = employee.emp_cd";
		$sqlstr .= " AND tmp_event_member.owner_emp_cd = '$owner_emp_cd'";
		$sqlstr .= " AND tmp_event_member.enable != '$enable';";
		return $sqlstr;
	}

	/**
	 * 塼վ
	 * @author 潨 
	 * @since 1.4 - 2005/05/22
	 */
	function selectScheduleDate($schedule_cd, $schedule_date_cd_array){
		
		$sqlstr = "SELECT  ";
/* mysql4.0ޤ
		$sqlstr .= "	lpad(EXTRACT(YEAR FROM concat(schedule_date.scdl_date,ifnull(schedule_date.scdl_s_time,'00:00:00'))), 4, '0') AS year, ";
		$sqlstr .= "	lpad(EXTRACT(MONTH FROM concat(schedule_date.scdl_date,ifnull(schedule_date.scdl_s_time,'00:00:00'))), 2, '0') AS month, ";
		$sqlstr .= "	lpad(EXTRACT(DAY FROM concat(schedule_date.scdl_date,ifnull(schedule_date.scdl_s_time,'00:00:00'))), 2, '0') AS day, ";
 */
		$sqlstr .= "	lpad(EXTRACT(YEAR FROM schedule_date.scdl_date)::text, 4, '0') AS year, ";
		$sqlstr .= "	lpad(EXTRACT(MONTH FROM schedule_date.scdl_date)::text, 2, '0') AS month, ";
		$sqlstr .= "	lpad(EXTRACT(DAY FROM schedule_date.scdl_date)::text, 2, '0') AS day, ";

/* 2005.06.23 tani PostgreSqlǤconcatѤǤʤὤ
		$sqlstr .= "	lpad(EXTRACT(HOUR FROM concat(schedule_date.scdl_date,schedule_date.scdl_s_time)), 2, '0') AS shour, ";
		$sqlstr .= "	lpad(EXTRACT(MINUTE FROM concat(schedule_date.scdl_date,schedule_date.scdl_s_time)), 2, '0') AS smin, ";
		$sqlstr .= "	lpad(EXTRACT(HOUR FROM concat(schedule_date.scdl_date,schedule_date.scdl_e_time)), 2, '0') AS ehour, ";
		$sqlstr .= "	lpad(EXTRACT(MINUTE FROM concat(schedule_date.scdl_date,schedule_date.scdl_e_time)), 2, '0') AS emin, ";
*/
		$sqlstr .= "	lpad(EXTRACT(HOUR FROM schedule_date.scdl_s_time)::text, 2, '0') AS shour, ";
		$sqlstr .= "	lpad(EXTRACT(MINUTE FROM schedule_date.scdl_s_time)::text, 2, '0') AS smin, ";
		$sqlstr .= "	lpad(EXTRACT(HOUR FROM schedule_date.scdl_e_time)::text, 2, '0') AS ehour, ";
		$sqlstr .= "	lpad(EXTRACT(MINUTE FROM schedule_date.scdl_e_time)::text, 2, '0') AS emin, ";

		$sqlstr .= "	schedule_cd, ";
		$sqlstr .= "	schedule_date_cd ";
		$sqlstr .= " FROM schedule_date ";
		$sqlstr .= " WHERE schedule_cd = " . $schedule_cd;
		$sqlstr .= "	AND schedule_date_cd in (";
		foreach($schedule_date_cd_array as $key => $value){
			$sqlstr .= $value . ",";
		}
		$sqlstr = rtrim($sqlstr, ",");
		$sqlstr .= ") ";
		$sqlstr .= "ORDER BY schedule_date.scdl_date, schedule_date.scdl_s_time, schedule_date.scdl_e_time;";	
	//whiteboard1.php 334
	//pg/myʬޤ

		return $sqlstr;
	}

	/**
	 * 塼վ
	 * @author 潨 
	 * @since 1.4 - 2005/05/22
	 */
	function selectAllScheduleDate($schedule_cd){
		$sqlstr = "SELECT  ";
/* mysql4.0ޤ
		$sqlstr .= "	lpad(EXTRACT(YEAR FROM concat(schedule_date.scdl_date,ifnull(schedule_date.scdl_s_time,'00:00:00'))), 4, '0') AS year, ";
		$sqlstr .= "	lpad(EXTRACT(MONTH FROM concat(schedule_date.scdl_date,ifnull(schedule_date.scdl_s_time,'00:00:00'))), 2, '0') AS month, ";
		$sqlstr .= "	lpad(EXTRACT(DAY FROM concat(schedule_date.scdl_date,ifnull(schedule_date.scdl_s_time,'00:00:00'))), 2, '0') AS day, ";

 */
		$sqlstr .= "	lpad(EXTRACT(YEAR FROM schedule_date.scdl_date)::text, 4, '0') AS year, ";
		$sqlstr .= "	lpad(EXTRACT(MONTH FROM schedule_date.scdl_date)::text, 2, '0') AS month, ";
		$sqlstr .= "	lpad(EXTRACT(DAY FROM schedule_date.scdl_date)::text, 2, '0') AS day, ";

/* 2005.06.23 tani PostgreSqlǤconcatѤǤʤὤ
		$sqlstr .= "	lpad(EXTRACT(HOUR FROM concat(schedule_date.scdl_date,schedule_date.scdl_s_time)), 2, '0') AS shour, ";
		$sqlstr .= "	lpad(EXTRACT(MINUTE FROM concat(schedule_date.scdl_date,schedule_date.scdl_s_time)), 2, '0') AS smin, ";
		$sqlstr .= "	lpad(EXTRACT(HOUR FROM concat(schedule_date.scdl_date,schedule_date.scdl_e_time)), 2, '0') AS ehour, ";
		$sqlstr .= "	lpad(EXTRACT(MINUTE FROM concat(schedule_date.scdl_date,schedule_date.scdl_e_time)), 2, '0') AS emin, ";
*/
		$sqlstr .= "	lpad(EXTRACT(HOUR FROM schedule_date.scdl_s_time)::text, 2, '0') AS shour, ";
		$sqlstr .= "	lpad(EXTRACT(MINUTE FROM schedule_date.scdl_s_time)::text, 2, '0') AS smin, ";
		$sqlstr .= "	lpad(EXTRACT(HOUR FROM schedule_date.scdl_e_time)::text, 2, '0') AS ehour, ";
		$sqlstr .= "	lpad(EXTRACT(MINUTE FROM schedule_date.scdl_e_time)::text, 2, '0') AS emin, ";
		
		$sqlstr .= "	schedule_cd, ";
		$sqlstr .= "	schedule_date_cd ";
		$sqlstr .= " FROM schedule_date ";
		$sqlstr .= " WHERE schedule_cd = " . $schedule_cd;
		$sqlstr .= " ORDER BY schedule_date.scdl_date, schedule_date.scdl_s_time, schedule_date.scdl_e_time;"; 

	//whiteboard1.php 334
	//pg/myʬޤ

//		$this->argumentCheck("emp_cd", $emp_cd);

//		pg
//		$sqlstr = "SELECT lpad(date_part('hour'::text, datetime(scdl_date, scdl_s_time)), 2, '0') AS shour , ";
//		$sqlstr .= "lpad(date_part('minutes'::text, datetime(scdl_date, scdl_s_time))::text, 2, '0') AS smin , ";
//		$sqlstr .= "lpad(date_part('hour'::text, datetime(scdl_date, scdl_e_time))::text, 2, '0') AS ehour , ";
//		$sqlstr .= "lpad(date_part('minutes'::text, datetime(scdl_date, scdl_e_time))::text, 2, '0') AS emin , ";

//		my
//		$sqlstr = "SELECT lpad(EXTRACT(HOUR FROM TIMESTAMP concat(scdl_date,scdl_s_time)), 2, '0') AS shour , ";
//		$sqlstr .= "lpad(EXTRACT(MINUTE FROM TIMESTAMP concat(scdl_date,scdl_s_time)), 2, '0') AS smin , ";
//		$sqlstr .= "lpad(EXTRACT(HOUR FROM TIMESTAMP concat(scdl_date,scdl_e_time)), 2, '0') AS ehour , ";
//		$sqlstr .= "lpad(EXTRACT(MINUTE FROM TIMESTAMP concat(scdl_date,scdl_e_time)), 2, '0') AS emin , ";

//		$sqlstr .= "* FROM schedule ";
//		$sqlstr .= "WHERE scdl_date = 'now'::date ";
//		$sqlstr .= "AND emp_cd = '" . $emp_cd . "' ";
//		$sqlstr .= "AND flg_del = 'f' ";
//		$sqlstr .= "AND flg_pub = 't' ";
//		$sqlstr .= "ORDER BY scdl_s_time ;";

		return $sqlstr;
	}
}

?>
