<?php
/**
 * SQL饹 PostgreSQL
 **/

include_once($_ROOT_DIR_ . "class/DBSqlPgsql.php");

class DBSqlPgsqlForTask extends DBSqlPgsql
{
  function DBSqlPgsqlForTask()
  {
  }

  function selectMonthScheduleTaskList($emp_cd, $startYear, $startMonth, $startDay, $endYear, $endMonth, $endDay)
  {
    $strsql = <<<EOF
      SELECT task.category_cd,
        task.sub_category_cd,
        task.group_cd,
        task.task_cd,
        task.title,
        task.description,
        date_part('year'::text, task.plan_end_date) AS peyear,
        lpad(date_part('month'::text, task.plan_end_date)::text, 2, '0') AS pemonth,
        lpad(date_part('day'::text, task.plan_end_date)::text, 2,'0') AS peday,
        lpad(date_part('hour'::text, task.plan_end_time)::text, 2, '0') AS pehour,
        lpad(date_part('minutes'::text, task.plan_end_time)::text, 2, '0') AS peminutes,
        task.owner_emp_cd,
        task.regist_emp_cd,
        task.status,
        task.schedule_flg
      FROM task
      WHERE
            task.owner_emp_cd = '$emp_cd'
        AND task.plan_end_date >= '$startYear-$startMonth-$startDay'
        AND task.plan_end_date <= '$endYear-$endMonth-$endDay'
        AND task.schedule_flg = 't'
      ORDER BY
        plan_end_date, plan_end_time;
EOF;
    return $strsql; 
  }
  function countCategoryWithGroupCd($group_cd)
  {
    $strsql = <<<EOF
      SELECT 
        COUNT(1) AS num_cat
      FROM 
        task_category
      WHERE
        group_cd = '$group_cd';
EOF;
    
    return $strsql;

  }
}

?>
