<?php
//
// Copyright (C) 2001-2002 System Consultants Co.,Ltd. All Rights Reserved.
//
// $Id: dateinfo.php 1023 2002-12-20 05:34:03Z yu-ji $
//

/**
 * վ󥯥饹
 *
 * @author hiroki KAWAMURA <hiroki@syscon.co.jp>
 * @author yuji TAKAHASHI <yu-ji@syscon.co.jp>
 */



class dateInfo
{
	// PHPLib Session
	var $classname = "dateInfo";
	var $persistent_slots = array("dateTime",
								"dateData",
								"timeData",
								"year",
								"month",
								"day",
								"hour",
								"minute",
								"second",
								"dateNameArray");

	var $dateTime;		// 
	var $dateData;		// 
	var $timeData;		// 

	var	$year;			// ǯ
	var $month;			// 
	var $day;			// 
	var $hour;			// 
	var $minute;		// ʬ
	var $second;		// 

	var $dateNameArray;	// ̾
	var $holidayName;	// ̾


	// 󥹥ȥ饯
	function dateInfo()
	{
		// ߤդ򥻥åȤ
		$nowDateArray = $this->getNowDate();
		$this->setYear($nowDateArray[0]);
		$this->setMonth($nowDateArray[1]);
		$this->setDay($nowDateArray[2]);

		$this->dateNameArray = array("", "", "", "", "", "", "");
	}

	// ̾μ
	function getHolidayName($conn, $dbSqlObj, $dbExecObj)
	{
		$tmpDate = $this->getYear() . "/" . $this->getMonth() . "/" . $this->getDay();
		if ($tmpDate != "//")
		{
			$strSql = $dbSqlObj->selectHolidayAllWithHDateSortedHDate($tmpDate,$tmpDate);
			$result = $dbExecObj->exeSql($conn, $strSql);
			if (!$result)
			{
				echo "can't connect to DB";
				exit;
			}

			if ($dbExecObj->getNumRows($result) == 0)
			{
				$tmpString = "";
			}
			else
			{
				$tmpString = $dbExecObj->getResult($result, 0, "hname");
			}

			$this->holidayName = $tmpString;
		}
		return $this->holidayName;
	}

	// μ
	function getDateTime()
	{
		return $this->dateTime;
	}

	// 
	function setDateTime($dateTime)
	{
		$this->dateTime = $dateTime;

		if ($dateTime != "")
		{
			// ʬ䤷
			$splitDateTime = split("[/- :+]", $dateTime, 6);

			$this->setYear($splitDateTime[0]);
			$this->setMonth($splitDateTime[1]);
			$this->setDay($splitDateTime[2]);
			$this->setHour($splitDateTime[3]);
			$this->setMinute($splitDateTime[4]);
			$this->setSecond($splitDateTime[5]);
		}
		else
		{
			$this->setYear("");
			$this->setMonth("");
			$this->setDay("");
			$this->setHour("");
			$this->setMinute("");
			$this->setSecond("");
		}
	}


	// դμ
	function getDateData()
	{
		return $this->dateData;
	}

	// դ
	function setDateData($dateData)
	{
		$this->dateData = $dateData;

		if ($dateData != "")
		{
			// դʬ䤷
			$splitDate = split("[/-]", $dateData, 3);

			$this->setYear($splitDate[0]);
			$this->setMonth($splitDate[1]);
			$this->setDay($splitDate[2]);
		}
		else
		{
			$this->setYear("");
			$this->setMonth("");
			$this->setDay("");
		}
	}


	// μ
	function getTimeData()
	{
		return $this->timeData;
	}

	// 
	function setTimeData($timeData)
	{
		$this->timeData = $timeData;

		if ($timeData != "")
		{
			// ʬ䤷
			$splitTime = split(":", $timeData, 2);

			$this->setHour($splitTime[0]);
			$this->setMinute($splitTime[1]);
		}
		else
		{
			$this->setHour("");
			$this->setMinute("");
		}
	}


	// yearμ
	function getYear()
	{
		return $this->year;
	}

	// year
	function setYear($year)
	{
		$this->year = $year;
	}

	// monthμ
	function getMonth()
	{
		return $this->month;
	}

	// month
	function setMonth($month)
	{
		$this->month = $month;
	}

	// dayμ
	function getDay()
	{
		return $this->day;
	}

	// day
	function setDay($day)
	{
		$this->day = $day;
	}

	// hourμ
	function getHour()
	{
		return $this->hour;
	}

	// hour
	function setHour($hour)
	{
		$this->hour = $hour;
	}

	// minuteμ
	function getMinute()
	{
		return $this->minute;
	}

	// minute
	function setMinute($minute)
	{
		$this->minute = $minute;
	}

	// secondμ
	function getSecond()
	{
		return $this->second;
	}

	// hour
	function setSecond($second)
	{
		$this->second = $second;
	}


	// դμ
	function getNowDate()
	{
		$year = date("Y");
		$month = date("n");
		$day = date("j");

		$nowDateArray = array($year, $month, $day);

		return $nowDateArray;
	}

	// ǯդμ
	function getNextYear()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();

		$unixTime = mktime(0, 0, 0, $month, $day, $year + 1);

		$year = date("Y", $unixTime);
		$month = date("n", $unixTime);
		$day = date("j", $unixTime);

		$nextYearArray = array($year, $month, $day);

		return $nextYearArray;
	}

	// ǯդμ
	function getBeforeYear()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();

		$unixTime = mktime(0, 0, 0, $month, $day, $year - 1);

		$year = date("Y", $unixTime);
		$month = date("n", $unixTime);
		$day = date("j", $unixTime);

		$beforeYearArray = array($year, $month, $day);

		return $beforeYearArray;
	}

	// ηդμ
	function getNextMonth()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();
		$day = 1;

		$unixTime = mktime(0, 0, 0, $month + 1, $day, $year);

		$year = date("Y", $unixTime);
		$month = date("n", $unixTime);
		$day = date("j", $unixTime);

		$nextMonthArray = array($year, $month, $day);

		return $nextMonthArray;
	}

	// ηդμ
	function getBeforeMonth()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();
		$day = 1;

		$unixTime = mktime(0, 0, 0, $month - 1, $day, $year);

		$year = date("Y", $unixTime);
		$month = date("n", $unixTime);
		$day = date("j", $unixTime);

		$beforeMonthArray = array($year, $month, $day);

		return $beforeMonthArray;
	}


	// νդμ
	function getNextWeek()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();

		$unixTime = mktime(0, 0, 0, $month, $day, $year) + 24 * 60 * 60 * 7;

		$year = date("Y", $unixTime);
		$month = date("n", $unixTime);
		$day = date("j", $unixTime);

		$nextWeekArray = array($year, $month, $day);
		
		return $nextWeekArray;
	}

	// νդμ
	function getBeforeWeek()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();

		$unixTime = mktime(0, 0, 0, $month, $day, $year) - 24 * 60 * 60 * 7;

		$year = date("Y", $unixTime);
		$month = date("n", $unixTime);
		$day = date("j", $unixTime);

		$beforeWeekArray = array($year, $month, $day);
		
		return $beforeWeekArray;
	}


	// դμ
	function getNextDay()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();

		$unixTime = mktime(0, 0, 0, $month, $day, $year) + 24 * 60 * 60;

		$year = date("Y", $unixTime);
		$month = date("n", $unixTime);
		$day = date("j", $unixTime);

		$nextDayArray = array($year, $month, $day);
		
		return $nextDayArray;
	}

	// դμ
	function getBeforeDay()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();

		$unixTime = mktime(0, 0, 0, $month, $day, $year) - 24 * 60 * 60;

		$year = date("Y", $unixTime);
		$month = date("n", $unixTime);
		$day = date("j", $unixTime);

		$beforeDayArray = array($year, $month, $day);
		
		return $beforeDayArray;
	}


	// κǽդμ
	function getFirstWeek()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();

		$baseTime = mktime(0, 0, 0, $month, $day, $year);
		$firstDate = $baseTime - date("w", $baseTime) * 60 * 60 * 24;

		$year = date("Y", $firstDate);
		$month = date("n", $firstDate);
		$day = date("j", $firstDate);

		$firstWeekArray = array($year, $month, $day);
		
		return $firstWeekArray;

	}

	// κǸդμ
	function getLastWeek()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();

		$baseTime = mktime(0, 0, 0, $month, $day, $year);
		$lastDate = $baseTime + ((6 - date("w", $baseTime)) * 60 * 60 * 24);

		$year = date("Y", $lastDate);
		$month = date("n", $lastDate);
		$day = date("j", $lastDate);

		$lastWeekArray = array($year, $month, $day);
		
		return $lastWeekArray;

	}


	// κǽμ
	function getLastMonth()
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = 1;

		while (checkdate($month, $day, $year)) 
		{
			$day++;
		}
		$day--;

		$lastMonthArray = array($year, $month, $day);
		
		return $lastMonthArray;
	}


	// ̾μ
	function getDateName()
	{
		$baseTime = mktime(0, 0, 0, $this->month, $this->day, $this->year);
		$dateNumber = date("w", $baseTime);

		return $this->dateNameArray[$dateNumber];
	}


	// ֹμ
	// 0 =   6 = 
	function getDateNumber()
	{
		$baseTime = mktime(0, 0, 0, $this->month, $this->day, $this->year);
		$dateNumber = date("w", $baseTime);

		return $dateNumber;
	}


	// Y-mμ
	function getYM()
	{
		$month = sprintf("%02d", $this->getMonth());

		return $this->getYear() . "-" . $month;
	}

	// Y-m-dμ
	function getYMD()
	{
		$month = sprintf("%02d", $this->getMonth());
		$day = sprintf("%02d", $this->getDay());

		return $this->getYear() . "-" . $month . "-" . $day;
	}

	// m/dμ
	function getMD()
	{
		$month = sprintf("%d", $this->getMonth());
		$day = sprintf("%d", $this->getDay());

		return $month . "/" . $day;
	}

	// ư
	// +XXʤ
	// -XX
	function moveDay($days)
	{
		$year = $this->getYear();
		$month = $this->getMonth();
		$day = $this->getDay();

		$unixTime = mktime(0, 0, 0, $month, $day, $year) + 24 * 60 * 60 * $days;

		$this->setYear(date("Y", $unixTime));
		$this->setMonth(date("n", $unixTime));
		$this->setDay(date("j", $unixTime));
	}


	// Ĥǯ顢δ֤
	function getDayDifference($fromYear, $fromMonth, $fromDay, $toYear, $toMonth, $toDay)
	{
		// ǽǯȺǸǯƱϽ
		if ($fromYear != $toYear)
		{
			// ǽǯϤ뤦ǯ
			$isLeap = date("L", mktime(0, 0, 0, 1, 1, $fromYear));

			// ǽǯǯ֤ѻ
			$daysSum =date("z", mktime(0, 0, 0, $fromMonth, $fromDay, $toYear));

			//뤦ǯä顢366ǯ֤ѻ뤦ǯǤʤ365
			if ($isLeap == 1)
			{
				$dayDifference = 366 - $daysSum;
			}
			else
			{
				$dayDifference = 365 - $daysSum;
			}

			//2ǯܤǸǯǯޤǤϡ365366­Ƥ
			for ($i = ($fromYear + 1); $i <= ($toYear - 1) ; $i++)
			{
				if (date("L", mktime(0, 0, 0, 1, 1, $i)) == 0) 
				{
					$dayDifference += 365;
				}
				else
				{
					$dayDifference += 366;
				} 
			}

			//Ǹǯǯѻ­
			$dayDifference += date("z", mktime(0, 0, 0, $toMonth, $toDay, $toYear));
		}
		//ǽǯȺǸǯƱξ硢ǯѻκ$dayDifferenceˤ
		else 
		{
			$dayDifference = date("z", mktime(0, 0, 0, $toMonth, $toDay, $toYear)) - date("z", mktime(0, 0, 0, $fromMonth, $fromDay, $fromYear));
		}

		return $dayDifference;
	}

}

?>
