<?php
//
// Copyright (C) 2001-2002 System Consultants Co.,Ltd. All Rights Reserved.
//
// $Id: employeeinfoowner.php 1294 2005-07-27 06:22:33Z admin $
//

/**
 * Ұ饹
 *
 * @author hiroki KAWAMURA <hiroki@syscon.co.jp>
 * @author yuji TAKAHASHI <yu-ji@syscon.co.jp>
 */



class EmployeeInfoOwner
{
	var	$employeeInfoArray;			// Ұ
//	var $execSql;					// ExecSql饹
	var $emp_cd;					// Ұֹ
	var $division;					// 
	var $admin;						// Ԥɤ
	var $excludeUnify;				// 桼

	// 󥹥ȥ饯
	function EmployeeInfoOwner()
	{
//		$this->execSql = new ExecSql();
		$this->employeeInfoArray = array();

		$this->excludeUnify = False;
	}

	// employeeInfoArrayμ
	function getEmployeeInfoArray()
	{
		return $this->employeeInfoArray;
	}

	// emp_cd
	function setEmp_cd($emp_cd)
	{
		$this->emp_cd = $emp_cd;
	}

	// emp_cdμ
	function getEmp_cd()
	{
		return $this->emp_cd;
	}

	// division
	function setDivision($division)
	{
		$this->division = $division;
	}

	// divisionμ
	function getDivision()
	{
		return $this->division;
	}

	// admin
	function setAdmin($admin)
	{
		$this->admin = $admin;
	}

	// adminμ
	function isAdmin()
	{
		return $this->admin;
	}

	// excludeUnify
	function setExcludeUnify($excludeUnify)
	{
		$this->excludeUnify = $excludeUnify;
	}

	// excludeUnifyμ
	function isExcludeUnify()
	{
		return $this->excludeUnify;
	}


	// SelectSQLμ¹
	function doSelectQuery($conn, $dbSqlObj, $dbExecObj)
	{
//
//		$sqlStr = "SELECT employee.emp_cd,employee.last_name_j || employee.first_name_j AS name,(SELECT COUNT(*) FROM administrators WHERE administrators.emp_cd = employee.emp_cd) AS admin FROM employee";
//
//		// оݼҰ
//		if ($this->getDivision() == "all")
//		{
//			$sqlPrerequisiteStr = "";
//		}
//		else if ($this->getEmp_cd() != "" && $this->getDivision() != "")
//		{
//			$sqlPrerequisiteStr = " WHERE employee.emp_cd = '" . $this->getEmp_cd() . "' OR employee.division = '" . $this->getDivision() . "'";
//		}
//		else if ($this->getEmp_cd() != "")
//		{
//			$sqlPrerequisiteStr = " WHERE employee.emp_cd = '" . $this->getEmp_cd() . "'";
//		}
//		else if ($this->getDivision() != "")
//		{
//			$sqlPrerequisiteStr = " WHERE employee.division = '" . $this->getDivision() . "'";
//		}
//
//		// Ⱦ
//		$sqlOrderStr = " ORDER BY employee.sort_no;";
//
//		// SQL¹
//		$this->execSql->doExecSql($conn, $sqlStr . $sqlPrerequisiteStr . $sqlOrderStr);

		if ($this->isExcludeUnify())
		{
			$strSql = $dbSqlObj->selectEmployeeInfoExcludeUnify($this->getDivision(), $this->getEmp_cd());
		}
		else
		{
			$strSql = $dbSqlObj->selectEmployeeInfo($this->getDivision(), $this->getEmp_cd());
		}
		$result = $dbExecObj->exeSql($conn, $strSql);

		// EmployeeInfoؤΥС
		$this->convertResult2EmployeeInfo($dbExecObj, $result);
	}

	// SelectSQL(桼Ƚ)μ¹
	function doSelectQueryUnify($conn, $dbSqlObj, $dbExecObj)
	{
		$strSql = $dbSqlObj->selectEmployeeInfoUnify($this->getEmp_cd());
		$result = $dbExecObj->exeSql($conn, $strSql);

		// EmployeeInfoؤΥС
		$this->convertUnifyResult2EmployeeInfo($dbExecObj, $result);
	}


	// resultEmployeeInfo˥С
	function convertResult2EmployeeInfo($dbExecObj, $result)
	{
		$employeeInfoArray = array();

		$numrows = $dbExecObj->getNumRows($result);

		for ($i = 0; $i < $numrows; $i++)
		{
			$employeeInfo = new EmployeeInfo();
			$employeeInfo->setEmp_cd($dbExecObj->getResult($result, $i, "emp_cd"));
			$employeeInfo->setName($dbExecObj->getResult($result, $i, "name"));
			$employeeInfo->setDivision($dbExecObj->getResult($result, $i, "division"));
			// SQLѹ١admin桼ξadminemp_cd
//			$employeeInfo->setAdmin($dbExecObj->getResult($result, $i, "admin") == "1" ? True : False);
			$employeeInfo->setAdmin($dbExecObj->getResult($result, $i, "admin") != "" ? True : False);
			$employeeInfoArray = $this->employeeInfoArray;
			$employeeInfoArray[$dbExecObj->getResult($result, $i, "emp_cd")] = $employeeInfo;
			$this->employeeInfoArray = $employeeInfoArray;
		}
	}

	// result(桼Ƚ)EmployeeInfo˥С
	function convertUnifyResult2EmployeeInfo($dbExecObj, $result)
	{
		$employeeInfoArray = array();

		$numrows = $dbExecObj->getNumRows($result);

		for ($i = 0; $i < $numrows; $i++)
		{
			$employeeInfo = new EmployeeInfo();
			$employeeInfo->setEmp_cd($dbExecObj->getResult($result, $i, "emp_cd"));
			$employeeInfo->setDivision($dbExecObj->getResult($result, $i, "division"));
			$employeeInfo->setUnify($dbExecObj->getResult($result, $i, "unify") == "t" ? True : False);

			$employeeInfoArray = $this->employeeInfoArray;
			$employeeInfoArray[$dbExecObj->getResult($result, $i, "emp_cd")] = $employeeInfo;
			$this->employeeInfoArray = $employeeInfoArray;
		}
	}
}

?>