#!/bin/csh -f

if (! $?PGDATA) then
    echo "Envirnment Variable PGDATA is not set."
    exit 1
endif
if (! -o $PGDATA) then
    echo "You are not PostgreSQL administrator."
    exit 1
endif
if (! -e /tmp/.s.PGSQL.5432) then
    echo "postmaster is not up."
    exit 1
endif
while (1)
        echo -n "Name your database.(default:masters) -> "
        set dbname = $<
        if ("$dbname" == "") then
            set dbname = "masters"
            break
        else
            echo "OK."
            break
        endif
end
while (1)
        echo -n "Name database username.(default:nobody) -> "
        set username = $<
        if ("$username" == "") then
            set username = "nobody"
            break
        else
            echo "OK."
            break
        endif
end
set curdir = `pwd`
    sed "s/nobody/$username/g" $curdir/task_manage_pgsql.sql \
     | psql -e $dbname

echo "******************************************************"
echo "***2004 (C)System Consultants Co.,Ltd.             ***"
echo "***                            All Rights Reserved.***"
echo "******************************************************"
exit 0
