<?php
//
// Copyright (C) 2001-2002 System Consultants Co.,Ltd. All Rights Reserved.
//
// $Id: databasecsv_employee.php 1226 2004-09-14 09:16:50Z hideki-h $
//

/**
 * ǡ١ؤϿ饹
 *
 * @author hiroki KAWAMURA <hiroki@syscon.co.jp>
 * @author yuji TAKAHASHI <yu-ji@syscon.co.jp>
 * @author hideki HARANAKA <hideki-h@syscon.co.jp> 
 */


// 
include_once($_ROOT_DIR_ . "admin/csvimport/class/databasecsv.php");

class DatabaseCsvEmployee extends DatabaseCsv
{
	// 󥹥ȥ饯
	function DatabaseEmployee()
	{
		$this->DatabaseCsv();
	}


	// DBϿ
	function doInsert($A_PHP_AUTH_USER)
	{
		$isError = False;

		// BEGIN
		$sql = $this->dbSqlObj->sqlBeginTrans();
		$result = $this->dbExecObj->exeSql($this->conn, $sql);
		if (!$result)
		{
			$this->errorInfoOwner->add("ǡ١顼:ȥ󥶥󤬳ϤǤޤǤ");
			return False;
		}

		// ݡȤǡ
		$importCsvData = $this->importCsvDataOwner->getImportCsvData();

		$count = count($importCsvData);

		for ($i = 0; $i < $count; $i++)
		{
			$sql = $this->dbSqlObj->selectEmployeeCountOfEmpCdWithEmpCd($importCsvData[$i]->arrayValue[0]);
			$result = $this->dbExecObj->exeSql($this->conn, $sql);
			if (!$result)
			{
				$this->errorInfoOwner->add("ǡ١顼:ݡTSVե" . $importCsvData[$i]->getLineNum() . "ܤemp_cd¸߳ǧǥ顼ȯޤ¹ԤSQL:" . $sql);
				$isError = True;
			}

			if ($this->dbExecObj->getResult($result, 0, "count_of_records") != 0)
			{
				$this->errorInfoOwner->add("ݡTSVե" . $importCsvData[$i]->getLineNum() . "ܤemp_cdϤǤϿƤޤ");
				$isError = True;
			}

			if ($importCsvData[$i]->arrayValue[24] == "t")
			{
				$sql = $this->dbSqlObj->selectUnifyCount();
				$result = $this->dbExecObj->exeSql($this->conn, $sql);
				if (!$result)
				{
					$this->errorInfoOwner->add("ǡ١顼:ݡTSVե" . $importCsvData[$i]->getLineNum() . "ܤ桼¸߳ǧǥ顼ȯޤ¹ԤSQL:" . $sql);
					$isError = True;
				}

				if ($this->dbExecObj->getResult($result, 0, "count_of_records") != 0)
				{
					$this->errorInfoOwner->add("ݡTSVե" . $importCsvData[$i]->getLineNum() . "ܤǡ桼ϤǤ¸ߤƤޤ");
					$isError = True;
				}
			}

			if (!$isError)
			{
				// Ͽ
				$sql = $this->dbSqlObj->insertCsv2Employee($importCsvData[$i]->arrayValue[0],
															crypt($importCsvData[$i]->arrayValue[1], $this->createDESSalt()),
															$importCsvData[$i]->arrayValue[2],
															$importCsvData[$i]->arrayValue[3],
															$importCsvData[$i]->arrayValue[4],
															$importCsvData[$i]->arrayValue[5],
															$importCsvData[$i]->arrayValue[6],
															$importCsvData[$i]->arrayValue[7],
															$importCsvData[$i]->arrayValue[8],
															$importCsvData[$i]->arrayValue[9],
															$importCsvData[$i]->arrayValue[10],
															$importCsvData[$i]->arrayValue[11],
															$importCsvData[$i]->arrayValue[12],
															$importCsvData[$i]->arrayValue[13],
															$importCsvData[$i]->arrayValue[14],
															$importCsvData[$i]->arrayValue[15],
															$importCsvData[$i]->arrayValue[16],
															$importCsvData[$i]->arrayValue[17],
															$importCsvData[$i]->arrayValue[18],
															$importCsvData[$i]->arrayValue[19],
															$importCsvData[$i]->arrayValue[20],
															$importCsvData[$i]->arrayValue[21],
															$importCsvData[$i]->arrayValue[22],
															$importCsvData[$i]->arrayValue[23],
															$importCsvData[$i]->arrayValue[24]
															);
				$result = $this->dbExecObj->exeSql($this->conn, $sql);
				if ($result)
				{
					// .htpasswdؤɲ
					system(escapeshellcmd("/home/nobody/mkhtpasswd.sh " . $importCsvData[$i]->arrayValue[0] . " " . crypt($importCsvData[$i]->arrayValue[1], $this->createDESSalt())));
				}
				else
				{
					$this->errorInfoOwner->add("ǡ١顼:ݡTSVե" . $importCsvData[$i]->getLineNum() . "ܤϿǥ顼ȯޤ¹ԤSQL:" . $sql);
					$isError = True;
				}
				// ԤܡɤؤϿ
				$emp_cd = $importCsvData[$i]->arrayValue[0];
				$sql = $this->dbSqlObj->insertWhiteboard($emp_cd,$A_PHP_AUTH_USER);
				$result = $this->dbExecObj->exeSql($this->conn, $sql);
				if (!$result)
				{
					$this->errorInfoOwner->add("ǡ١顼:WhiteboardؤϿǥ顼ȯޤ¹ԤSQL:" . $sql);
					$isError = True;
				}
			}
		}

		if ($isError)
		{
			// ROLLBACK
			$sql = $this->dbSqlObj->sqlRollBackTrans();
			$result = $this->dbExecObj->exeSql($this->conn, $sql);

			return False;
		}

		// COMMIT
		$sql = $this->dbSqlObj->sqlCommitTrans();
		$result = $this->dbExecObj->exeSql($this->conn, $sql);
		if (!$result)
		{
			$this->errorInfoOwner->add("ǡ١顼:ߥåȤǤޤǤ");

			// ROLLBACK
			$sql = $this->dbSqlObj->sqlRollBackTrans();
			$result = $this->dbExecObj->exeSql($this->conn, $sql);

			return False;
		}

		return True;
	}


	function createDESSalt()
	{
		mt_srand((double)microtime() * 1000000);

		$possible = "abcdefghijklmnopqrstuvwxyz";
		$str = "";
		while (strlen($str) < 2)
		{
			$str .= substr($possible, mt_rand(0, strlen($possible) - 1), 1);
		}

		return $str;
	}


}
?>