<?php
//
// Copyright (C) 2001-2002 System Consultants Co.,Ltd. All Rights Reserved.
//
// $Id: verification.php 1226 2004-09-14 09:16:50Z hideki-h $
//

/**
 * ơ֥ȥݡCSVǡӸڤ륯饹
 *
 * @author hiroki KAWAMURA <hiroki@syscon.co.jp>
 * @author yuji TAKAHASHI <yu-ji@syscon.co.jp>
 */



include_once($_ROOT_DIR_ . "admin/csvimport/class/errorinfoowner.php");
include_once($_ROOT_DIR_ . "admin/csvimport/class/table_definitionowner.php");
include_once($_ROOT_DIR_ . "admin/csvimport/class/importcsvdata_owner.php");
include_once($_ROOT_DIR_ . "admin/csvimport/class/databasecsv.php");


class Verification
{
	var $tableDefinitionOwner;		// ơ֥饹
	var $importCsvDataOwner;		// ݡȤCSVǡ饹
	var $databaseCsv;				// ǡ١饹

	var $tableDefinitionFileName;	// ơ֥եѥ
	var $importCsvFileName;			// ݡȤTSVեѥ

	var $delimiter;					// ǥߥ
	var $tableName;					// ơ֥̾

	var $conn;						// DBͥ
	var $dbSqlObj;					// SQL֥
	var $dbExecObj;					// Exec֥

	var $errorInfoOwner;			// 顼󥯥饹


	// 󥹥ȥ饯
	function Verification()
	{
		$this->errorInfoOwner = new ErrorInfoOwner();
		$this->tableDefinitionOwner = new TableDefinitionOwner();
		$this->importCsvDataOwner = new ImportCsvDataOwner();

		$this->delimiter = "\t";
	}


	// tableDefinitionOwnerμ
	function getTableDefinitionOwner()
	{
		return $this->tableDefinitionOwner;
	}

	// tableDefinitionOwner
	function setTableDefinitionOwner($tableDefinitionOwner)
	{
		$this->tableDefinitionOwner = $tableDefinitionOwner;
	}

	// importCsvDataμ
	function getImportCsvDataOwner()
	{
		return $this->importCsvDataOwner;
	}

	// importCsvDataOwner
	function setImportCsvDataOwner($importCsvDataOwner)
	{
		$this->importCsvDataOwner = $importCsvDataOwner;
	}

	// tableDefinitionFileNameμ
	function getTableDefinitionFileName()
	{
		return $this->tableDefinitionFileName;
	}

	// tableDefinitionFileName
	function setTableDefinitionFileName($tableDefinitionFileName)
	{
		$this->tableDefinitionFileName = $tableDefinitionFileName;
	}

	// importCsvFileNameμ
	function getImportCsvFileName()
	{
		return $this->importCsvFileName;
	}

	// importCsvFileName
	function setImportCsvFileName($importCsvFileName)
	{
		$this->importCsvFileName = $importCsvFileName;
	}

	// delimiterμ
	function getDelimiter()
	{
		return $this->delimiter;
	}

	// delimiter
	function setDelimiter($delimiter)
	{
		$this->delimiter = $delimiter;
	}

	// tableNameμ
	function getTableName()
	{
		return $this->tableName;
	}

	// tableName
	function setTableName($tableName)
	{
		$this->tableName = $tableName;
	}

	// connμ
	function getConn()
	{
		return $this->conn;
	}

	// conn
	function setConn($conn)
	{
		$this->conn = $conn;
	}

	// dbSqlObjμ
	function getDbSqlObj()
	{
		return $this->dbSqlObj;
	}

	// dbSqlObj
	function setDbSqlObj($dbSqlObj)
	{
		$this->dbSqlObj = $dbSqlObj;
	}

	// dbExecObjμ
	function getDbExecObj()
	{
		return $this->dbExecObj;
	}

	// dbExecObj
	function setDbExecObj($dbExecObj)
	{
		$this->dbExecObj = $dbExecObj;
	}


	// errorInfoμ
	function getErrorInfo()
	{
		return $this->errorInfo;
	}

	// errorInfo
	function setErrorInfo($errorInfo)
	{
		$this->errorInfo = $errorInfo;
	}


	// 
	function verify()
	{
		// ơ֥֥Ȥ
		$tableDefinitionTemp = $this->getTableDefinitionOwner();
		$tableDefinitionTemp->setTableDefinitionFileName($this->getTableDefinitionFileName());
		$tableDefinitionTemp->setDelimiter($this->getDelimiter());
		$tableDefinitionTemp->setTableName($this->getTableName());
		$tableDefinitionTemp->setConn($this->getConn());
		$tableDefinitionTemp->setDbSqlObj($this->getDbSqlObj());
		$tableDefinitionTemp->setDbExecObj($this->getDbExecObj());

		if (!$tableDefinitionTemp->analyze())
		{
			echo $tableDefinitionTemp->errorInfoOwner->outputAllErrorInfo();
			exit;
		}

		$this->setTableDefinitionOwner($tableDefinitionTemp);

		// ݡCSV֥Ȥ
		$importCsvDataTemp = $this->getImportCsvDataOwner();
		$importCsvDataTemp->setImportCsvFileName($this->getImportCsvFileName());
		$importCsvDataTemp->setDelimiter($this->getDelimiter());

		if (!$importCsvDataTemp->analyze())
		{
			echo $importCsvDataTemp->errorInfoOwner->outputAllErrorInfo();
			exit;
		}

		$this->setImportCsvDataOwner($importCsvDataTemp);

		// 
		if (!$this->compare())
		{
			echo $this->errorInfoOwner->outputAllErrorInfo();

			return False;
		}

		return True;
	}


	// 
	function compare()
	{
		$tableDefinitionTemp = $this->getTableDefinitionOwner();
		$tableDefinition = $tableDefinitionTemp->getTableDefinition();

		$importCsvDataTemp = $this->getImportCsvDataOwner();
		$importCsvData = $importCsvDataTemp->getImportCsvData();

		$isError = False;

		$countImportCsvData = count($importCsvData);

		for ($i = 0; $i < $countImportCsvData; $i++)
		{
			$countTableDefinition = count($tableDefinition);

			for ($k = 0; $k < $countTableDefinition; $k++)
			{
				// Կ, kܤΥΥǡ, kܤΥΥơ֥
				if (!$this->individualCompare($importCsvData[$i]->getLineNum(), $importCsvData[$i]->arrayValue[$k], $tableDefinition[$k], $i))
				{
					$isError = True;
				}
			}
		}

		if ($isError)
		{
			return False;
		}

		$importCsvDataTemp->setImportCsvData($importCsvData);
		$this->setImportCsvDataOwner($importCsvDataTemp);

		return True;
	}


	// ġΥǡθ
	// ȥơ֥뤬ä顢̾뤫åä餽Υɤ֤롣
	// ̵̾ä饨顼
	function individualCompare($lineNum, &$data, $definition, $dataNum)
	{
		$isError = False;

		$relationTableName = $definition->getRelationTableName();
		$columnName = $definition->getColumnName();

		if ($relationTableName != "")
		{
			if (!$this->isRelationDataExist($lineNum, $data, $definition, $dataNum))
			{
				$isError = True;
			}
		}

		// פΥå(ͤΤߤΥ)
		if (eregi("^integer$", $definition->getType()) || eregi("^smallint$", $definition->getType()))
		{
			if (ereg("[^0-9]", $data))
			{
				$this->errorInfoOwner->add("ݡTSVե" . $lineNum . "ܤΥ̾" . $columnName . "ͤϿͤΤߤǤ");
				$isError = True;
			}
		}

		// ĹΥå
		if ($definition->getLength() != "")
		{
			if ($definition->getLength() < strlen($data))
			{
				$this->errorInfoOwner->add("ݡTSVե" . $lineNum . "ܤΥ̾" . $columnName . "ĹǤ");
				$isError = True;
			}
		}

		// NotNullΥå
		if ($definition->isNotNull() == "t" || $definition->isNotNull() == "notnull")
		{
			if (0 == strlen($data))
			{
				$this->errorInfoOwner->add("ݡTSVե" . $lineNum . "ܤΥ̾" . $columnName . "Ǥ");
				$isError = True;
			}
		}

		if ($isError)
		{
			return False;
		}

		return True;
	}


	// ˥ǡ¸ߤ뤫å
	function isRelationDataExist($lineNum, &$data, $definition, $dataNum)
	{
		if (eregi("^(integer|smallint)$", $definition->getType()))
		{
			$isNumeric = True;
		}
		else
		{
			$isNumeric = False;
		}

		$sql = $this->dbSqlObj->selectFromRelationTable($data, $definition->getRelationTableName(), $definition->getRelationColumnCode(), $definition->getRelationColumnName(), $isNumeric);

		$result = $this->dbExecObj->exeSql($this->conn, $sql);

		if (!$result)
		{
			$this->errorInfoOwner->add("ݡTSVե" . $lineNum . "ܤΥ̾" . $definition->getColumnName() . "λΥǡ¸ߥåκݡǡ١顼ȯޤ¹ԤSQL:" . $sql);
			$isError = True;
		}

		if ($this->dbExecObj->getNumRows($result) == 0)
		{
			$this->errorInfoOwner->add("ݡTSVե" . $lineNum . "ܤΥ̾" . $definition->getColumnName() . "λǡ¸ߤޤǤ");
			$isError = True;
		}
		else
		{
			$data = $this->dbExecObj->getResult($result, 0, $columnName);
		}

		if ($isError)
		{
			return False;
		}

		return True;
	}


	// DBϿ
	function doInsert($A_PHP_AUTH_USER)
	{
//		echo "ǡ١Ͽ桦<br>\n";

		$this->databaseCsv->setImportCsvDataOwner($this->getImportCsvDataOwner());
		$this->databaseCsv->setConn($this->getConn());
		$this->databaseCsv->setDbSqlObj($this->getDbSqlObj());
		$this->databaseCsv->setDbExecObj($this->getDbExecObj());

		if (!$this->databaseCsv->doInsert($A_PHP_AUTH_USER))
		{
			echo $this->databaseCsv->errorInfoOwner->outputAllErrorInfo();
			return False;
		}

		return True;
	}

}
?>