<?php
//////////////////////////////////////////////////////////////////////////////
//																			//
//	 Copyright (C) 2000  Phorum Development Team							//
//	 http://www.phorum.org													//
//																			//
//	 This program is free software. You can redistribute it and/or modify	//
//	 it under the terms of either the current Phorum License (viewable at	//
//	 phorum.org) or the Phorum License that was distributed with this file	//
//																			//
//	 This program is distributed in the hope that it will be useful,		//
//	 but WITHOUT ANY WARRANTY, without even the implied warranty of			//
//	 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.					//
//																			//
//	 You should have received a copy of the Phorum License					//
//	 along with this program.												//
//////////////////////////////////////////////////////////////////////////////

//ѿ
$f = $_GET["f"];
$search = $_GET["search"];
$Submit = $_GET["Submit"];
$globalsearch = $_GET["globalsearch"];
$match = $_GET["match"];
$date = $_GET["date"];
$fldauthor = $_GET["fldauthor"];
$fldsubject = $_GET["fldsubject"];
$fldbody = $_GET["fldbody"];
$sub = $_GET["sub"];

include("../gw.php");
include_once($_ROOT_DIR_ . "class/PhraseSelect.php");
$objPhraseSelect = new PhraseSelect($bolPhraseSelect);
$varPhraseSet = $objPhraseSelect->getPhrase();

require "./common.php";

if ($num == 0 || $ForumName == '')
{
	header("Location: $forum_url/$forum_page.$ext?$GetVars");
	exit;
}

include "$include_path/read_functions.php";

/////////////////////////////////////////////////////////////////
// build the search terms array
// this will build the array to pass to build_sql()

function build_search_terms($search, $match)
{
	$terms = array();

	// if this is an exact phrase match
	if ($match == 3)
	{
		$terms[] = $search;
	}
	// not exact phrase, break up the terms
	else
	{
		if (strstr($search, '"'))
		{
			//first pull out all the double quoted strings
			if (strstr($search, "\""))
			{
				$search_string = $search;

				while (ereg('-*"[^"]*"', $search_string, $match))
				{
					$terms[] = trim(str_replace("\"", "", $match[0]));
					$search_string = substr(strstr($search_string, $match[0]), strlen($match[0]));
				}
			}

			$search = ereg_replace('-*"[^"]*"', '', $search );
		}

		//pull out the rest words in the string
		$regular_terms = explode( " ", $search);

		//merge them all together and return
		while (list ($key, $val) = each ($regular_terms))
		{
			if ($val != "")
			{
				$terms[] = trim($val);
			}
		}
	}

	return $terms;
}

/////////////////////////////////////////////////////////////////
// build the sql statement's where clause
// this will build the sql based on the given information

function build_terms_clause($terms, $date, $fields, $match)
{
	global $DB;
	static $where_clause;

	if (empty($where_clause))
	{
		if ($date != 0)
		{
			$cutoff = date("Y-m-d", mktime(0, 0, 0, date("m"), date("d") - $date));
			$where_clause .= " datestamp >= '$cutoff' AND ";
		}

		while (list ($junk, $_ENV["term"]) = each ($terms))
		{
			if (substr($_ENV["term"], 0, 1) == "-")
			{
				if(strstr($DB->type, "postgresql"))
				{
					$notmod = "!";
				}
				else
				{
					$notmod = "NOT ";
				}

				$_ENV["term"] = substr($_ENV["term"], 1);
			}
			else
			{
				$notmod = "";
			}

			reset($fields);
			unset($likeArray);

			while (list ($key, $val) = each ($fields))
			{
				$A_term = addslashes($_ENV["term"]);

				if (strstr($DB->type, "postgresql"))
				{
					$likeArray[] = " upper($val) $notmod" . "~~ upper('%$A_term%') ";
				}
				else
				{
					$likeArray[] = " $val $notmod" . "LIKE '%$A_term%' ";
				}
			}

			$termArray[] = " (" . implode( $likeArray, " OR " ) . ") ";
		}

		$cmptype = "AND";

		if ($match != 1)
		{
			$cmptype="OR";
		}

		$where_clause .= " (" . implode($termArray, " $cmptype ") . ") ";
		$where_clause .= "order by datestamp desc";
	}

	return $where_clause;

}

/////////////////////////////////////////////////////////////////
// build the sql statement
// this will build the sql based on the given information

function build_sql($table_name, $terms, $date, $fields, $match)
{
	global $ForumTableName;

	$SQL = "select $table_name.id, $table_name.thread, author, subject, datestamp, body from $table_name, $table_name" . "_bodies where $table_name.id = $table_name" . "_bodies.id and $table_name.approved='Y' AND";
	$SQL .= build_terms_clause($terms, $date, $fields, $match);

	return $SQL;
}

if (!isset($fldsubject) && !isset($fldbody))
{
	$fields[] = "subject";
	$fields[] = "body";
	$fldsubject = 1;
	$fldbody = 1;
}
else
{
	empty($fldsubject) ? $fldsubject=0 : $fields[] = "subject";
	empty($fldbody) ? $fldbody=0 : $fields[] = "body";
}

initvar("date", 30);
initvar("globalsearch");
initvar("match");
initvar("start", 1);

//////////////////////////
// START NAVIGATION			//
//////////////////////////

$menu = array();
if ($ActiveForums > 1)
{
	// Forum List
	addnav($menu, $lForumList, "$forum_page.$ext?f=$ForumParent$GetVars");
}

// New Topic
addnav($menu, $lStartTopic, "$post_page.$ext?f=$num$GetVars");

// Go To Top
addnav($menu, $lGoToTop, "$list_page.$ext?f=$num$GetVars");

// Log Out/Log In
if ($ForumSecurity)
{
	if (!empty($phorum_auth))
	{
		addnav($menu, $lLogOut, "login.$ext?logout=1$GetVars");
		addnav($menu, $lMyProfile, "profile.$ext?f=$f&id=$phorum_user[id]$GetVars");
	}
	else
	{
		addnav($menu, $lLogIn, "login.$ext?f=$f$GetVars");
	}
}

//$TopLeftNav = getnav($menu);
$TopLeftNav = getnav2($menu, "TopLeft");

//////////////////////////
// END NAVIGATION		//
//////////////////////////

if (empty($search))
{
	$search = "";
	$searchtext = "";
}
else
{
	$search = trim(stripslashes($search));
//		$searchtext = htmlentities($search);
	$searchtext = htmlspecialchars($search);
	$terms = build_search_terms($search, $match);

	if (count($terms) > 0)
	{
		if ($globalsearch)
		{
			$SQL = "Select id, name, table_name from $pho_main where";

			if (isset($searchforums))
			{
				$SQL .= " id in (" . implode(",", $searchforums) . ")";
			}
			else
			{
				$SQL .= " (active=1 or id=$num)";
			}

			if (empty($phorum_auth))
			{
				$SQL .= " and security!=" . SEC_ALL;
			}

			$q->query($DB, $SQL);
			$row = $q->getrow();
		}
		else
		{
			$row = array("id"=>$num, "name"=>$ForumName, "table_name"=>$ForumTableName);
		}

		$totalFound = 0;
		$messagesCopied = 0;
		$messages = array();

		while (is_array($row))
		{
			$forums[$row["id"]] = $row["name"];

			$SQL = build_sql($row["table_name"], $terms, $date, $fields, $match);
			$results[$row["id"]] = new query($DB, $SQL);
			$numrows=$results[$row["id"]]->numrows();

			if ($numrows == 0)
			{
				unset($results[$row["id"]]);
			}
			else
			{
				$results[$row["id"]]->getrow();
				$totalFound += $numrows;
			}

			if ($globalsearch)
			{
				$row = $q->getrow();
			}
			else
			{
				$row = 0;
			}
		}

		if ($globalsearch)
		{
			$q->free();
		}

		$winner = 1;
		$MessagesCopied = 0;
		$MessagesMatched = 0;

		while ($MessagesCopied < $ForumDisplay && $winner != 0)
		{
			$winner = 0;
			reset($results);
			$highdate = "";

			while (list($forum, $res) = each($results))
			{
				if (!empty($res->row))
				{
					if ($res->field("datestamp") > $highdate)
					{
						$highdate = $res->field("datestamp");
						$winner = $forum;
					}
				}
			}

			if ($winner != 0)
			{
				$MessagesMatched++;

				if ($MessagesMatched >= $start)
				{
					$MessagesCopied++;
					$row = $results[$winner]->row;
					$row["forum"] = $winner;
					$messages["$row[datestamp]-$winner-$row[id]"] = $row;
				}

				$results[$winner]->getrow();

				// if these match then there are no more rows in this result.
				if (empty($results[$winner]->row["id"]) || $row["id"]==$results[$winner]->row["id"])
				{
					unset($results[$winner]);
				}
			}
		}

	}
}

$sTitle = " " . strtolower($lSearch);

include phorum_get_file_name("header");

if (@is_array($terms))
{
?>
            </td>
            <td></td>
          </tr>

<?php echo $TopLeftNav; ?>


<?php
	$messagesTemp = $messages;

	$message = current($messagesTemp);
	$count = $start - 1;

	while (is_array($message))
	{
		$count++;
		$message = next($messagesTemp);
	}

	$prevmatch = "";
	$morematch = "";

	if ($totalFound > $count)
	{
		$startvar = $count + 1;

		$morematch = "$search_page.$ext?f=$num&search=" . urlencode($search) . "&globalsearch=$globalsearch&match=$match&date=$date&fldauthor=$fldauthor&fldsubject=$fldsubject&fldbody=$fldbody&start=$startvar$GetVars";
	}

	if ($start != 1)
	{
		$startvar = $start - $ForumDisplay;

		$prevmatch = "$search_page.$ext?f=$num&search=" . urlencode($search) . "&globalsearch=$globalsearch&match=$match&date=$date&fldauthor=$fldauthor&fldsubject=$fldsubject&fldbody=$fldbody&start=$startvar$GetVars";
	}

	if ($prevmatch != "" || $morematch != "")
	{
?>
          <td align="right">
            <table border="0" cellspacing="0" cellpadding="0" width="360">
              <tr>
<?php
		if ($prevmatch != "")
		{
?>
                        <td><div align="right"><a href="<?php echo $prevmatch ?>"><img src="<?php echo $forum_url?>/images/triangle_l.gif" width="30" height="30" border="0" alt="<?php echo $lPrevMatches ?>"></a></div></td>
                        <td valign="middle" nowrap><span class="fBlack10100"><a href="<?php echo $prevmatch ?>" class="usually"><?php echo $lPrevMatches ?></a></span></td>
<?php
		}

		if ($morematch != "")
		{
?>
                        <td valign="middle" nowrap><div align="right"><span class="fBlack10100"><a href="<?php echo $morematch ?>" class="usually"><?php echo $lMoreMatches ?></a></span></div></td>
                        <td><a href="<?php echo $morematch ?>"><img src="<?php echo $forum_url?>/images/triangle_r.gif" alt="<?php echo $lMoreMatches ?>" width="30" height="30" border="0"></a></td>
<?php
		}
?>
              </tr>
            </table>
          </td>
<?php
	}
?>
            <td>
            </td>
          </tr>
          <tr> 
            <td><img src="images/spazio.gif" width="1" height="5" alt=""></td>
            <td></td>
            <td></td>
          </tr>

          <tr> 
            <td></td>
            <td colspan="2"> 
              <table width="760" border="0" cellspacing="0" cellpadding="0">



                <tr> 
                  <td valign="top" class="gray"> 
                    <table width="760" border="0" cellspacing="1" cellpadding="3">
<?php
	$end = count($messages) + $start - 1;
	if ($end > 0)
	{
		$range = "$start-$end $lOf $totalFound";
	}
	else
	{
		$range = "";
	}
?>
                      <tr> 
                        <!-- ̾ -->
                        <td valign="middle" class="sky" colspan="3"> <span class="fWhite10100"><b><font color="#FFFFFF"  class="PhorumTableHeader"><?php echo "$lSearchResults: $range";?></font></b></span></td>
                      </tr>
<?php
	$bgcolor = bgcolor($ForumTableBodyColor1);

	if ($totalFound > 0)
	{
		krsort($messages);
		$message = current($messages);
		$count = $start - 1;

		while (is_array($message))
		{
			$count++;

			if (!isset($top_id))
			{
				$top_id = $message["id"];
			}

			$text = format_body($message["body"]);
			$text = chop(mb_substr($text, 0, 200));
			$text = strip_tags($text);
			$text = str_replace(PHORUM_SIG_MARKER, "", $text);
			$text = nl2br($text);
			$link = "$read_page.$ext?f=$message[forum]&i=$message[id]&t=$message[thread]$GetVars";
			$subject = chop($message["subject"]);
			$author = chop($message["author"]);

			// Ұ̾μ
			$strSql = $dbSqlObj->selectEmployeeNameWithEmpCd(trim($author));
			$authData = $dbExecObj->exeSql($conn, $strSql);
			$author = htmlspecialchars($dbExecObj->getResult($authData, 0, 0));

//			$datestamp = date_format($message["datestamp"]);
			$datestamp = date_format_wiz($message["datestamp"]);
			$forum = $forums[$message["forum"]];

?>
                      <tr>
                        <td class="crame" valign="middle" colspan="3">
                          <table width="100%" cellpadding="4" cellspacing="0">
                            <tr> 
                              <td width="5%" nowrap  bgcolor="#FFFFCC"><span class="fBlack10100"><b><?php echo $count ?>.</b></span></td>
                              <td width="47%"  bgcolor="#FFFFCC"><span class="fBlack10100"><a href="<?php echo $link ?>" class="usually"><b><?php echo $subject ?></b></a></span></td>
                              <td width="24%"  bgcolor="#FFFFCC"><span class="fBlack10100"><?php echo $author ?></span></td>
                              <td width="24%"  bgcolor="#FFFFCC"><span class="fBlack10100"><?php echo $datestamp ?></span></td>
                            </tr>
                          </table>
                          <span class="fBlack10100"><blockquote><?php echo $text ?><br><br>
                            <b><?php echo $lBigForum ?>: <a href="<?php echo $list_page . "." . $ext . "?f=" . $message[forum] . $GetVars ?>" class="usually"><?php echo htmlspecialchars($forum) ?></a></b></blockquote></span>
</td>
                      </tr>
<?php
			$last_id = $message["id"];
			$message = next($messages);
		}
	}
	else
	{
?>
                      <tr>
                        <td class="crame" valign="middle" colspan="3">
                          <table width="100%" cellpadding="4" cellspacing="0">
                            <tr> 
                              <td width="47%"  bgcolor="#FFFFCC"><span class="fBlack10100"><b><?php echo $lNoMatches ?></b></span></td>
                            </tr>
                          </table>
                        </td>
                      </tr>
<?php
		$count = 0;
	}
?>
                    </table>
                  </td>
                </tr>
<?php
	$prevmatch = "";
	$morematch = "";

	if ($totalFound > $count)
	{
		$startvar = $count + 1;

		$morematch = "$search_page.$ext?f=$num&search=" . urlencode($search) . "&globalsearch=$globalsearch&match=$match&date=$date&fldauthor=$fldauthor&fldsubject=$fldsubject&fldbody=$fldbody&start=$startvar$GetVars";
	}

	if ($start != 1)
	{
		$startvar = $start - $ForumDisplay;

		$prevmatch = "$search_page.$ext?f=$num&search=" . urlencode($search) . "&globalsearch=$globalsearch&match=$match&date=$date&fldauthor=$fldauthor&fldsubject=$fldsubject&fldbody=$fldbody&start=$startvar$GetVars";
	}

	if ($prevmatch != "" || $morematch != "")
	{
?>
                <tr>
                  <td align="right">
                    <table border="0" cellspacing="0" cellpadding="0" width="360">
                      <tr>
<?php
		if ($prevmatch)
		{
?>
                        <td><div align="right"><a href="<?php echo $prevmatch ?>"><img src="<?php echo $forum_url?>/images/triangle_l.gif" width="30" height="30" border="0" alt="<?php echo $lPrevMatches ?>"></a></div></td>
                        <td valign="middle" nowrap><span class="fBlack10100"><a href="<?php echo $prevmatch ?>" class="usually"><?php echo $lPrevMatches ?></a></span></td>
<?php
		}
		if ($morematch)
		{
?>
                        <td valign="middle" nowrap><div align="right"><span class="fBlack10100"><a href="<?php echo $morematch ?>" class="usually"><?php echo $lMoreMatches ?></a></span></div></td>
                        <td><a href="<?php echo $morematch ?>"><img src="<?php echo $forum_url?>/images/triangle_r.gif" alt="<?php echo $lMoreMatches ?>" width="30" height="30" border="0"></a></td>
<?php
		}
?>
                      </tr>
                    </table>
                  </td>
                </tr>
<?php
	}
?>
              </table>
<?php
}
?>
			</td>
          </tr>

          <form action="<?php echo htmlspecialchars($_SERVER["PHP_SELF"]); ?>" method="GET">
<?php echo $PostVars; ?>
            <input type="Hidden" name="f" value="<?php echo htmlspecialchars($num); ?>">
<?php echo $TopLeftNav ?>
          <td><br></td>
        </tr>
        <tr> 
          <td><img src="<?php echo $forum_url?>/images/spazio.gif" width="1" height="5" alt=""></td>
          <td></td>
          <td></td>
        </tr>
        <tr> 
          <td></td>
            <td colspan="2"> <span class="fBlack12100"> </span> 
              <table border="0" cellspacing="2" cellpadding="3">
                <tr> 
                  <td valign="top"> <span class="fBlack10100"><b>̾</b></span></td>
                  <td> 
                    <input type="Text" name="search" size="40" value="<?php echo $searchtext; ?>">
                    <input type="Submit" value="" name="Submit">
                  </td>
                </tr>
                <tr> 
                  <td valign="top"></td>
                  <td><font color="#000000"> 
                    <select name="globalsearch">
                      <option value="0" <?php if ($globalsearch == 0) echo "selected"; ?>><?php echo $lSearchThisForum ?></option>
                      <option value="1" <?php if ($globalsearch == 1) echo "selected"; ?>><?php echo $lSearchAllForums ?></option>
                    </select>&nbsp;&nbsp;&nbsp;&nbsp;
                    <select name="match">
                      <option value="1" <?php if ($match == 1) echo "selected"; ?>><?php echo $lSearchAllWords ?></option>
                      <option value="2" <?php if ($match == 2) echo "selected"; ?>><?php echo $lSearchAnyWords ?></option>
                      <option value="3" <?php if ($match == 3) echo "selected"; ?>><?php echo $lSearchPhrase ?></option>
                    </select>&nbsp;&nbsp;&nbsp;&nbsp;
                    <select name="date">
                      <option value="30" <?php if ($date == 30) echo "selected"; ?>><?php echo $lSearchLast30; ?></option>
                      <option value="60" <?php if ($date == 60) echo "selected"; ?>><?php echo $lSearchLast60; ?></option>
                      <option value="90" <?php if ($date == 90) echo "selected"; ?>><?php echo $lSearchLast90; ?></option>
                      <option value="180" <?php if ($date == 180) echo "selected"; ?>><?php echo $lSearchLast180; ?></option>
                      <option value="0" <?php if ($date == 0) echo "selected"; ?>><?php echo $lSearchAllDates; ?></option>
                    </select>
                    </font></td>
                </tr>
                <tr> 
                  <td valign="top"><span class="fBlack10100"></span></td>
                  <td><span class="fBlack10100">
                    <input type="checkbox" name="fldauthor" value="1"<?php if ($fldauthor == 1)  echo " checked"; ?>>
                    Ƽ&nbsp;&nbsp;&nbsp; 
                    <input type="checkbox" name="fldsubject" value="1"<?php if ($fldsubject == 1)  echo " checked"; ?>>
                    ̾&nbsp;&nbsp;&nbsp; 
                    <input type="checkbox" name="fldbody" value="1"<?php if ($fldbody == 1)  echo " checked"; ?>>
                    å (®)&nbsp;</span> </td>
                </tr>
              </table>
              <br>
              <table width="760" border="0" cellspacing="0" cellpadding="0">
                <tr> 
                  <td valign="top" class="gray"> 
                    <table width="760" border="0" cellspacing="1" cellpadding="3">
                      <tr> 
                        <!-- ̾ -->
                        <td valign="middle" class="sky" colspan="3"> <span class="fWhite10100"><b>Υҥ</b></span></td>
                      </tr>
                      <tr> 
                        <td class="crame" valign="middle" colspan="3"><span class="fBlack10100"> 
                          AND ǥեȤǤĤޤꡢ<b>dog</b> 
                           <b>cat</b> 򸡺硢ñɤͭƤΥå̤Ȥʤޤ
                          <p> (") ˤθǽǤξ硢<b>"dog cat"</b>򸡺Ȥζ˰פƤΥå̤Ȥʤޤ
                          <p>ޥʥ(-)ϡñޤĤޤꡢ<b>dog</b>  <b>-cat</b> 򸡺硢<b>dog</b>ޤ 
                            <b>cat</b>ޤޤʤƤΥå̤Ȥʤޤ<b>dog -"siamese cat"</b>Τ褦˰ǳä˥ޥʥդ뤳ȤǽǤ
                          <p> Let'sʤ 'פΤñ򸡺ϡ<b>Let''sͤ 'פ³ƵҤ</b>Ʋ
                          <p> ϡʸʸ̤Ƽԡ̾å򸡺ޤ
                          </span></td>
                      </tr>
                    </table>
                  </td>
                </tr>
              </table>
            </td>
        </tr>
		</form>




<!--


              <table width="<?php echo $ForumTableWidth; ?>" border="0" cellspacing="0" cellpadding="3">
                <tr>
                  <td <?php echo bgcolor($ForumNavColor); ?> valign="TOP" nowrap>
                    <font color="<?php echo $ForumNavFontColor; ?>"><?php echo $TopLeftNav; ?></font>
                      </td>
                    </tr>
                  </table>
                  <table class="PhorumListTable" width="<?php echo $ForumTableWidth; ?>" border="0" cellspacing="0" cellpadding="2">
                    <tr>
                      <td <?php echo bgcolor($ForumTableHeaderColor); ?> valign="TOP" nowrap>
                        <font color="<?php echo $ForumTableHeaderFontColor; ?>"	class="PhorumTableHeader">&nbsp;<?php echo $lSearch;?></font>
                      </td>
                    </tr>
                    <tr>
                      <td align="CENTER" valign="MIDDLE" <?php echo bgcolor($ForumTableBodyColor2); ?>>
                  	  <br>
                        <table cellspacing="0" cellpadding="2" border="0">
                          <tr>
                            <td align="right">
                              <font color="<?php echo $ForumTableBodyFontColor2; ?>">&nbsp;&nbsp;<?php echo $lSearch;?>:&nbsp;&nbsp;</font>
                            </td>
                            <td>
                              <input type="Text" name="search" size="40" value="<?php echo $searchtext; ?>">&nbsp;<input type="Submit" value="<?php echo $lSearch;?>">&nbsp;&nbsp;
                            </td>
                          </tr>
                          <tr>
                            <td align="right">&nbsp;</td>
                            <td>
                              <font color="<?php echo $ForumTableBodyFontColor2; ?>">
                                <select name="globalsearch">
                                  <option value="0" <?php if ($globalsearch == 0) echo "selected"; ?>><?php echo $lSearchThisForum ?></option>
                                  <option value="1" <?php if ($globalsearch == 1) echo "selected"; ?>><?php echo $lSearchAllForums ?></option>
                                </select>&nbsp;&nbsp;&nbsp;&nbsp;
                                <select name="match">
                                  <option value="1" <?php if ($match == 1) echo "selected"; ?>><?php echo $lSearchAllWords ?></option>
                                  <option value="2" <?php if ($match == 2) echo "selected"; ?>><?php echo $lSearchAnyWords ?></option>
                                  <option value="3" <?php if ($match == 3) echo "selected"; ?>><?php echo $lSearchPhrase ?></option>
                                </select>&nbsp;&nbsp;&nbsp;&nbsp;
                                <select name="date">
                                  <option value="30" <?php if ($date == 30) echo "selected"; ?>><?php echo $lSearchLast30; ?></option>
                                  <option value="60" <?php if ($date == 60) echo "selected"; ?>><?php echo $lSearchLast60; ?></option>
                                  <option value="90" <?php if ($date == 90) echo "selected"; ?>><?php echo $lSearchLast90; ?></option>
                                  <option value="180" <?php if ($date == 180) echo "selected"; ?>><?php echo $lSearchLast180; ?></option>
                                  <option value="0" <?php if ($date == 0) echo "selected"; ?>><?php echo $lSearchAllDates; ?></option>
                                </select>
                              </font>
                            </td>
                          </tr>
                          <tr>
                            <td align="right">&nbsp;</td>
                            <td>
                              <font color="<?php echo $ForumTableBodyFontColor2; ?>"><input type="checkbox" name="fldsubject" value="1" <?php if($fldsubject==1)	echo "checked"; ?>> <?php echo $lFormSubject; ?>&nbsp;&nbsp;&nbsp;<input type="checkbox" name="fldbody" value="1" <?php if($fldbody==1)  echo "checked"; ?>> <?php echo $lMessageBodies; ?>&nbsp;&nbsp;&nbsp;</font>
                            </td>
                          </tr>
                        </table>
                      </font><br>
                    </td>
                </td>
              </tr>
            </table>
          </form>
          <p>
          <table class="PhorumListTable" width="<?php echo $ForumTableWidth; ?>" border="0" cellspacing="0" cellpadding="2">
            <tr>
              <td <?php echo bgcolor($ForumTableHeaderColor); ?> valign="TOP" nowrap><font color="<?php echo $ForumTableHeaderFontColor; ?>" class="PhorumTableHeader">&nbsp;<?php echo $lSearchTips;?></font></td>
            </tr>
            <tr>
              <td width="<?php echo $ForumTableWidth; ?>" align="LEFT" valign="MIDDLE" <?php echo bgcolor($ForumTableBodyColor2); ?>><font color="<?php echo $ForumTableBodyFontColor2; ?>"><?php echo $lTheSearchTips;?><br></font>
              </td>
            </tr>
          </table>
-->
<?php
include phorum_get_file_name("footer");
?>
