<?php
/**
 * Ͽ&ѥ饹
 *
 * @author maiko MIKAMI <m-mikami@syscon.co.jp>
 * @author hideki HARANAKA <hideki-h@syscon.co.jp>
 */

require_once($_ROOT_DIR_ . "gw.php");

class NoticeDrawUp {
	var $conn;				//connectionHandller
	var $dbSqlObj;			//sqlObject
	var $dbExecObj;			//executeObject
	var $sendtime;			//Ͽ
	var $owner_emp_cd;		//Ͽ
	var $title;				//ĥȥ
	var $body;				//ʸ
	var $confirm;			//ȻѲԲ
	var $schedule_cd;		//塼륳(塼뵡ǽμưϿΤ߻)
	var $scdl_date_cd;		//塼(塼뵡ǽμưϿΤ߻)
	var $arrEmp_cd;			//ĤEMP_CD
	var $strRootURL;        //La!coodaWIZ Root URL


	function setConn($conn){
		$this->conn = $conn;
	}
	function getConn(){
		return $this->conn;
	}

	function setDbSqlObj($dbSqlObj){
		$this->dbSqlObj = $dbSqlObj;
	}
	function getDbSqlObj(){
		return $this->dbSqlObj;
	}

	function setDbExecObj($dbExecObj){
		$this->dbExecObj = $dbExecObj;
	}
	function getDbExecObj(){
		return $this->dbExecObj;
	}

	function setSendtime($sendtime){
		//Y-m-d H:i:s
		$this->sendtime = $sendtime;
	}
	function getSendtime(){
		return $this->sendtime;
	}

	function setOwner_emp_cd($owner_emp_cd){
		$this->owner_emp_cd = $owner_emp_cd;
	}
	function getOwner_emp_cd(){
		return $this->owner_emp_cd;
	}

	function setTitle($title){
		$title = strip_tags(mb_convert_kana($title));
		$this->title = $title;
	}
	function getTitle(){
		return $this->title;
	}

	function setBody($body){
		$body = strip_tags(mb_convert_kana($body));
		$this->body = $body;
	}
	function getBody(){
		return $this->body;
	}

	function setConfirm($confirm){
		if ($confirm != 't') {
			$confirm = 'f';
		}
		else {
			$confirm = 't';
		}
		$this->confirm = $confirm;
	}
	function getConfirm(){
		return $this->confirm;
	}

	function setSchedule_cd($schedule_cd){
		$this->schedule_cd = $schedule_cd;
	}
	function getSchedule_cd(){
		return $this->schedule_cd;
	}

	function setScdl_date_cd($scdl_date_cd){
		$this->scdl_date_cd = $scdl_date_cd;
	}
	function getScdl_date_cd(){
		return $this->scdl_date_cd;
	}

	function setArrEmp_cd($arrEmp_cd){
		$this->arrEmp_cd = $arrEmp_cd;
	}
	function getArrEmp_cd(){
		return $this->arrEmp_cd;
	}

	function setRootURL($strRootURL){
		$this->strRootURL = $strRootURL;
	}
	function getRootURL(){
		return $this->strRootURL;
	}

	/**
	 * 󥹥ȥ饯
	 */
	function NoticeDrawUp($conn, $dbSqlObj, $dbExecObj) {
		$this->setConn($conn);
		$this->setDbSqlObj($dbSqlObj);
		$this->setDbExecObj($dbExecObj);
	}

	/**
	 * ĥǡ
	 */
	function createNotice(){
		//ȥ󥶥󳫻
		$this->dbExecObj->exeSql($this->conn, $this->dbSqlObj->sqlBeginTrans());

		//ľϿ
		$ret = $this->insertNotice();
		if($ret == false){
			//ԤROLLBACK
			$this->dbExecObj->exeSql($this->conn,$this->dbSqlObj->sqlRollBackTrans());
			return false;
		}

		//ĤϿ
		$ret = $this->insertPNotice();
		if($ret == false){
			//ԤROLLBACK
			$this->dbExecObj->exeSql($this->conn,$this->dbSqlObj->sqlRollBackTrans());
			return false;
		}
		//COMMIT
		$this->dbExecObj->exeSql($this->conn, $this->dbSqlObj->sqlCommitTrans());

		return true;
	}

	/**
	 * ĥǡ
	 */
	function createNoticeWithoutTransaction(){

		//ľϿ
		$ret = $this->insertNotice();
		if($ret == false){
			return false;
		}

		//ĤϿ
		$ret = $this->insertPNotice();
		if($ret == false){
			return false;
		}

		return true;
	}

	/**
	 * ĥǡ
	 * (privateʴؿ)
	 */
	function insertNotice() {
		$sqlstr = $this->dbSqlObj->insertNotice($this->getSendtime(),$this->getOwner_emp_cd(),$this->getTitle(),$this->getBody(),$this->getConfirm(),$this->getSchedule_cd(),$this->getScdl_date_cd());
		$result = $this->dbExecObj->exeSql($this->conn,$sqlstr);
	 	if (!$result) {
	 		return false;
	 	}

	 	return true;
	}

	/**
	 * Ĥǡȥ᡼
	 * (privateʴؿ)
	 */
	function insertPNotice() {
		$arrEmp_cd = $this->getArrEmp_cd();
		$emp_count = count($arrEmp_cd);
		$i = 0;
		while ($i < $emp_count) {
			$sqlstr = $this->dbSqlObj->insertPNotice($this->getSendtime(),$arrEmp_cd[$i]);

			$result = $this->dbExecObj->exeSql($this->conn,$sqlstr);
			if (!$result) {
				return false;
			}
			if($this->getOwner_emp_cd() == $arrEmp_cd[$i]){
				$sqlstr = $this->dbSqlObj->updatePnoticeSeenTimeWithSendTimeEmpCd($this->getSendtime(),$arrEmp_cd[$i]);
				$result = $this->dbExecObj->exeSql($this->conn,$sqlstr);
				if (!$result) {
					return false;
				}
			}
			//᡼ǽ
			//᡼Τ򥲥å
			$sqlstr = $this->dbSqlObj->selectEmployeeEmailNameWithEmpCd($arrEmp_cd[$i]);

			$result = $this->dbExecObj->exeSql($this->conn,$sqlstr);
			if (!$result) {
				return false;
			}
			$email = $this->dbExecObj->getResult($result,0,"email");
			$toName = $this->dbExecObj->getResult($result,0,"name");
			//пͤ̾򥲥å
			$sqlstr = $this->dbSqlObj->selectEmployeeNameWithEmpCd($this->getOwner_emp_cd());

			$result = $this->dbExecObj->exeSql($this->conn,$sqlstr);
			if (!$result) {
				return false;
			}
			$fromName = $this->dbExecObj->getResult($result,0,"name");
			//FromΥ᡼륢ɥ쥹å
			$xmail = "X-Mailer: PHP/5";
/**/			$fromMailStr = $fromMailStrDefault . "\r\n" . $xmail;
//			$fromMailStr = $admin;
			//᡼ʸ
			$mailstr = "Message from WIZ\r\n\r\n";
			$mailstr .= $toName . "Ͱ˲Ƥޤ\r\n";
			$mailstr .= "Ƥ򤴳ǧ\r\n\r\n";
			$mailstr .= "мԡ" . $fromName . "\r\n";
			$mailstr .= "" . $this->getSendtime() . "\r\n";
			$mailstr .= "ȥ롧" . $this->getTitle() . "\r\n\r\n";
			$mailstr .= $this->getRootURL() . "\r\n";
			$mailstr .= $this->getRootURL() . "index.php\r\n\r\n";
			$mailstr .= "ܥ᡼ֿפǤ";
			//᡼
			if ($email != ""){
				// Ȥθ
				mb_language("Japanese");
				// إå
//				$MailHeaders  = "Mime-Version: 1.0\r\n";
//				$MailHeaders .= "Content-Type: text/plain; charset=ISO-2022-JP\r\n";
//				$MailHeaders .= "Content-Transfer-Encoding: 7bit\r\n";
//				$MailHeaders .= "From:$fromMailStr\r\n";

				// ᡼
				mb_send_mail($email, "[WIZ] 夷ޤ", $mailstr, "From: $fromMailStr");
//				mail($email,
//					("=?iso-2022-jp?B?" . base64_encode(i18n_convert("[WIZ] 夷ޤ","JIS","EUC")) . "?="),
//					i18n_convert($mailstr,"JIS","EUC"), $MailHeaders);
			}

			$i++;
		}
	 	return true;
	}

	/**
	 * ˽°emp_cd֤
	 * @param String $division 祳
	 */
	function getEmpcdWithDivision($division) {

		$sqlstr = $this->dbSqlObj->selectEmployeeEmpCdWithDivision($division);
		$result = $this->dbExecObj->exeSql($this->conn,$sqlstr);
		if (!$result) {
			exit;
		}
		$i = 0;
		$emp_count = $this->dbExecObj->getNumRows($result);
		while ($i < $emp_count) {
			$arrEmp_cd[$i] = $this->dbExecObj->getResult($result, $i, "emp_cd");
			$i++;
		}

	 	return $arrEmp_cd;
	}

	/**
	 * 꽢ȷ֤˽°emp_cd֤
	 * @param String $categoryValue	 ȷ֥
	 */
	function getEmpcdWithKind($categoryValue) {

		$sqlstr = $this->dbSqlObj->selectEmployeeEmpCdWithKind($categoryValue);
		$result = $this->dbExecObj->exeSql($this->conn,$sqlstr);

		if (!$result) {
			exit;
		}

		$i = 0;
		$emp_count = $this->dbExecObj->getNumRows($result);
		while ($i < $emp_count) {
			$arrEmp_cd[$i] = $this->dbExecObj->getResult($result, $i, "emp_cd");
			$i++;
		}

	 	return $arrEmp_cd;
	}

	/**
	 * ĺ
	 * @param int $delMode
	 * 				0:
	 * 				1:ꥭ(sendtime)βκ
	 * 				2:ʬ
	 * 				3:ꥹ塼륳ɤβ
	 * 				4:ꥹ塼륳ɡդβ
	 */
	function deleteNotice($delMode){
		//ȥ󥶥󳫻
		$this->dbExecObj->exeSql($this->conn, $this->dbSqlObj->sqlBeginTrans());

		switch($delMode){
			//
			case 0:
				$ret = $this->delAll();
				break;

			//ꥭ(sendtime)βκ
			case 1:
				$this->argumentCheck("sendtime", $this->getSendtime());
				$ret = $this->delWithSendtime();
				break;

			//ʬ
			case 2:
				$this->argumentCheck("owner_emp_cd", $this->getOwner_emp_cd());
				$ret = $this->delWithOwner();
				break;

			//ꥹ塼륳ɤβ
			case 3:
				$this->argumentCheck("schedule_cd", $this->getSchedule_cd());
				$ret = $this->delWithSchedule();
				break;

			//ꥹ塼륳ɡդβ
			case 4:
				$this->argumentCheck("schedule_cd", $this->getSchedule_cd());
				$this->argumentCheck("schedule_date_cd", $this->getScdl_date_cd());
				$ret = $this->delWithSchedule();
				break;
		}
		//ԤROLLBACK
		if($ret == false){
			$this->dbExecObj->exeSql($this->conn,$this->dbSqlObj->sqlRollBackTrans());
			return false;
		}
		//COMMIT
		$this->dbExecObj->exeSql($this->conn, $this->dbSqlObj->sqlCommitTrans());

		return true;
	}

	/**
	 * ĺ
	 * @param int $delMode
	 * 				0:
	 * 				1:ꥭ(sendtime)βκ
	 * 				2:ʬ
	 * 				3:ꥹ塼륳ɤβ
	 * 				4:ꥹ塼륳ɡդβ
	 */
	function deleteNoticeWithoutTransaction($delMode){

		switch($delMode){
			//
			case 0:
				$ret = $this->delAll();
				break;

			//ꥭ(sendtime)βκ
			case 1:
				$this->argumentCheck("sendtime", $this->getSendtime());
				$ret = $this->delWithSendtime();
				break;

			//ʬ
			case 2:
				$this->argumentCheck("owner_emp_cd", $this->getOwner_emp_cd());
				$ret = $this->delWithOwner();
				break;

			//ꥹ塼륳ɤβ
			case 3:
				$this->argumentCheck("schedule_cd", $this->getSchedule_cd());
				$ret = $this->delWithSchedule();
				break;

			//ꥹ塼륳ɡդβ
			case 4:
				$this->argumentCheck("schedule_cd", $this->getSchedule_cd());
				$this->argumentCheck("schedule_date_cd", $this->getScdl_date_cd());
				$ret = $this->delWithSchedule();
				break;
		}
		if($ret == false){
			return false;
		}

		return true;
	}

	/**
	 * 
	 * (privateʴؿ)
	 */
	function delAll(){
		//Notice
		$strSQL = $this->dbSqlObj->deleteNotice();
		$result = $this->dbExecObj->exeSql($this->conn,$strSQL);
		if (!$result)
		{
			return false;
		}
		//PNotice
		$strSQL = $this->dbSqlObj->deletePNotice();
		$result = $this->dbExecObj->exeSql($this->conn,$strSQL);
		if (!$result)
		{
			return false;
		}
		return true;
	}

	/**
	 * ꤵ줿(sendtime)βǡ
	 * (privateʴؿ)
	 */
	function delWithSendtime(){
		//PNotice
		$strSQL = $this->dbSqlObj->deletePNoticeWithSendTime($this->getSendtime());
		$result = $this->dbExecObj->exeSql($this->conn,$strSQL);
		if (!$result)
		{
			return false;
		}

		//Notice
		$strSQL = $this->dbSqlObj->deleteNoticeWithSendTime($this->getSendtime());
		$result = $this->dbExecObj->exeSql($this->conn,$strSQL);
		if (!$result)
		{
			return false;
		}

		return true;
	}

	/**
	 * ʬ
	 * (privateʴؿ)
	 */
	function delWithOwner(){
		//ʬκĤΥ
		$strSQL = $this->dbSqlObj->selectNoticeSendTimeWithEmpCd($this->getOwner_emp_cd());
		$result = $this->dbExecObj->exeSql($this->conn,$strSQL);
		if (!$result)
		{
			return false;
		}
		$rowCount = $this->dbExecObj->getNumRows($result);
		for ($i = 0; $i < $rowCount; $i++)
		{
			//
			$sendtime = $this->dbExecObj->getResult($result,$i,"sendtime");
			$this->setSendtime($sendtime);
			//ǡ
			$ret = $this->delWithSendtime();
			if (!$ret)
			{
				return false;
			}
		}

		return true;
	}

	/**
	 * ꥹ塼β
	 * (privateʴؿ)
	 */
	function delWithSchedule(){
		//塼륳ɤطΤĤsendtime
		$strSQL = $this->dbSqlObj->selectNoticeKeyWithSchedule($this->getSchedule_cd(),$this->getScdl_date_cd());
		$result = $this->dbExecObj->exeSql($this->conn,$strSQL);
		if (!$result)
		{
			return false;
		}
		$rowCount = $this->dbExecObj->getNumRows($result);
		for ($i = 0; $i < $rowCount; $i++)
		{
			//
			$sendtime = $this->dbExecObj->getResult($result,$i,"sendtime");
			$this->setSendtime($sendtime);
			//ǡ
			$ret = $this->delWithSendtime();
			if (!$ret)
			{
				return false;
			}
		}

		return true;
	}

	/**
	 * Υå
	 * (privateʴؿ)
	 */
	function argumentCheck($argumentName,$argValue){
		if($argValue == 0 ||
			$argValue == "false") {
		} else {
			if(!$argValue) {
				echo "<b>ѿ̾ : $argumentName<br>ǡμ˼Ԥޤ</b><br>\n";
				exit;
			}
		}
	}

}
?>