<?php
/**
 *٥մ饹
 *
 * @author hideki HARANAKA <hideki-h@syscon.co.jp>
 */
class ScheduleDateInfo {

  /**
   *饹̾
   */
  var $classname = "ScheduleDateInfo";

  /**
   *塼륳
   */
  var $schedule_cd;
  
  /**
   * 塼ե
   */
  var $schedule_date_cd;

  /**
   * 
   * @see dateinfo
   */
  var $startDateInfo;

  /**
   *λ
   * @see dateinfo
   */
  var $endDateInfo;

  /**
   * ս⡼
   * <ul>
   * 	<li>0:ˤ</li>
   * 	<li>1:</li>
   * 	<li>2:</li>
   * 	<li>3:</li>
   * 	<li>4:ֻ</li>
   * </ul>
   */
  var $date_mode;
  
  /**
   * 
   * ե⡼ɤˤ
   */
  var $scheduleDateArray = array();
   
  var $scheduleEventInfo;
  
  /**
   * 
   */
  var $week_day = array();

  /**
   * ջ
   */
  var $month_of_day;
  
  /**
   * 
   */
  var $month_of_week = array();

  /**
   * 塼ե
   */
  var $schedule_date_cd_array = array();

  /**
   * 
   */
  function getWeek_day(){
	return $this->week_day;
  }

  /**
   * ñ̤դ
   */
  function getMonth_of_day(){
	return $this->month_of_day;
  }

  /**
   * 
   */
  function getMonth_of_week(){
  	return $this->month_of_week;
  }

  /**
   * ꤹ
   */
  function setWeek_day($week_day){
	$this->week_day = $week_day;
  }

  /**
   * ñ̤դꤹ
   */
  function setMonth_of_day($month_of_day){
	$this->month_of_day = $month_of_day;
  }

  /**
   * ꤹ
   */
  function setMonth_of_week($month_of_week){
  	$this->month_of_week = $month_of_week;
  }

  /**
   * 塼륳ɤꤹ
   */
  function setSchedule_cd($schedule_cd){
  	$this->schedule_cd = $schedule_cd;
  }
  
  /**
   *塼륳ɤ
   *
   *@return int 塼륳
   */
  function  getSchedule_cd() {
    return $this->schedule_cd;
  }

  /**
   * ս⡼ɤꤹ
   * @param date_mode 
   */
  function setDate_mode($date_mode){
	$this->date_mode = $date_mode;
  }
  
  /**
   *DateInfoꤹ
   *
   *@param schedule_cd 塼륳
   */
  function  setStartDateInfo( $startDateInfo) {
  	$this->startDateInfo = $startDateInfo;
  }

  /**
   *λDateInfoꤹ
   *
   *@param schedule_cd 塼륳
   */
  function  setEndDateInfo( $endDateInfo) {
  	$this->endDateInfo = $endDateInfo;
  }

  /**
   * 塼
   */
  function setSchedule_date_cd_array($schedule_date_cd_array){
	$this->schedule_date_cd_array = $schedule_date_cd_array;
  }
  
  /**
   *
   *
   *@return String 
   */
  function  getStartDateInfo() {
    return $this->startDateInfo;
  }

  /**
   *λ
   *
   *@return String λ
   */
  function  getEndDateInfo() {
    return $this->endDateInfo;
  }
  
  /**
   * ǯ
   */
  function getStartYear(){
  	return $this->startDateInfo->getYear();
  }

  /**
   * λǯ
   */
  function getEndYear(){
  	return $this->endDateInfo->getYear();
  }
  
  /**
   * Ϸ
   */
  function getStartMonth(){
  	return $this->startDateInfo->getMonth();
  }

  /**
   * λ
   */
  function getEndMonth(){
  	return $this->endDateInfo->getMonth();
  }

  /**
   * 
   */
  function getStartDay(){
  	return $this->startDateInfo->getDay();
  }

  /**
   * λ
   */
  function getEndDay(){
  	return $this->endDateInfo->getDay();
  }

  /**
   * ϻ
   */
  function getStartHour(){
  	return $this->startDateInfo->getHour();
  }

  /**
   * λ
   */
  function getEndHour(){
  	return $this->endDateInfo->getHour();
  }

  /**
   * ʬ
   */
  function getStartMinute(){
  	return $this->startDateInfo->getMinute();
  }

  /**
   * λʬ
   */
  function getEndMinute(){
  	return $this->endDateInfo->getMinute();
  }
  
  /**
   * κǽ
   * @param String dayFlg  s:Ϸ e:λ
   * @return String rtnValue
   */
  function getLastMonth($dayFlg){
  	$rtnValue = "";
  	switch($dayFlg){
  		case "s":
  			$rtnValue = $this->startDateInfo->getLastMonth();
  			break;
  		case "e":
  			$rtnValue = $this->endDateInfo->getLastMonth();
  			break;
  		default:
  			$rtnValue = $this->startDateInfo->getLastMonth();
  			break;
  	}
  	return $rtnValue;
  }
  
  /**
   * 
   * @return String startDate YYYY-MM-DD
   */
  function getStartDate(){
  	if($this->getStartYear() != "" and $this->getStartMonth() != "" and $this->getStartDay() != ""){
	  	$tmpStartDate = $this->getStartYear() . "-" . $this->getStartMonth() . "-" . $this->getStartDay();
  	}
  	else{
  		$tmpStartDate = "";
  	}
  	return $tmpStartDate;
  }

  /**
   * λ
   * @return String endDate YYYY-MM-DD
   */
  function getEndDate(){
  	if($this->getEndYear() != "" and $this->getEndMonth() != "" and $this->getEndDay() != ""){
	  	$tmpEndDate = $this->getEndYear() . "-" . $this->getEndMonth() . "-" . $this->getEndDay();
  	}
  	else{
  		$tmpEndDate = "";
  	}
  	return $tmpEndDate;
  }
  
  /**
   * ϻ֤
   * @return String startTime HH:MI
   */
  function getStartTime(){
  	$tmpTime =  $this->getStartHour() . ":" . $this->getStartMinute();

	if ($tmpTime != "" and $this->getStartHour() != "" and $this->getStartMinute() != "")
	{
		$tmpTime = $tmpTime . ":00";
	}
	elseif ($tmpTime != "" and $this->getStartHour() != "" and $this->getStartMinute() == "")
	{
		$tmpTime = $this->getStartHour() . ":00:00";
	}
	else
	{
		$tmpTime = "";
	}
	
	return $tmpTime;
  }

  /**
   * λ֤
   * @return String endTime HH:MI
   */
  function getEndTime(){
  	$tmpTime = $this->getEndHour() . ":" . $this->getEndMinute();

	if ($tmpTime != "" and $this->getEndHour() != "" and $this->getEndMinute() != "")
	{
		$tmpTime = $tmpTime . ":00";
	}
	elseif ($tmpTime != "" and $this->getEndHour() != "" and $this->getEndMinute() == "")
	{
		$tmpTime = $this->getEndHour() . ":00:00";
	}
	else
	{
		$tmpTime = "";
	}
	
	return $tmpTime;
  }
  
  /**
   * 
   */
  function getScheduleDateArray(){
  	return $this->scheduleDateArray;
  }
  
  /**
   * ե
   */
  function createUpdateScheduleDateArray($conn, $dbSqlObj, $dbExecObj){
    $strSql = $dbSqlObj->selectScheduleDate($this->getSchedule_cd(), $this->schedule_date_cd_array);
	$result = $dbExecObj->exeSql($conn, $strSql);
	if (!$result) {
        $this->errMsg = "˾㳲ȯޤ\\n";
	
		return false;
	}
	if($dbExecObj->getNumRows($result) == 0){
		return false;
	}
	
    for ($i = 0; $i < $dbExecObj->getNumRows($result); $i++)
    {
	  	$tmpDateInfo = array();
	  	$tmpDateInfo['year'] = $dbExecObj->getResult($result, $i, "year");
	  	$tmpDateInfo['month'] = $dbExecObj->getResult($result, $i, "month");
	  	$tmpDateInfo['day'] = $dbExecObj->getResult($result, $i, "day");
	  	$tmpDateInfo['hour_s'] = $dbExecObj->getResult($result, $i, "shour");
	  	$tmpDateInfo['minute_s'] = $dbExecObj->getResult($result, $i, "smin");
	  	$tmpDateInfo['hour_e'] =  $dbExecObj->getResult($result, $i, "ehour");
	  	$tmpDateInfo['minute_e'] = $dbExecObj->getResult($result, $i, "emin");
	  	$tmpDateInfo['schedule_date_cd']  = $dbExecObj->getResult($result, $i, "schedule_date_cd");
	  	
	  	array_push($this->scheduleDateArray, $tmpDateInfo);
    }	
    return true;
  }

  /**
   * 塼륳ɤ
   */
  function createUpdateAllScheduleDateArray($conn, $dbSqlObj, $dbExecObj){
  	unset($this->scheduleDateArray);
  	$this->scheduleDateArray = array();
    $strSql = $dbSqlObj->selectAllScheduleDate($this->getSchedule_cd());
	$result = $dbExecObj->exeSql($conn, $strSql);
	if (!$result) {
        $this->errMsg = "˾㳲ȯޤ\\n";
	
		return false;
	}
    for ($i = 0; $i < $dbExecObj->getNumRows($result); $i++)
    {
	  	$tmpDateInfo = array();
	  	$tmpDateInfo['year'] = $dbExecObj->getResult($result, $i, "year");
	  	$tmpDateInfo['month'] = $dbExecObj->getResult($result, $i, "month");
	  	$tmpDateInfo['day'] = $dbExecObj->getResult($result, $i, "day");
	  	$tmpDateInfo['hour_s'] = $dbExecObj->getResult($result, $i, "shour");
	  	$tmpDateInfo['minute_s'] = $dbExecObj->getResult($result, $i, "smin");
	  	$tmpDateInfo['hour_e'] =  $dbExecObj->getResult($result, $i, "ehour");
	  	$tmpDateInfo['minute_e'] = $dbExecObj->getResult($result, $i, "emin");
	  	$tmpDateInfo['schedule_date_cd']  = $dbExecObj->getResult($result, $i, "schedule_date_cd");
	  	
	  	array_push($this->scheduleDateArray, $tmpDateInfo);
    }	
  }

  /**
   * 
   */
  function createScheduleDateArray(){
  	switch($this->date_mode){
  		case 0:
  			$this->createScheduleDateArray0();
  			break;
  		case 1:
  			$this->createScheduleDateArray1();
  			break;
  		case 2:
  			$this->createScheduleDateArray2();
  			break;
  		case 3:
  			$this->createScheduleDateArray3();
  			break;
  		case 4:
  			$this->createScheduleDateArray4();
  			break;
  		case 5:
  			$this->createScheduleDateArray5();
  			break;
  	}
  }
  
  /**
   * ˤ
   */
  function createScheduleDateArray0(){
  	$tmpDateInfo = array();
  	$tmpDateInfo['date'] = $this->getStartDate();
  	$tmpDateInfo['time_s'] = $this->getStartTime();
  	$tmpDateInfo['time_e'] = $this->getEndTime();
  	
  	array_push($this->scheduleDateArray, $tmpDateInfo);
  }
  
  /**
   * 
   */
  function createScheduleDateArray1()
  {
    $secs = 60 * 60 * 24;
    
    foreach($this->week_day as $key => $value){
		$time = 0;	
	    $stime = mktime(0,0,0,$this->getStartMonth(),$this->getStartDay(),$this->getStartYear());
	    $etime = mktime(0,0,0,$this->getEndMonth(),$this->getEndDay(),$this->getEndYear());
	    $info = getdate($stime);
	    $time = (($value - $info["wday"] + 7) % 7) * $secs + $stime;
	
	    $diff = 7 * $secs;

		while($time <= $etime){
		    $tmpDateInfo = array();
			$tmpDateInfo['date'] = date("Y-m-d",$time);
			$tmpDateInfo['time_s'] = $this->getStartTime();
			$tmpDateInfo['time_e'] = $this->getEndTime();
	        array_push($this->scheduleDateArray, $tmpDateInfo);
	        $time += $diff;
		}
    }
  }

  /**
   * 
   */
  function createScheduleDateArray2()
  {
    $secs = 60 * 60 * 24;
    
    foreach($this->week_day as $key => $value){
		$time = 0;	
	    $stime = mktime(0,0,0,$this->getStartMonth(),$this->getStartDay(),$this->getStartYear());
	    $etime = mktime(0,0,0,$this->getEndMonth(),$this->getEndDay(),$this->getEndYear());
	    $info = getdate($stime);
	    $time = (($value - $info["wday"] + 7) % 7) * $secs + $stime;
	
	    $diff = 7 * $secs;

		while($time <= $etime){
			if($this->ceckWeekOfMonth($time)){
			    $tmpDateInfo = array();
				$tmpDateInfo['date'] = date("Y-m-d",$time);
				$tmpDateInfo['time_s'] = $this->getStartTime();
				$tmpDateInfo['time_e'] = $this->getEndTime();
		        array_push($this->scheduleDateArray, $tmpDateInfo);
			}
	        $time += $diff;
		}
    }
  }

  /**
   * ñ̤Ǥջ
   */
  function createScheduleDateArray3()
  {
    $stime = mktime(0,0,0,$this->getStartMonth(),$this->getStartDay(),$this->getStartYear());
    $etime = mktime(0,0,0,$this->getEndMonth(),$this->getEndDay(),$this->getEndYear());
    
    $time = $stime;
    
    $curMonth = $this->getStartDay();
    $curYear = $this->getStartYear();
    
    
	while($time <= $etime){
		$curMonth = date("m", $time);
		$curYear = date("Y", $time);
		if($stime <= mktime(0,0,0,$curMonth,$this->month_of_day,$curYear) &&
			mktime(0,0,0,$curMonth,$this->month_of_day,$curYear) <= $etime &&
			checkdate($curMonth, $this->month_of_day, $curYear)){
			
		    $tmpDateInfo = array();
			$tmpDateInfo['date'] = $curYear . "-" . $curMonth . "-" . $this->month_of_day;
			$tmpDateInfo['time_s'] = $this->getStartTime();
			$tmpDateInfo['time_e'] = $this->getEndTime();
	        array_push($this->scheduleDateArray, $tmpDateInfo);
	    }
	    
        $time = mktime(0,0,0,$curMonth + 1,$this->month_of_day,$curYear);
	}
  }
  
  /**
   * ֻ
   */
  function createScheduleDateArray4(){	
	//UNIXॹ׼
	$startTimeStamp = mktime(0,0,0, $this->getStartMonth(), $this->getStartDay(), $this->getStartYear());
	//äѴ
	$startDate = $startTimeStamp / 60 / 60 / 24;
	$startDate = (int)$startDate;
	//λUNIXॹ׼
	$endTimeStamp = mktime(0,0,0, $this->getEndMonth(), $this->getEndDay(), $this->getEndYear());
	$endDate = $endTimeStamp / 60 / 60 / 24;
	$endDate = (int)$endDate;
	
	$diffDate = $endDate - $startDate;
	
  	$tmpDateInfo = array();
  	$tmpDateInfo['date'] = $this->getStartDate();
  	$tmpDateInfo['time_s'] = "";
  	$tmpDateInfo['time_e'] = "";

  	//$tmpDateInfo['time_s'] = $this->getStartTime();
  	//$tmpDateInfo['time_e'] = "23:50:00";
  	
  	array_push($this->scheduleDateArray, $tmpDateInfo);	
	
	for($i = 1; $i < $diffDate; $i++){
	  	$tmpDateInfo = array();
		$tmpTimeStamp = $startTimeStamp + ($i * 60 * 60 * 24);
		$tmpDateInfo['date'] = date("Y-m-d",$tmpTimeStamp);
	  	$tmpDateInfo['time_s'] = "";
	  	$tmpDateInfo['time_e'] = "";
	  	//$tmpDateInfo['time_s'] = "00:00:00";
	  	//$tmpDateInfo['time_e'] = "23:50:00";
	  	array_push($this->scheduleDateArray, $tmpDateInfo);	
	}
  	
  	if($diffDate > 0){
	  	$tmpDateInfo = array();
	  	$tmpDateInfo['date'] = $this->getEndDate();
	  	$tmpDateInfo['time_s'] = "";
	  	$tmpDateInfo['time_e'] = "";
	  	//$tmpDateInfo['time_s'] = "00:00:00";
	  	//$tmpDateInfo['time_e'] = $this->getEndTime();
	  	array_push($this->scheduleDateArray, $tmpDateInfo);
  	}
  }
  
  /**
   * ֻ֡
   */
  function createScheduleDateArray5(){	
	//UNIXॹ׼
	$startTimeStamp = mktime(0,0,0, $this->getStartMonth(), $this->getStartDay(), $this->getStartYear());
	//äѴ
	$startDate = $startTimeStamp / 60 / 60 / 24;
	$startDate = (int)$startDate;
	//λUNIXॹ׼
	$endTimeStamp = mktime(0,0,0, $this->getEndMonth(), $this->getEndDay(), $this->getEndYear());
	$endDate = $endTimeStamp / 60 / 60 / 24;
	$endDate = (int)$endDate;
	
	$diffDate = $endDate - $startDate;
	
  	$tmpDateInfo = array();
  	$tmpDateInfo['date'] = $this->getStartDate();
  	$tmpDateInfo['time_s'] = $this->getStartTime();
  	$tmpDateInfo['time_e'] = $this->getEndTime();

  	//$tmpDateInfo['time_s'] = $this->getStartTime();
  	//$tmpDateInfo['time_e'] = "23:50:00";
  	
  	array_push($this->scheduleDateArray, $tmpDateInfo);	
	
	for($i = 1; $i < $diffDate; $i++){
	  	$tmpDateInfo = array();
		$tmpTimeStamp = $startTimeStamp + ($i * 60 * 60 * 24);
		$tmpDateInfo['date'] = date("Y-m-d",$tmpTimeStamp);
	  	$tmpDateInfo['time_s'] = $this->getStartTime();
	  	$tmpDateInfo['time_e'] = $this->getEndTime();
	  	//$tmpDateInfo['time_s'] = "00:00:00";
	  	//$tmpDateInfo['time_e'] = "23:50:00";
	  	array_push($this->scheduleDateArray, $tmpDateInfo);	
	}
  	
  	if($diffDate > 0){
	  	$tmpDateInfo = array();
	  	$tmpDateInfo['date'] = $this->getEndDate();
	  	$tmpDateInfo['time_s'] = $this->getStartTime();
	  	$tmpDateInfo['time_e'] = $this->getEndTime();
	  	//$tmpDateInfo['time_s'] = "00:00:00";
	  	//$tmpDateInfo['time_e'] = $this->getEndTime();
	  	array_push($this->scheduleDateArray, $tmpDateInfo);
  	}
  }
  
  /**
   * 꽵ܤǤ뤫ɤå
   */
  function ceckWeekOfMonth($time){
    $secs = 60 * 60 * 24;
    $diff = 7 * $secs;
  	foreach($this->month_of_week as $key => $value){
  		$tmpTime = $time;
  		$tmpETime = mktime(0,0,0,date("m", $time), 1, date("Y",$time));
  		$i = 0;
  		if($value == 6){ //ǽ
			$tmpTime = mktime(0,0,0,date("m", $tmpTime), date("j",$tmpTime) + 7, date("Y",$tmpTime));
			if(date("d",$time) >= date("d", $tmpTime)){
				return true;
			}  			
  		}
  		else{
	  		while($tmpTime >= $tmpETime){
				$tmpTime -= $diff;	
				$i += 1;
	  		}
	  		if($i == $value){
				return true;
	  		}  			
  		}
  	}
  	return false;
  }
}

?>
