<?php
include_once("./class/TaskInfo.php");

class TaskInfoOwner
{
  var $startYear;
  var $startMonth;
  var $startDay;
  var $endYear;
  var $endMonth;
  var $endDay;

  var $conn;
  var $dbSqlObj;
  var $dbExecObj;

  var $varTaskInfo = array();

  var $emp_cd;

  /**
   * 󥹥ȥ饯
   **/
  function TaskInfoOwner($emp_cd, $conn, $dbSqlObj, $dbExecObj)
  {
    $this->emp_cd = $emp_cd;
    $this->conn = $conn;
    $this->dbSqlObj = $dbSqlObj;
    $this->dbExecObj = $dbExecObj;
  }

  /**
   * ɽ륿ϰϡStart
   **/
  function setStartDate($startYear, $startMonth, $startDay)
  {
    $this->startYear = $startYear;
    $this->startMonth = $startMonth;
    $this->startDay = $startDay;
  }
  /**
   * ɽ륿ϰϡEnd
   **/
  function setEndDate($endYear, $endMonth, $endDay)
  {
    $this->endYear = $endYear;
    $this->endMonth = $endMonth;
    $this->endDay = $endDay;
  }
  /**
   * ɽ륿ΥꥹȤ
   **/
  function createTaskInfo()
  {
    $strSql = $this->dbSqlObj->selectMonthScheduleTaskList($this->emp_cd,$this->startYear,$this->startMonth,$this->startDay,$this->endYear, $this->endMonth, $this->endDay);
    $result = $this->dbExecObj->exeSql($this->conn,$strSql);
    if (!$result)
    {
      echo "DB has been error!<br>\n";
      exit;
    }

    for ($i = 0; $i < $this->dbExecObj->getNumRows($result); $i++)
    {
      $tempTaskCd = $this->dbExecObj->getResult($result, $i, "task_cd");
      $tempTaskTitle = $this->dbExecObj->getResult($result, $i, "title");
      $tempDesc = $this->dbExecObj->getResult($result, $i, "description");
      $tempPlanEndYear = $this->dbExecObj->getResult($result, $i, "peyear");
      $tempPlanEndMonth = $this->dbExecObj->getResult($result, $i, "pemonth");
      $tempPlanEndDay = $this->dbExecObj->getResult($result, $i, "peday");
      $tempPlanEndHour = $this->dbExecObj->getResult($result, $i, "pehour");
      $tempPlanEndMinute = $this->dbExecObj->getResult($result, $i, "peminutes");
      $tempCatCd = $this->dbExecObj->getResult($result, $i, "category_cd");
      $tempSubCatCd = $this->dbExecObj->getResult($result, $i, "sub_category_cd");
      $tempGroupCd = $this->dbExecObj->getResult($result, $i, "group_cd");
      $tempStatus = $this->dbExecObj->getResult($result, $i, "status");
      
      $objTempTask = new TaskInfo($tempTaskCd, $tempTaskTitle, $tempDesc);
      $objTempTask->setPlanEnd($tempPlanEndYear, $tempPlanEndMonth, $tempPlanEndDay, $tempPlanEndHour, $tempPlanEndMinute);
      $objTempTask->setCatCd($tempCatCd);
      $objTempTask->setSubCatCd($tempSubCatCd);
      $objTempTask->setGroupCd($tempGroupCd);
      $objTempTask->setStatus($tempStatus);
      $this->addTaskList($objTempTask);
    }
  }
  /**
   *  ꥹ˿֥Ȥɲä
   */
  function addTaskList($objTask) {
    array_push($this->varTaskInfo, $objTask);
  }
  /**
   * ꥹ
   **/
  function getTaskList()
  {
    return $this->varTaskInfo;
  }
  
}
?>