<?php
//
// Copyright (C) 2001-2002 System Consultants Co.,Ltd. All Rights Reserved.
//
// $Id: javascriptselect_div_emp.php,v 1.3 2002/10/01 08:10:12 yu-ji Exp $
//

/**
 * 
 *
 * @author maiko MIKAMI <m-mikami@syscon.co.jp>
 * @author hideki HARANAKA <hideki-h@syscon.co.jp>
 */



require_once ($_ROOT_DIR_ . "class/javascriptselect.php");

class JavaScriptSelect_CatFacScheduleFacility extends JavaScriptSelect
{
/// private ///
	var $owner_emp_cd;
	var $scheduleFacilities;

/// public ///

	// 󥹥ȥ饯
	function JavaScriptSelect_CatFacScheduleFacility($fac_cat_cd,$fac_cd,$owner_emp_cd,$scheduleFacilities, $conn,$dbSqlObj,$dbExecObj)
	{
		$this->setOwnerEmpCd($owner_emp_cd);
		$this->setScheduleFacilities($scheduleFacilities);
		$this->setMainElementNameColumnName("fac_cat_name");		// ᥤǤ̾̾
		$this->setMainElementCodeColumnName("fac_cat_cd");		// ᥤǤΥɥ̾
		$this->setSubElementNameColumnName("fac_name");				// Ǥ̾̾
		$this->setSubElementCodeColumnName("fac_cd");			// ǤΥɥ̾
		$this->setMainIncludeAll("True");						// ᥤǤ""ޤफɤ
		$this->setSubIncludeAll("False");						// Ǥ""ޤफɤ
		$this->setSubAllOnly("False");							// ᥤǤ""ξ硢Ǥ""Τߤɤ
		$this->setMainAllSubIncludeAll("False");				// ᥤǤ""ξ硢Ǥ""ޤफɤ
		$this->setMainFormSelectName("fac_cat_cd");				// ᥤǤ<select>̾
		$this->setSubFormSelectName("facilities1[]");			// Ǥ<select>̾
		$this->setInitSelectFunctionName("initSelectFac");		// initSelect()̾
		$this->setChangeSelectFunctionName("changeSelectFac");	// changeSelect()̾
		$this->setDisableJavaScriptShowMain("True");			// JavaScript̵κݡᥤǤɽ뤫ɤ
		$this->setMainElementCodeFromHttp($fac_cat_cd);			// HTTPͳǼäᥤǤΥ
		$this->setSubElementCodeFromHttp($fac_cd);				// HTTPͳǼäᥤǤΥ
		$this->setElement($conn, $dbSqlObj, $dbExecObj);
		
	}

	function setOwnerEmpCd($owner_emp_cd){
		$this->owner_emp_cd = $owner_emp_cd;
	}
	function getOwnerEmpCd(){
		return $this->owner_emp_cd;
	}


	function setScheduleFacilities($scheduleFacilities){
		$this->scheduleFacilities = $scheduleFacilities;
	}
	function getScheduleFacilities(){
		return $this->scheduleFacilities;
	}
	
	function getMainElementCount(){
		echo $this->getMainResult();
		return $this->getMainResult();
	}

/// protected ///

	// ᥤǼSQLμ
	// ɡ̾
	function getSelectMainElementSql($dbSqlObj)
	{
		$sqlstr = $dbSqlObj->selectFacCatFacNameOrderByFacNameFac_cd($this->getOwnerEmpCd(), $this->getScheduleFacilities());
		return $sqlstr;
	}


	// ǼSQLμ
	// ǤΥɡǤ̾ϢդᥤǤΥ
	function getSelectSubElementSql($dbSqlObj)
	{
		$sqlstr = $dbSqlObj->selectFacFacNameOrderByFacNameFac_cd($this->getOwnerEmpCd(), $this->getScheduleFacilities());

		return $sqlstr;
	}

	// initSelectν
	function printInitSelectFunction()
	{
		echo "function " . $this->getInitSelectFunctionName() . "(myForm)\n";
		echo "{\n";

		// ᥤǤν
		$this->printMainElementArray();

		// Ǥν
		$this->printSubElementNameArray();

		// ᥤ󡿥Ǥƥåȥ롼ν
		$this->printMainElementSetRoutine();

		echo "\treturn true;\n";
		echo "}\n";
	}


	// 롼(changeSelect)ν
	function printChangeSelectFunction()
	{
		echo "function " . $this->getChangeSelectFunctionName() . "(myForm)\n";
		echo "{\n";

		echo "\tmyForm.elements['" . $this->getSubFormSelectName() . "'].options.length = 0;\n";

		echo "\tvar mainValue = myForm." . $this->getMainFormSelectName() . ".options[myForm." . $this->getMainFormSelectName() . ".selectedIndex].value;\n";
		echo "\tswitch (mainValue)\n";
		echo "\t{\n";

		if ($this->isMainIncludeAll() == "True")
		{
			echo "\t\tcase \"all\" :\n";
			echo "\t\t\tfor (i = 0; i < " . $this->getSubNameArrayName() . "all.length; i++)\n";
			echo "\t\t\t{\n";
			echo "\t\t\t\twoption = new Option(" . $this->getSubNameArrayName() . "all[i], " . $this->getSubCodeArrayName() . "all[i]);\n";
			echo "\t\t\t\tmyForm.elements['" . $this->getSubFormSelectName() . "'].options[i] = woption;\n";
			echo "\t\t\t}\n";
			echo "\t\t\tmyForm.elements['" . $this->getSubFormSelectName() . "'].selectedIndex = 0;\n";
			echo "\t\t\tbreak;\n";
		}

		$tempMainElementArray = $this->getMainElementArray();

		foreach ($tempMainElementArray as $key => $value)
		{
			echo "\t\tcase \"" . $key . "\" :\n";
			echo "\t\t\tfor (i = 0; i < " . $this->getSubNameArrayName() . $key . ".length; i++)\n";
			echo "\t\t\t{\n";
			echo "\t\t\t\twoption = new Option(" . $this->getSubNameArrayName() . $key . "[i], " . $this->getSubCodeArrayName() . $key . "[i]);\n";
			echo "\t\t\t\tmyForm.elements['" . $this->getSubFormSelectName() . "'].options[i] = woption;\n";
			echo "\t\t\t}\n";
			echo "\t\t\tmyForm.elements['" . $this->getSubFormSelectName() . "'].selectedIndex = 0;\n";
			echo "\t\t\tbreak;\n";
		}

		echo "\t}\n";

		// changeSelect()ν
		$this->printChangeSelectOption();

		echo "\treturn true;\n";
		echo "}\n";
	}

	// ᥤ󡿥Ǥƥåȥ롼ν
	function printMainElementSetRoutine()
	{
		echo "\tmyForm." . $this->getMainFormSelectName() . ".options.length = 0;\n";
		echo "\tfor (i = 0; i < " . $this->getMainNameArrayName() . ".length; i++)\n";
		echo "\t{\n";
		echo "\t\twoption = new Option(" . $this->getMainNameArrayName() . "[i], " . $this->getMainCodeArrayName() . "[i]);\n";
		echo "\t\tmyForm." . $this->getMainFormSelectName() . ".options[i] = woption;\n";
		echo "\t}\n\n";

		echo "\tmyForm." . $this->getMainFormSelectName() . ".selectedIndex = " . $this->getSelectedMainElementIndex() . ";\n\n";

		echo "\t" . $this->getChangeSelectFunctionName() . "(myForm);\n\n";

		echo "\tmyForm.elements['" . $this->getSubFormSelectName() . "'].selectedIndex = " . $this->getSelectedSubElementIndex() . ";\n";
	}


	// ᥤǤ<option>ν
	// JavaScript̵κݤɽ
	function printDefaultMainOption()
	{
		if ($this->isDisableJavaScriptShowMain() == "True")
		{
			if ($this->isMainIncludeAll() == "True")
			{
				 $mainOptionStr = "<option value=\"all\"></option>\n";
			}

			$tempMainElementArray = $this->getMainElementArray();

			foreach ($tempMainElementArray as $key => $value)
			{
				$mainOptionStr .= "<option value=\"" . htmlspecialchars($key) . "\">" . htmlspecialchars($value) . "</option>\n";
			}
		}
		else
		{
			//$mainOptionStr = "<option value=\"\"></option>\n";
		}

		echo $mainOptionStr;
	}


	// Ǥ<option>ν
	// JavaScript̵κݤɽ
	function printDefaultSubOption()
	{
		if ($this->isDisableJavaScriptShowMain() == "True")
		{
			//$subOptionStr = "<option value=\"\"></option>\n";
		}
		else
		{
			$tempSubElementArray = $this->getSubElementArray();

//			if ($this->isSubIncludeAll() == "True")
			if ($this->isMainAllSubIncludeAll() == "True")
			{
				$subOptionStr = "<option value=\"all\"></option>\n";
			}

			// ᥤǤƤλƤΥǤɽ
			if ($this->isSubAllOnly() == "False")
			{
				$tempSubElementArrayAll = $tempSubElementArray["all"];

				foreach ($tempSubElementArrayAll as $key => $value)
				{
					$subOptionStr .= "<option value=\"" . htmlspecialchars($key) . "\">" . htmlspecialchars($value) . "</option>\n";
				}
			}
		}

		echo $subOptionStr;
	}
}

?>
