<?php
//
// Copyright (C) 2001-2002 System Consultants Co.,Ltd. All Rights Reserved.
//
// $Id: scheduleinfo.php 1267 2005-05-23 01:20:24Z admin $
//

/**
 * 塼󥯥饹
 *
 * @author hiroki KAWAMURA <hiroki@syscon.co.jp>
 * @author yuji TAKAHASHI <yu-ji@syscon.co.jp>
 */



class ScheduleInfo
{
	// PHPLib Session
	var $classname = "ScheduleInfo";
	var $persistent_slots = array("startDate",
								"endDate",
								"startTime",
								"endTime",
								"plan",
								"place",
								"remark",
								"public",
								"outdoor",
								"schedule_cd");

	var	$startDate;			// 
	var $endDate;			// λ
	var $startTime;			// ϻ
	var $endTime;			// λ
	var	$plan;				// ͽ
	var $place;				// 
	var $remark;			// 
	var $public;			// 
	var $outdoor;			// ҳ
	var $schedule_cd;		// 塼륳
	var $schedule_date_cd;		// 塼ե


	// 󥹥ȥ饯
	function ScheduleInfo()
	{
	}

	// startDateμ
	function getStartDate()
	{
		return $this->startDate;
	}

	// startDate
	function setStartDate($startDate)
	{
		$this->startDate = $startDate;
	}

	// endDateμ
	function getEndDate()
	{
		return $this->endDate;
	}

	// endDate
	function setEndDate($endDate)
	{
		$this->endDate = $endDate;
	}

	// startTimeμ
	function getStartTime()
	{
		return $this->startTime;
	}

	// startTime
	function setStartTime($startTime)
	{
		if ($startTime != "")
		{
			$this->startTime = ereg_replace(":00$", "", $startTime);
		}
		else
		{
			$this->startTime = "";
		}
	}

	// endTimeμ
	function getEndTime()
	{
		return $this->endTime;
	}

	// endTime
	function setEndTime($endTime)
	{
		if ($endTime != "")
		{
			$this->endTime = ereg_replace(":00$", "", $endTime);
		}
		else
		{
			$this->endTime = "";
		}
	}

	// planμ
	function getPlan()
	{
		return $this->plan;
	}

	// plan
	function setPlan($plan)
	{
		$this->plan = $plan;
	}

	// placeμ
	function getPlace()
	{
		return $this->place;
	}

	// place
	function setPlace($place)
	{
		$this->place = $place;
	}

	// remarkμ
	function getRemark()
	{
		return $this->remark;
	}

	// remark
	function setRemark($remark)
	{
		$this->remark = $remark;
	}

	// publicμ
	function isPublic()
	{
		return $this->public;
	}

	// public
	function setPublic($public)
	{
		$this->public = $public;
	}

	// outdoorμ
	function isOutdoor()
	{
		return $this->outdoor;
	}

	// outdoor
	function setOutdoor($outdoor)
	{
		$this->outdoor = $outdoor;
	}

	// schedule_cdμ
	function getSchedule_cd()
	{
		return $this->schedule_cd;
	}

	// schedule_cd
	function setSchedule_cd($schedule_cd)
	{
		$this->schedule_cd = $schedule_cd;
	}

	// schedule_date_cdμ
	function getSchedule_date_cd()
	{
		return $this->schedule_date_cd;
	}

	// schedule_date_cd
	function setSchedule_date_cd($schedule_date_cd)
	{
		$this->schedule_date_cd = $schedule_date_cd;
	}
}

?>
