<?php
//
// Copyright (C) 2001-2002 System Consultants Co.,Ltd. All Rights Reserved.
//
// $Id: dbChange.php 965 2002-06-25 11:53:28Z hiboki $
//

/**
 * DB
 *
 * @author hiroki KAWAMURA <hiroki@syscon.co.jp>
 * @author yuji TAKAHASHI <yu-ji@syscon.co.jp>
 */



switch ($db_type)
{
	case "PostgreSQL":
		include($_ROOT_DIR_ . "/class/DBSqlPgsql.php");
		include($_ROOT_DIR_ . "/class/DBExecPgsql.php");
		include($_ROOT_DIR_ . "/class/DBConnectPgsql.php");

		$dbConnectObj = new DBConnectPgsql($host, $db_port, $db_user, $db_password, $masterdb);
		$dbExecObj = new DBExecPgsql();
		$dbSqlObj = new DBSqlPgsql();
		break;

	case "MySQL":
		include($_ROOT_DIR_ . "/class/DBSqlMysql.php");
		include($_ROOT_DIR_ . "/class/DBExecMysql.php");
		include($_ROOT_DIR_ . "/class/DBConnectMysql.php");

		$dbConnectObj = new DBConnectMysql($host, $db_port, $db_user, $db_password, $masterdb);
		$dbExecObj = new DBExecMysql();
		$dbSqlObj = new DBSqlMysql();
		break;

	default:
		echo "饹ǤޤǤ";
		exit;
		break;
}
?>